/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"


#ifndef ARM_ACTIONS_H
#define ARM_ACTIONS_H
/* Includes {{{ */
#include "../../kernel/diablo_action.h"
#include "arm_actions.h"
#include "arm_assemble.h"
#include "arm_constant_propagation.h"
#include "arm_deflowgraph.h"
#include "arm_disassemble.h"
#include "arm_emulation.h"
#include "arm_factor.h"
#include "arm_flowgraph.h"
#include "arm_copy_propagation.h"
#include "arm_map.h"
#include "arm_print.h"
#include "arm_registers.h"
#include "arm_write.h"
#include "arm_datamap.h"
#include "arm_factor.h"
#include "arm_stack.h"
#include "arm_instructions.h"
/* }}} */

/*! \todo Document + add missing comments */
const t_action_struct arm_actions={
/*  0 */   NULL,                            /* Group Info */
/*  1 */   ArmReadMap,                      /* Read Map */
/*  2 */   NULL,                            /* Disassemble */
/*  3 */   ArmDisassembleSection,           /* Disassemble Section */
/*  4 */   NULL,                            /* Flowgraph */
/*  5 */   ArmFlowgraphSection,             /* Flowgraph Section */
/*  6 */   ArmMakeAddressProducers,	    /* Make address producers */
/*  7 */   NULL,                            /* Deflowgraph */
/*  8 */   ArmDeflowgraphSection,           /* Deflowgraph Section */
/*  9 */   NULL,                            /* Assemble */ 
/* 10 */   ArmAssembleSection,              /* Assemble Section */
/* 11 */   ArmWrite,                        /* Write Object */
  /* Instruction related arm callbacks*/
/* 12 */   ArmInstructionPrint,             /* Print Instruction */
/* 13 */   ArmInstructionMakeNoop,          /* Make a noop from the instruction */

   
/* 14 */   ArmRegisterName,                 /* return the register name (from a static array of registers )*/
/* 15 */   ArmInstructionEmulator,          /* Instruction Emulation */
/* 16 */   ArmEdgePropagator,               /* */
/* 17 */   ArmInstructionUnconditionalizer, /* */
/* 18 */   ArmInstructionsConstantOptimizer,/* */
/* 19 */   NULL,                            /* */
/* 20 */   ArmConvertToBlocksSec,           /* */
/* 21 */   ArmCompareInstructions,          /* */
/* 22 */   ArmInsIsCopy,		    /* */
/* 23 */   ArmInsHasSideEffect,             /* */
  /* Basic Block factorisation related arm callbacks*/
/* 24 */   ArmBblCmpExtReg,		    /* Searches for copy instructions needed before a bbl*/  
/* 25 */   ArmBblAbstract,		    /* Abstract a bbl with two given sets of copy-operations (before and after the bbl)*/
/* 26 */   ArmFunComputeStackSavedRegisters,/* Compute the stack saved registers for a function */ 
/* 27 */   ArmCopyInstructionPropagator,    /* Propagate copy analysis information */
/* 28 */   ArmIsSyscallExit,		    /* Returns true when instruction is program exit */
/* 29 */   ArmIsControlflow,
/* 30 */   ArmIsIndirectCall,               /* InsIsIndirectCall */
/* 31 */   ArmFunIsGlobal,             /* FunIsGlobal */
/* 32 */   ArmInsCleanup,
/* 33 */   ArmInsDupDynamic
};
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
