/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/



#include "../../config.h"
#ifndef ARM_CONSTANT_PROPAGATION_H
#define ARM_CONSTANT_PROPAGATION_H
#include "../../kernel/diablo_flowgraph.h"
#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h"
void ArmEdgePropagator(t_cfg_edge * edge, t_ins * ins);
t_bool ArmInstructionUnconditionalizer(t_ins * ins);
t_bool ArmInstructionsConstantOptimizer(t_ins * ins, t_procstate * procstate1, t_procstate * procstate2);
unsigned int ArmInsDefinedRegCount(t_ins * ins);
void RenameLocalAddressProducers(t_bbl * bbl);
void MakeConstProducers(t_cfg * cfg);
#ifdef DIETER
void ArmAddressAnalyser(t_ins * ins, t_procstate * procstate1, t_procstate * procstate2);
void ArmOptimizeLayoutForAddresses(t_object * obj);
#endif
#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
