/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"

#ifndef ARM_CONSTANTOPTIMIZATIONS_H
#define ARM_CONSTANTOPTIMIZATIONS_H
/* Includes {{{ */
#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h"
#include "../../simple_types.h"
/* }}} */
t_bool ArmInsOptKillSBit(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptKillIdempotent(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptMakeIndirectJumpsDirect(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptSwitchOptimizer(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptEncodeConstantResult(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptProduceConstantFromOtherRegister(t_ins * ins, t_procstate * before, t_procstate * after,int teller);
t_bool ArmInsOptEncodeConstantOperands(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmInsOptEncodeConstantResultInTwoInstructions(t_ins * ins, t_procstate * before, t_procstate * after);
t_bool ArmOptMoveNullIntoPC(t_ins * ins);
t_bool ArmInsOptChangeLoadBaseRegister(t_ins * ins, t_procstate * before, t_procstate * after);
#ifdef DIETER
t_bool ArmOptMemoryAccess(t_ins * ins, t_procstate * before, t_procstate * after);
#endif
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
