/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"

#ifndef ARM_EMULATION_H
#define ARM_EMULATION_H
/* Includes {{{ */
#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h" 
/* }}} */
/*! \todo Should be in arm instruction! */
#define ARM_SHIFT_AMOUNT(reg) (reg & 0xFF)
/*! \todo Should be in arm instruction! */
#define ARM_ROTATE_AMOUNT(reg) (reg & 0x1F) /* rotate uses only last five bits */
void ArmInstructionEmulator(t_ins *, t_procstate *);
t_bool ConditionsAreEqualAndKnown(t_procstate * state_a, t_procstate * state_b);
t_bool RegIsEqualAndKnown(t_reg reg, t_procstate * state_a, t_procstate * state_b);
t_lattice_level ArmInsExtractShift(t_ins * ins, t_procstate * state, register_content * shifted_value);
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
