/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"

#ifndef ARM_LAYOUT_H
#define ARM_LAYOUT_H
t_uint32 ArmCfgLayout(t_cfg * cfg,t_uint32 mode);
#endif

typedef struct _t_inslist
{
  t_ins * ins;
  struct _t_inslist * next;
} t_inslist;

typedef struct _t_data_pool_entry
{
  t_uint32 nr_ins;
/*  t_reloc_ref * rel;*/
/*  t_uint32  data;*/
  t_inslist * inslist;
  struct _t_data_pool_entry * next;
} t_data_pool_entry;

typedef struct _t_data_pool
{
  t_bbl * bbl;
  t_data_pool_entry * list;
  t_data_pool_entry * end;
  t_int32 nr_entries;
} t_data_pool;

#define POOLENTRY_FIRSTINS(pool_entry)	(pool_entry->inslist->ins)

/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
