/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"
#include "arm_instructions.h"

#ifndef ARM_LS_FWD_TYPEDEFS
#define ARM_LS_FWD_TYPEDEFS
/*! \todo Document */
typedef struct _t_partial_value t_partial_value;
#endif

#ifndef ARM_LS_FWD_H
#define ARM_LS_FWD_H
/* Includes {{{ */
#include "../../kernel/diablo_flowgraph.h"
#include "../../kernel/diablo_regset.h"
/* }}} */

void ArmLoadStoreFwd(t_cfg* cfg);
t_lattice_level ArmPartialEvaluation(t_arm_ins * ins, register_content * offset, t_reg reg);

/*! \todo Document */
struct _t_partial_value
{
  t_regset registers;
  t_int32 offset[MAX_REG_ITERATOR];
  t_bool  changed[MAX_REG_ITERATOR];
  t_uint32 value[MAX_REG_ITERATOR];
  t_lattice_level level[MAX_REG_ITERATOR];
  t_reg   corresponding[MAX_REG_ITERATOR];
};

#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
