/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/
/* Includes {{{ */
#include "arm_registers.h"
#include "../../utils/util_error.h"
/* }}} */
/*! \todo this definition also in arm description .... */
/* regnames {{{ */
static char * regnames[] = {
  "r0", /* 0 */
  "r1", /* 1 */
  "r2", /* 2 */
  "r3", /* 3 */
  "r4", /* 4 */
  "r5", /* 5 */
  "r6", /* 6 */
  "r7", /* 7 */
  "r8", /* 8 */
  "r9", /* 9 */
  "r10", /* 10 */
  "r11", /* 11 */
  "r12", /* 12 */
  "r13", /* 13 */
  "r14", /* 14 */
  "r15", /* 15 */
  "cpsr", /* 16 */
  "spsr", /* 17 */
  "cQ", /* 18 */
  "cC", /* 19 */
  "cV", /* 20 */
  "cZ", /* 21 */
  "cN" /* 22 */
};
/* }}} */
/*!
 * \todo Document? Maybe remove it?
 *
 * \param reg
 *
 * \return t_string 
*/
/* ArmRegisterName {{{ */
t_string ArmRegisterName(t_reg reg) 
{
  return regnames[reg];
}
/* }}} */
/* vim: set shiftwidth=2 foldmethod=marker : */
