/***********************************************************
 * Copyright 2001,2002,2003: {{{
 * 
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * Diablo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Diablo; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * }}}
 **********************************************************/

#ifndef I386_ATOM_H
#define I386_ATOM_H

#include "../../kernel/diablo_bbl.h"
#include "../../kernel/diablo_regset.h"
#include "../../atom.h"
#include "../../atom_internal.h"
void I386AtomInit(t_object * obj);
t_regset I386AtomEstimateChangedRegisters(t_atom_instrument_marker * m);
t_uint32 I386AtomAddSave(t_bbl * in, t_regset liveregs, t_regset changedregs);
void I386AtomAddRestore(t_bbl * out,t_regset liveregs,t_regset changedregs,t_uint32 stack_change) ;
void I386AtomAddParams(t_bbl * in, t_ins * ins, t_bbl * orig, t_atom_instrument_marker * marker,t_uint32 stack_change, t_address pc);
void I386AtomAddKillParams(t_bbl * out, t_atom_instrument_marker * marker);
void I386AtomAddCheckForExitCall(t_bbl * check, t_bbl * call, t_bbl * restore);
void I386AtomAddCall(t_bbl * in, t_bbl * out, t_atom_proto * proto);
t_bool I386IsInstType(Inst * ins, t_atom_inst_type type);
#endif

/* vim: set shiftwidth=2 foldmethod=marker:*/
