/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Maintainer: Bjorn De Sutter (brdsutte@elis.rug.ac.be)
 *
 */
#ifndef I386_CONSTANTOPTIMIZATIONS_H
#define I386_CONSTANTOPTIMIZATIONS_H

#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h"
#include "../../kernel/diablo_liveness.h"
#include "i386_registers.h"
#include "i386_instructions.h"

t_reg I386InversRegisterNumber(t_reg reg);
void I386PrintInsInfo(t_i386_ins * ins);
t_bool I386IsFP(t_ins * ins);
t_bool I386RegIsEqualAndKnown(t_reg reg,t_procstate * prev_state,t_procstate * next_state);
t_bool I386CondIsEqualAndKnown(t_reg reg,t_procstate * prev_state,t_procstate * next_state);

t_bool I386UnconditionalizeJumps(t_ins * ins,t_procstate * prev_state);
t_bool I386KillIdempotentIns(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);
t_bool I386KillUselessIns(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);
t_bool I386MakeIndirectJumpsDirect(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);
t_bool I386EncodeConstantOperand(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);
t_bool I386StrengthReduction(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);
t_bool I386ProduceConstantFromRegister(t_ins * ins,t_procstate * prev_state,t_procstate * next_state);

#endif
