/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../config.h"
#ifndef I386_EMULATION_H
#define I386_EMULATION_H
#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h"

#define I386_LOW_8(value)     (value & 0x000000FF)
#define I386_HIGH_8(value)    (value & 0x0000FF00)
#define I386_FULL_16(value)   (value & 0x0000FFFF)

#define I386_BITS_24(value)   (value & 0xFFFFFF00)
#define I386_BITS_16_8(value) (value & 0xFFFF00FF)
#define I386_BITS_16(value)   (value & 0xFFFF0000) 

void I386InstructionEmulator(t_ins *, t_procstate *);
#endif
/* vim: set shiftwidth=2: */
