/* A Bison parser, made from i386_a2i.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	ID	257
# define	STRING	258
# define	SEGMENT	259
# define	REG	260
# define	ONEBYTE	261
# define	STR	262
# define	JMP	263
# define	SET	264
# define	ARITH	265
# define	LEA	266
# define	INC	267
# define	CLTD	268
# define	PUSH	269
# define	IMUL	270
# define	IDIV	271
# define	TRANSLAT	272
# define	NEG	273
# define	DIV	274
# define	LSEG	275
# define	LGDT	276
# define	MOV_SD	277
# define	_FILE	278
# define	ASCII	279
# define	GLOBAL	280
# define	_LONG	281
# define	_WORD	282
# define	_BYTE	283
# define	IDENT	284
# define	ALIGN	285
# define	P2ALIGN	286
# define	COMM	287
# define	LCOMM	288
# define	SPACE	289
# define	CALL	290
# define	INT	291
# define	_VERSION	292
# define	SECTION	293
# define	UNSUPPORTED	294
# define	UNSUP_2	295
# define	LOCAL	296
# define	ST	297
# define	MATH	298
# define	NUMBER	299

#line 1 "i386_a2i.y"

/*
 * A2I
 * Copyright (c) 1998 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

* 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)

* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/* 
 * Please contact me if you find bugs or if you want to improve A2I.
 * Lacroix Pascal <placr@hotmail.com>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../../../utils/util_error.h"
#include "i386_a2i.h"

#define VERSION "0.4"

/* forward declarations */

void warning(char *);
void fatal();

void yyerror(char *);

void mov_sd(const char*, const char*, const char*);

/* command line switches */
int no_info = 0/*, opt = 0*/;
long baseaddr = 0;

char * string_pointer;
char output_string[250];

/* buffer used for strings and IDs */
char strbuf[512];
long strbuflen;

/* symbol structure for externals */
struct symbol {
  char *name;
  char isextern;
  char islocal;  
  struct symbol *next;
};

#define HASH_BITS 32
#define HASH_SIZE 509

static struct symbol *hashtab[HASH_SIZE];

static unsigned int hash(char *name) {
	unsigned int hash = 0;

while (*name) {
		hash = hash << 3 | hash >>( HASH_BITS - 3);
		hash += *name++;
	}

return hash % HASH_SIZE;
}

struct symbol *addexternal(char *);
void killexternal(char *s);
struct symbol *sym_lookup(char *);

void *xmalloc(int size)
{
  void *p = (void *) malloc(size);
  if (!p) {
    printf("error: not enough memory\n");
    exit(0);
  }
  return p;
}


#line 105 "i386_a2i.y"
#ifndef YYSTYPE
typedef union {
  char *str;
  long type;
  long num;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#line 124 "i386_a2i.y"


#define tDWORD 1
#define tWORD 2
#define tBYTE 3

/* return the correct instruction without 'l', 'w' or 'b' at the end */
static char *op(const char *s) {
  static char tmp[50];
  strcpy(tmp, s);
  tmp[strlen(tmp)-1] = 0;
  return strdup(tmp);
}

/* get instruction size: dword, word or byte */
static char *op_size(const char *s) {
	int c;
	if (strlen(s)>1) c = s[strlen(s)-1];
	else c = 0;

if (c == 'l')  return "dword";
	else
	if (c == 'w') return "word";
	else
	if (c == 'b') return "byte";
	else
	{ fprintf(stderr, "Internal error: op_size=%c (in %s line %d)\n", c, __FILE__, __LINE__);
	  yyerror("unknown instruction");
	  return "[error]";
	}
}

/* convert a number to a string but always with a sign (+ or -) */
static char *signed_num(const long x) {
	static char s[16];
	sprintf(s, "%s%ld", (x>=0 ? "+" : ""), x);
	return strdup(s);
}

/* useful for jumps */
static char *is_near(const char *s) {
	if (strcmp(s, "jmp") == 0) return ""; else return " near";
}


static char *translate_instr(char *instr) {
    char s[20];
    strcpy(s, instr);
    if (s[strlen(s)-1] == 'l') {
	s[strlen(s)-1] = 'd';
    }
    else {
	char buf[100];
	sprintf(buf, "translating %s to %s", instr, s);
	warning(buf);
    }

return strdup(s);
}

static char *translate_math(char *instr) {
    char s[30], c;
    strcpy(s, instr);
    c = s[strlen(s)-1];
    if (c=='s') {
	s[strlen(s)-1] = 0;
	strcat(s, " dword");
	return strdup(s);
    }
    else
    if (c=='l') {
	s[strlen(s)-1] = 0;
	strcat(s, " qword");
	return strdup(s);
    }
    else
    if (c=='p') {
	return strdup(s);
    }
    else warning("unknown math instruction");

return instr;
}

struct tok {
	char *name;
	long token;
};

struct tok tokens[] = {
    {".file", _FILE},
    {".text", SEGMENT},
    {".data", SEGMENT},
    {".bss", SEGMENT},
    {".section", SECTION},
    {".ascii", ASCII},
    {".string", ASCII},
    {".globl", GLOBAL},
    {".version", _VERSION},
    {".local", LOCAL},

{".long", _LONG},
    {".word", _WORD},
    {".byte", _BYTE},

{".p2align", P2ALIGN},
    {".align", ALIGN},
    {".space", SPACE},
    {".zero", SPACE},

{"pushl", PUSH},
    {"pushw", PUSH},

{"popl", PUSH},
    {"popw", PUSH},

{"movl", ARITH},
    {"movw", ARITH},
    {"movb", ARITH},

{"xorl", ARITH},
    {"xorw", ARITH},
    {"xorb", ARITH},

{"call", CALL},

{"addl", ARITH},
    {"addw", ARITH},
    {"addb", ARITH},

{"subl", ARITH},
    {"subw", ARITH},
    {"subb", ARITH},

{"cmpl", ARITH},
    {"cmpw", ARITH},
    {"cmpb", ARITH},

{"leal", LEA},
    {"leaw", LEA},

{"incl", INC},
    {"incw", INC},
    {"incb", INC},

{"decl", INC},
    {"decw", INC},
    {"decb", INC},

{"ja", JMP},
    {"jae", JMP},
    {"jb", JMP},
    {"jbe", JMP},
    {"jc", JMP},
    {"jcxz", JMP},
    {"je", JMP},
    {"jg", JMP},
    {"jge", JMP},
    {"jl", JMP},
    {"jle", JMP},
    {"jmp", JMP},
    {"jna", JMP},
    {"jnae", JMP},
    {"jnb", JMP},
    {"jnbe", JMP},
    {"jnc", JMP},
    {"jne", JMP},
    {"jng", JMP},
    {"jnge", JMP},
    {"jnl", JMP},
    {"jnle", JMP},
    {"jno", JMP},
    {"jnp", JMP},
    {"jns", JMP},
    {"jnz", JMP},
    {"jo", JMP},
    {"jp", JMP},
    {"jpe", JMP},
    {"jpo", JMP},
    {"js", JMP},
    {"jz", JMP},
    {"jcxz", JMP},
    {"jecxz", JMP},
    {"loop", JMP},
    {"loopz", JMP},
    {"loope", JMP},
    {"loopnz", JMP},
    {"loopne", JMP},


{"sarl", ARITH},
    {"sarw", ARITH},

{"sall", ARITH},
    {"salw", ARITH},

{"movswl", MOV_SD},
    {"movslw", MOV_SD},
    {"movsbl", MOV_SD},
    {"movsbw", MOV_SD},

{"movzwl", MOV_SD},
    {"movzlw", MOV_SD},
    {"movzbl", MOV_SD},
    {"movzbw", MOV_SD},

{"testl", ARITH},
    {"testw", ARITH},
    {"testb", ARITH},

{"negl", NEG},
    {"negw", NEG},
    {"negb", NEG},

{"notl", NEG},
    {"notw", NEG},
    {"notb", NEG},

{"setne", SET},
    {"sete", SET},
    {"setg", SET},

{"andl", ARITH},
    {"andw", ARITH},
    {"andb", ARITH},

{".comm", COMM},
    {".lcomm", LCOMM},

{"shrl", ARITH},
    {"shrw", ARITH},
    {"shrb", ARITH},

{"shll", ARITH},
    {"shlw", ARITH},
    {"shlb", ARITH},

{"imull", IMUL},
    {"imulw", IMUL},

{"idivl", IDIV},
    {"idivw", IDIV},
    {"idivb", IDIV},

{"divl", DIV},
    {"divw", DIV},

{"orl", ARITH},
    {"orw", ARITH},
    {"orb", ARITH},

{"sbbl", ARITH},
    {"sbbw", ARITH},
    {"sbbb", ARITH},

{"eax", REG},
    {"ebx", REG},
    {"ecx", REG},
    {"edx", REG},
    {"esi", REG},
    {"edi", REG},
    {"ebp", REG},
    {"esp", REG},

{"cr0", REG},
    {"cr2", REG},
    {"cr3", REG},
    {"cr4", REG},

{"ax", REG},
    {"bx", REG},
    {"cx", REG},
    {"dx", REG},
    {"si", REG},
    {"di", REG},
    {"bp", REG},
    {"sp", REG},

{"ah", REG},
    {"al", REG},
    {"bh", REG},
    {"bl", REG},
    {"ch", REG},
    {"cl", REG},
    {"dh", REG},
    {"dl", REG},

{"cs", REG},
    {"ds", REG},
    {"es", REG},
    {"fs", REG},
    {"gs", REG},
    {"ss", REG},

{"cld", ONEBYTE},
    {"cmc", ONEBYTE},
    {"std", ONEBYTE},
    {"stc", ONEBYTE},
    {"ret", ONEBYTE},
    {"nop", ONEBYTE},

{"rep", ONEBYTE},
    {"repe", ONEBYTE},
    {"repne", ONEBYTE},
    {"repnz", ONEBYTE},
    {"repz", ONEBYTE},

{"cmpsb", ONEBYTE},
    {"leave", ONEBYTE},

{"movs", ONEBYTE},
    {"movsw", ONEBYTE},
    {"movsb", ONEBYTE},
    {"aaa", ONEBYTE},
    {"aad", ONEBYTE},

{"lods", ONEBYTE},
    {"lodsb", ONEBYTE},
    {"lodsw", ONEBYTE},
    {"lodsl", TRANSLAT},

{"movsl", TRANSLAT},
    {"pushal", TRANSLAT},
    {"popal", TRANSLAT},

{"outl", ARITH},
    {"outw", ARITH},
    {"outb", ARITH},
    {"inl", ARITH},
    {"inb", ARITH},
    {"inw", ARITH},

{"btrl", ARITH},
    {"btrw", ARITH},
    {"btrb", ARITH},

{"cmps", ONEBYTE},
    {"cmpsb", ONEBYTE},
    {"cmpsw", ONEBYTE},
    {"cmpsl", TRANSLAT},

{"scasb", ONEBYTE},
    {"scasw", ONEBYTE},
    {"scasl", TRANSLAT},

{"adcl", ARITH},
    {"adcw", ARITH},
    {"adcb", ARITH},

{"btl", ARITH},
    {"btw", ARITH},
    {"btb", ARITH},

{"cli", ONEBYTE},
    {"sti", ONEBYTE},
    {"daa", ONEBYTE},
    {"clc", ONEBYTE},
    {"das", ONEBYTE},

{"int", INT},

{"lds", LSEG},
    {"les", LSEG},
    {"lfs", LSEG},
    {"lgs", LSEG},
    {"lss", LSEG},

{"lgdt", LGDT},
    {"sgdt", LGDT},
    {"lidt", LGDT},
    {"sidt", LGDT},
    {".type", UNSUPPORTED},
    {".size", UNSUPPORTED},
    {".weak", UNSUPPORTED},
    {".set", UNSUPPORTED},
    {".4byte", UNSUPPORTED},
    {".ident", IDENT},

{"roll", ARITH},
    {"rolw", ARITH},
    {"rolb", ARITH},

{"mull", DIV},
    {"mulw", DIV},
    {"mulb", DIV},

{"st", ST},
    {"flds", MATH},
    {"fldl", MATH},
    {"fdivs", MATH},
    {"fdivl", MATH},
    {"fstps", MATH},
    {"fstpl", MATH},
    {"fadds", MATH},
    {"faddl", MATH},
    {"faddp", MATH},
    {"faddrp", MATH},
    {"fsubs", MATH},
    {"fsubl", MATH},
    {"fsubp", MATH},
    {"fsubrp", MATH},
    {"fmuls", MATH},
    {"fmull", MATH},
    {"fdivrp", MATH},
    {"fstp", MATH},
    {"filds", MATH},
    {"fildl", MATH},
{"bsfl", ARITH},
{"cltd", CLTD}
};

/* slower than in math.h but without math instructions */
long pow2(long to)
{
  long i, j;
  j = 1;
  for (i = 0; i < to; i++) j *= 2;
  return j;
}

/* used by the parser */
char tmpstr1[100], tmpstr2[100], tmpstr3[100], tmpstr4[100], tmpstr5[100],
	tmpstr6[100];

/* execute something if there is no `--no-info' switch */
#define D(x) { if (no_info == 0) (x); }

#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		144
#define	YYFLAG		-32768
#define	YYNTBASE	53

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 299 ? yytranslate[x] : 62)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    52,     2,     2,     2,
      50,    51,    47,    48,    46,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    49,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     7,    10,    13,    18,    23,    28,
      33,    38,    43,    48,    53,    56,    59,    62,    67,    72,
      75,    79,    82,    85,    89,    93,    96,   101,   106,   111,
     114,   117,   120,   123,   126,   131,   134,   137,   140,   143,
     148,   151,   153,   155,   157,   160,   163,   168,   170,   172,
     174,   176,   178,   180,   182,   186,   189,   191,   195,   199,
     205,   213,   218,   225,   234,   240,   248,   251,   254,   258,
     263,   265,   267,   269,   271,   274,   277,   279
};
static const short yyrhs[] =
{
      -1,    15,     6,     0,    15,    58,     0,    15,    56,     0,
      15,    55,     0,    11,     6,    46,     6,     0,    11,     6,
      46,    56,     0,    11,    56,    46,     6,     0,    11,     6,
      46,    55,     0,    11,    55,    46,     6,     0,    11,    58,
      46,     6,     0,    11,    58,    46,    56,     0,    11,    58,
      46,    55,     0,    13,     6,     0,    13,    56,     0,    13,
      55,     0,    12,    56,    46,     6,     0,    12,    55,    46,
       6,     0,    36,     3,     0,    36,    47,     6,     0,     9,
       3,     0,     9,    56,     0,     9,    47,     6,     0,     9,
      47,     3,     0,    16,     6,     0,    16,     6,    46,     6,
       0,    16,    56,    46,     6,     0,    16,    55,    46,     6,
       0,    17,    56,     0,    17,     6,     0,    17,    55,     0,
      20,    56,     0,    20,     6,     0,    23,    54,    46,    54,
       0,    19,     6,     0,    19,    56,     0,    10,     6,     0,
      37,    45,     0,    21,     3,    46,     6,     0,    22,     3,
       0,     7,     0,    14,     0,    18,     0,    44,    54,     0,
      44,    61,     0,    44,    61,    46,    61,     0,    40,     0,
       1,     0,     6,     0,    55,     0,    56,     0,    58,     0,
       3,     0,     3,    48,    45,     0,     3,    45,     0,    57,
       0,     6,    49,    57,     0,    50,     6,    51,     0,    50,
       6,    46,     6,    51,     0,    50,     6,    46,     6,    46,
      59,    51,     0,    60,    50,     6,    51,     0,    60,    50,
       6,    46,     6,    51,     0,    60,    50,     6,    46,     6,
      46,    59,    51,     0,    60,    50,    46,     6,    51,     0,
      60,    50,    46,     6,    46,    59,    51,     0,    52,    45,
       0,    52,     3,     0,    52,     3,    45,     0,    52,     3,
      48,    45,     0,     6,     0,    45,     0,    45,     0,     3,
       0,     3,    45,     0,    47,     3,     0,    43,     0,    43,
      50,    45,    51,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   557,   558,   559,   560,   561,   563,   564,   566,   569,
     570,   572,   573,   575,   578,   579,   580,   582,   584,   586,
     587,   589,   590,   591,   592,   594,   595,   596,   597,   599,
     600,   601,   603,   604,   606,   608,   609,   611,   613,   615,
     617,   619,   621,   623,   625,   626,   627,   630,   632,   635,
     636,   637,   638,   641,   642,   643,   647,   648,   651,   652,
     653,   655,   656,   658,   660,   662,   666,   667,   668,   670,
     673,   674,   677,   678,   679,   680,   683,   684
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "ID", "STRING", "SEGMENT", "REG", "ONEBYTE", 
  "STR", "JMP", "SET", "ARITH", "LEA", "INC", "CLTD", "PUSH", "IMUL", 
  "IDIV", "TRANSLAT", "NEG", "DIV", "LSEG", "LGDT", "MOV_SD", "_FILE", 
  "ASCII", "GLOBAL", "_LONG", "_WORD", "_BYTE", "IDENT", "ALIGN", 
  "P2ALIGN", "COMM", "LCOMM", "SPACE", "CALL", "INT", "_VERSION", 
  "SECTION", "UNSUPPORTED", "UNSUP_2", "LOCAL", "ST", "MATH", "NUMBER", 
  "','", "'*'", "'+'", "':'", "'('", "')'", "'$'", "line", "arg", 
  "memptr", "memref", "memref1", "varptr", "scale", "offset", "math_reg", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    53,    53,    53,    53,    53,    53,    53,    53,    54,
      54,    54,    54,    55,    55,    55,    56,    56,    57,    57,
      57,    57,    57,    57,    57,    57,    58,    58,    58,    58,
      59,    59,    60,    60,    60,    60,    61,    61
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     2,     2,     2,     4,     4,     4,     4,
       4,     4,     4,     4,     2,     2,     2,     4,     4,     2,
       3,     2,     2,     3,     3,     2,     4,     4,     4,     2,
       2,     2,     2,     2,     4,     2,     2,     2,     2,     4,
       2,     1,     1,     1,     2,     2,     4,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     1,     3,     3,     5,
       7,     4,     6,     8,     5,     7,     2,     2,     3,     4,
       1,     1,     1,     1,     2,     2,     1,     4
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    48,    41,     0,     0,     0,     0,     0,    42,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
      47,     0,    21,     0,    72,     0,     0,    22,    56,     0,
      37,    53,     0,     0,     0,     0,     0,     0,     0,     0,
      14,    16,    15,     2,     5,     4,     3,    25,     0,     0,
      30,    31,    29,    73,    35,    36,    33,    32,     0,    40,
      49,     0,    50,    51,    52,    19,     0,    38,    76,    44,
      45,    74,     0,    24,    23,     0,     0,    55,     0,     0,
      75,    67,    66,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,    57,     0,    58,     0,
       0,    54,     6,     9,     7,    68,     0,    10,     8,    11,
      13,    12,    18,    17,    26,    28,    27,    39,    34,     0,
      46,     0,     0,    61,     0,    69,    77,     0,    59,     0,
       0,    64,    70,    71,     0,     0,    62,     0,    60,     0,
      65,    63,     0,     0,     0
};

static const short yydefgoto[] =
{
     142,    61,    62,    63,    28,    64,   134,    29,    70
};

static const short yypact[] =
{
     156,-32768,-32768,    34,    22,    17,    44,    48,-32768,    28,
      52,    68,-32768,    97,    98,    26,    40,    38,     2,     0,
  -32768,    16,   -18,    11,-32768,    33,    46,-32768,-32768,    27,
  -32768,   -24,    60,    84,    12,    50,    59,    82,    83,    85,
      11,-32768,-32768,    11,-32768,-32768,-32768,    77,    86,    87,
      11,-32768,-32768,    89,    11,-32768,    11,-32768,    90,-32768,
      11,    91,-32768,-32768,-32768,-32768,   124,-32768,    88,-32768,
      93,-32768,    67,    96,-32768,   -16,    19,   103,    95,   104,
  -32768,     8,-32768,   129,   135,   105,   152,   153,   154,   155,
     158,   174,    38,-32768,   117,   138,-32768,   176,-32768,   -13,
     177,-32768,    11,-32768,-32768,-32768,   139,-32768,-32768,    11,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   134,
  -32768,    70,   180,-32768,    73,-32768,-32768,     3,-32768,    74,
       3,-32768,-32768,-32768,   136,     3,-32768,   137,-32768,   140,
  -32768,-32768,   189,   190,-32768
};

static const short yypgoto[] =
{
  -32768,   -20,     7,    -3,   122,    37,    -8,-32768,   100
};


#define	YYLAST		200


static const short yytable[] =
{
      27,    69,    36,    39,    42,    65,    45,    49,    52,   132,
      55,    57,    35,    38,    41,    81,    44,    48,    51,    31,
      31,    77,    60,    32,    78,    99,   -73,    71,    30,    58,
      97,    31,   -73,   122,    43,    98,    73,    22,   123,    74,
      23,    31,    37,    59,    60,    67,    46,    31,   133,    66,
      23,    31,    75,   105,    40,    31,   106,    82,    47,    68,
      72,    24,    24,    33,    33,   100,    26,    26,    34,    34,
      53,    31,   118,    24,    50,    33,   104,    76,    26,    24,
      34,    25,   111,    24,    26,    33,   103,    80,    26,    24,
      34,    33,   110,    24,    26,    33,    83,    24,    26,    33,
      53,    53,    26,    54,    56,    84,    79,    31,    31,    72,
     102,   109,    24,    24,    33,    33,   127,    26,    26,   130,
     135,   128,   137,    88,   131,   136,    72,   139,    85,    86,
      93,    87,    89,    90,    71,   107,    91,    92,    94,    95,
     101,   108,    24,    24,    33,    33,   -75,    26,    26,    24,
      24,    33,    33,   -74,    26,    26,    -1,     1,   112,   113,
     114,   115,   119,     2,   116,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
     117,    68,   121,   124,   125,   126,   129,   138,   140,   143,
     144,   141,    18,    19,    96,   120,    20,     0,     0,     0,
      21
};

static const short yycheck[] =
{
       3,    21,     5,     6,     7,     3,     9,    10,    11,     6,
      13,    14,     5,     6,     7,     3,     9,    10,    11,     3,
       3,    45,     6,     6,    48,     6,    50,    45,     6,     3,
      46,     3,    50,    46,     6,    51,     3,     3,    51,     6,
       6,     3,     5,     3,     6,    45,     9,     3,    45,    47,
       6,     3,     6,    45,     6,     3,    48,    45,     6,    43,
      49,    45,    45,    47,    47,    46,    50,    50,    52,    52,
       3,     3,    92,    45,     6,    47,    79,    50,    50,    45,
      52,    47,    85,    45,    50,    47,    79,     3,    50,    45,
      52,    47,    85,    45,    50,    47,    46,    45,    50,    47,
       3,     3,    50,     6,     6,    46,    46,     3,     3,    49,
       6,     6,    45,    45,    47,    47,    46,    50,    50,    46,
      46,    51,   130,    46,    51,    51,    49,   135,    46,    46,
       6,    46,    46,    46,    45,     6,    46,    46,    50,    46,
      45,     6,    45,    45,    47,    47,    50,    50,    50,    45,
      45,    47,    47,    50,    50,    50,     0,     1,     6,     6,
       6,     6,    45,     7,     6,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
       6,    43,     6,     6,    45,    51,     6,    51,    51,     0,
       0,    51,    36,    37,    72,    95,    40,    -1,    -1,    -1,
      44
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 2:
#line 558 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 3:
#line 559 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 4:
#line 560 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 5:
#line 561 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 6:
#line 563 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 7:
#line 565 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 8:
#line 567 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 9:
#line 569 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 10:
#line 570 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 11:
#line 572 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 12:
#line 574 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 13:
#line 576 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s, %s\n", op(yyvsp[-3].str), op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 14:
#line 578 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 15:
#line 579 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 16:
#line 580 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 17:
#line 583 "i386_a2i.y"
{ sprintf(output_string, "lea %s %s, %s\n", op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 18:
#line 584 "i386_a2i.y"
{ sprintf(output_string, "lea %s %s, %s\n", op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 19:
#line 586 "i386_a2i.y"
{ sprintf(output_string, "call %s\n", yyvsp[0].str); ;
    break;}
case 20:
#line 587 "i386_a2i.y"
{ sprintf(output_string, "call %s\n", yyvsp[0].str); ;
    break;}
case 21:
#line 589 "i386_a2i.y"
{ sprintf(output_string, "%s%s %s\n", yyvsp[-1].str, is_near(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 22:
#line 590 "i386_a2i.y"
{ sprintf(output_string, "%s%s %s\n", yyvsp[-1].str, is_near(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 23:
#line 591 "i386_a2i.y"
{ sprintf(output_string, "%s%s %s\n", yyvsp[-2].str, is_near(yyvsp[-2].str), yyvsp[0].str); ;
    break;}
case 24:
#line 592 "i386_a2i.y"
{ sprintf(output_string, "%s%s %s\n", yyvsp[-2].str, is_near(yyvsp[-2].str), yyvsp[0].str); ;
    break;}
case 25:
#line 594 "i386_a2i.y"
{ sprintf(output_string, "imul %s %s\n", op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 26:
#line 595 "i386_a2i.y"
{ sprintf(output_string, "imul %s %s, %s\n", op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 27:
#line 596 "i386_a2i.y"
{ sprintf(output_string, "imul %s %s, %s\n", op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 28:
#line 597 "i386_a2i.y"
{ sprintf(output_string, "imul %s %s, %s\n", op_size(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 29:
#line 599 "i386_a2i.y"
{ sprintf(output_string, "idiv %s %s\n", op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 30:
#line 600 "i386_a2i.y"
{ sprintf(output_string, "idiv %s %s\n", op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 31:
#line 601 "i386_a2i.y"
{ sprintf(output_string, "idiv %s %s\n", op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 32:
#line 603 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 33:
#line 604 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 34:
#line 606 "i386_a2i.y"
{ mov_sd(yyvsp[-3].str, yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 35:
#line 608 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 36:
#line 609 "i386_a2i.y"
{ sprintf(output_string, "%s %s %s\n", op(yyvsp[-1].str), op_size(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 37:
#line 611 "i386_a2i.y"
{ sprintf(output_string, "%s %s\n", yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 38:
#line 613 "i386_a2i.y"
{ sprintf(output_string, "int 0x%lx\n", yyvsp[0].num); ;
    break;}
case 39:
#line 615 "i386_a2i.y"
{ sprintf(output_string, "%s %s, %s\n", yyvsp[-3].str, yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 40:
#line 617 "i386_a2i.y"
{ sprintf(output_string, "%s [%s]\n", yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 41:
#line 619 "i386_a2i.y"
{ sprintf(output_string, "%s\n", yyvsp[0].str); ;
    break;}
case 42:
#line 621 "i386_a2i.y"
{ sprintf(output_string, "cdq\n"); ;
    break;}
case 43:
#line 623 "i386_a2i.y"
{ sprintf(output_string, "%s\n", translate_instr(yyvsp[0].str)); ;
    break;}
case 44:
#line 625 "i386_a2i.y"
{ sprintf(output_string, "%s %s\n", translate_math(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 45:
#line 626 "i386_a2i.y"
{ sprintf(output_string, "%s %s\n", translate_math(yyvsp[-1].str), yyvsp[0].str); ;
    break;}
case 46:
#line 628 "i386_a2i.y"
{ sprintf(output_string, "%s %s, %s\n", translate_math(yyvsp[-3].str), yyvsp[0].str, yyvsp[-2].str); ;
    break;}
case 47:
#line 630 "i386_a2i.y"
{ ; ;
    break;}
case 49:
#line 635 "i386_a2i.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 50:
#line 636 "i386_a2i.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 51:
#line 637 "i386_a2i.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 52:
#line 638 "i386_a2i.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 53:
#line 641 "i386_a2i.y"
{ sprintf(tmpstr1, "[%s+0x%lx]", yyvsp[0].str, baseaddr); yyval.str = tmpstr1; ;
    break;}
case 54:
#line 642 "i386_a2i.y"
{ sprintf(tmpstr1, "[%s+%ld+0x%lx]", yyvsp[-2].str, yyvsp[0].num, baseaddr); yyval.str = tmpstr1; ;
    break;}
case 55:
#line 643 "i386_a2i.y"
{ sprintf(tmpstr1, "[%s%ld+0x%lx]", yyvsp[-1].str, yyvsp[0].num, baseaddr); yyval.str = tmpstr1;
					if (yyvsp[0].num>0) yyerror("expression error"); ;
    break;}
case 56:
#line 647 "i386_a2i.y"
{ sprintf(tmpstr6, "[%s]", yyvsp[0].str); yyval.str = tmpstr6; ;
    break;}
case 57:
#line 648 "i386_a2i.y"
{ sprintf(tmpstr6, "[%s:%s]", yyvsp[-2].str, yyvsp[0].str); yyval.str = tmpstr6; ;
    break;}
case 58:
#line 651 "i386_a2i.y"
{ sprintf(tmpstr2, "%s", yyvsp[-1].str); yyval.str = tmpstr2;;
    break;}
case 59:
#line 652 "i386_a2i.y"
{ sprintf(tmpstr2, "%s + %s", yyvsp[-3].str, yyvsp[-1].str); yyval.str = tmpstr2; ;
    break;}
case 60:
#line 654 "i386_a2i.y"
{ sprintf(tmpstr2, "%s + %s*%s", yyvsp[-5].str, yyvsp[-3].str, yyvsp[-1].str); yyval.str = tmpstr2; ;
    break;}
case 61:
#line 655 "i386_a2i.y"
{ sprintf(tmpstr2, "%s%s", yyvsp[-1].str, yyvsp[-3].str); yyval.str = tmpstr2; ;
    break;}
case 62:
#line 657 "i386_a2i.y"
{ sprintf(tmpstr2, "%s + %s %s", yyvsp[-3].str, yyvsp[-1].str, yyvsp[-5].str); yyval.str = tmpstr2; ;
    break;}
case 63:
#line 659 "i386_a2i.y"
{ sprintf(tmpstr2, "%s + %s*%s %s", yyvsp[-5].str, yyvsp[-3].str, yyvsp[-1].str, yyvsp[-7].str); yyval.str = tmpstr2; ;
    break;}
case 64:
#line 661 "i386_a2i.y"
{ sprintf(tmpstr2, "%s %s", yyvsp[-1].str, yyvsp[-4].str); yyval.str = tmpstr2; ;
    break;}
case 65:
#line 663 "i386_a2i.y"
{ sprintf(tmpstr2, "%s*%s %s", yyvsp[-3].str, yyvsp[-1].str, yyvsp[-6].str); yyval.str = tmpstr2; ;
    break;}
case 66:
#line 666 "i386_a2i.y"
{ yyval.str = signed_num(yyvsp[0].num); ;
    break;}
case 67:
#line 667 "i386_a2i.y"
{ sprintf(tmpstr3, "%s+0x%lx", yyvsp[0].str, baseaddr); yyval.str = tmpstr3; ;
    break;}
case 68:
#line 668 "i386_a2i.y"
{ sprintf(tmpstr3, "%s%ld+0x%lx", yyvsp[-1].str, yyvsp[0].num, baseaddr); yyval.str = tmpstr3;
					if (yyvsp[0].num>0) yyerror("expression error"); ;
    break;}
case 69:
#line 670 "i386_a2i.y"
{ sprintf(tmpstr3, "%s+%ld+0x%lx", yyvsp[-2].str, yyvsp[0].num, baseaddr); yyval.str = tmpstr3; ;
    break;}
case 70:
#line 673 "i386_a2i.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 71:
#line 674 "i386_a2i.y"
{ yyval.str = signed_num(yyvsp[0].num); ;
    break;}
case 72:
#line 677 "i386_a2i.y"
{ yyval.str = signed_num(yyvsp[0].num); ;
    break;}
case 73:
#line 678 "i386_a2i.y"
{ strcpy(tmpstr4, "+ "); strcat(tmpstr4, yyvsp[0].str); yyval.str = tmpstr4;;
    break;}
case 74:
#line 679 "i386_a2i.y"
{ strcpy(tmpstr4, "+ "); strcat(tmpstr4, yyvsp[-1].str); strcat(tmpstr4, signed_num(yyvsp[0].num)); yyval.str = tmpstr4; ;
    break;}
case 75:
#line 680 "i386_a2i.y"
{ strcpy(tmpstr4, "+ "); strcat(tmpstr4, yyvsp[0].str); yyval.str = tmpstr4; ;
    break;}
case 76:
#line 683 "i386_a2i.y"
{ yyval.str = "st"; ;
    break;}
case 77:
#line 684 "i386_a2i.y"
{ sprintf(tmpstr4, "st%d", (int)yyvsp[-1].num); yyval.str = tmpstr4; ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 686 "i386_a2i.y"


/* output an error, exit if more than 15 errors */
void yyerror(char *s)
{
  FATAL(("error in translation from AT&T to intel syntax.\n Possible causes: don't use 0x... for constants and use imull eax,ebx instead of imul eax,ebx etc."));
}

/* output a warning */
void warning(char *s)
{
printf("in warning\n");
return;
}

/* function used for token sorting */
static int tok_cmp (const void *e1, const void *e2)
{
  return strcmp (((struct tok *)e1)->name, ((struct tok *)e2)->name);
}

/* THE lexer */
int yylex(void)
{
  static int was_percent = 0;
  int c, oldc, i;
  struct tok *token, t;

do {
	c = *string_pointer;
	string_pointer++;
  } while (c == ' ' || c == '\t');

switch (c) {
	case 'a' ... 'z':
	case 'A' ... 'Z':
	case '.':
	case '@':
	case '_':
	case '%':
		if (c != '%') { string_pointer--; was_percent = 0; } else was_percent = 1;

		sscanf(string_pointer, "%[a-zA-Z0-9_$.@]", strbuf);
		string_pointer+=strlen(strbuf);


t.name = strbuf;

/* bsearch is quicker */
		token = bsearch(&t, tokens, sizeof(tokens) / sizeof(tokens[0]),
			sizeof(tokens[0]), tok_cmp);

if (token) {
			yylval.str = strdup(token->name);
			if (token->token == UNSUPPORTED || token->token == UNSUP_2) {
				char tmp[100];
				if (token->token == UNSUPPORTED) {
					sprintf(tmp, "unsupported keyword `%s'", token->name);
					warning(tmp);
					warning("(only appears one time)");
					token->token = UNSUP_2;
				}
				/* eat line */
				while ((c = *string_pointer ) != EOF && c != '\n') string_pointer++;
				string_pointer--;
				return UNSUPPORTED;
			}
					/* not a real REG */
			if ((token->token == REG || token->token == ST) && (was_percent == 0) ) {
				yylval.str = strdup (strbuf);
				addexternal(strbuf);
				printf("%s\n", strbuf);
				return ID;
			}

return token->token;
		}
		if (strbuf[0] == '.') strbuf[0] = '$';
		yylval.str = strdup(strbuf);
		addexternal(strbuf);	/* add it to the symbol table */
		return ID;

case '0' ... '9':
		string_pointer--;
		sscanf(string_pointer, "%li", &yylval.num);
		sprintf(strbuf,"%li",yylval.num);
		string_pointer+=strlen(strbuf);
		return NUMBER;

case '-':
		string_pointer--;
		sscanf(string_pointer, "%ld", &yylval.num);
		sprintf(strbuf,"%ld",yylval.num);
		string_pointer+=strlen(strbuf);
		return NUMBER;

case '"':	/* a string */
	case '\'':
		oldc = c;
		i = 0;
		while (1) {
			c = *string_pointer;
			string_pointer++;
			if (c == oldc) {
				strbuflen = i;
				strbuf[i] = 0;
				yylval.str = strdup(strbuf);
				return STRING;
			}
			switch (c) {
				case '\\':
					c = * string_pointer;
					string_pointer++;
					switch (c) {
						case '0': strbuf[i++] = 0; break;
						case 'n': /*strbuf[i++] = '\n';*/ break;
						case 't': strbuf[i++] = '\t'; break;
						default:
							if (c >= '0' && c<= '9') {
								string_pointer--;

sscanf(string_pointer, "%i", &c);
								sprintf(strbuf,"%i",c);
								string_pointer+=strlen(strbuf);
								if (c == 12) c = 10;
								else
								if (c == 11) c = 9;

strbuf[i++] = c;
								break;
							}
							else strbuf[i++] = c;
					}
					break;
				default: strbuf[i++] = c; break;
			}
		}
		abort();
	case '/':
                printf("UNCOMMENT\n");
/*		c = ';';
		while (c != '\n') {
			if (no_info == 0) putc(c, outfile);
			c = *string_pointer;
			string_pointer++;
			//c = getc(infile);
		}
		c = '\n';
		if (no_info == 0) putc(c, outfile);
		return '\n';*/
	case ';':
	case '#':
		while ((c = *string_pointer )!= '\n') string_pointer++;
		c = '\n';

default:
       return c;
  }
}


void mov_sd(const char *mov, const char *arg1, const char *arg2)
{
printf("UNCOMME\n");
/*	int src, dst;
	char *s, *d;
	src = mov[4]; dst = mov[5];
	if (src == 'l') s = "dword";
	else
	if (src == 'w') s = "word";
	else
	if (src == 'b') s = "byte";
	else
	{ yyerror("mov?? unknown"); s = "[error]"; }

if (dst == 'l') d = "dword";
	else
	if (dst == 'w') d = "word";
	else
	if (dst == 'b') d = "byte";
	else
	{ yyerror("mov?? unknown"); d = "[error]"; }

if (strncmp(mov, "movs", 4) == 0)
		fprintf(outfile, "\tmovsx %s %s, %s %s\n",
			d, arg1, s, arg2);
	else
	if (strncmp(mov, "movz", 4) == 0)
		fprintf(outfile, "\tmovzx %s %s, %s %s\n",
			d, arg1, s, arg2);
	else yyerror("mov?? unknown");*/
}

/* look for a symbol */
struct symbol *sym_lookup(char *name) {
	int i;
	struct symbol *s;

i = hash(name);
	for (s = hashtab[i]; s; s = s->next) {
		if (!strcmp(s->name, name))
			return s;
	}
	return (struct symbol *)NULL;
}

/* add a symbol to the table */

struct symbol* addexternal(char *name)
{
	int i;
	struct symbol* s = sym_lookup(name);
	if (s == NULL) {	/* not found, add it */
		i = hash(name);
		s = (struct symbol *) xmalloc(sizeof (struct symbol));
		s->name = (char *) xmalloc(strlen(name) + 1);
		strcpy(s->name, name);
		s->isextern = 1;
		s->islocal = 0; 
		s->next = hashtab[i];
		hashtab[i] = s;
		return s;
	}
	return s;
}

int initialized = 0;
char * i386_a2i(char * input){
  if(!initialized){
    qsort(tokens, sizeof(tokens) / sizeof(tokens[0]), sizeof(tokens[0]), tok_cmp);
    initialized=1;
  }

  string_pointer = input;
  yyparse();
  return output_string;
}

/*
int main(int argc, char **argv)
{
	qsort(tokens, sizeof(tokens) / sizeof(tokens[0]), sizeof(tokens[0]), tok_cmp);

        printf("tada: %s",a2i("imull   %ebx, %eax"));
	string_pointer = "imull   %ebx, %eax";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "leal    0(,%eax,8), %edx";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "subl    %eax, %edx";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "movl    %ecx, %eax";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "decl    %edx";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "imull   %ecx, %eax";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "cmpl    %eax, %edx";
	yyparse();
	printf("resultaat: %s",output_string);
	string_pointer = "je      .L5";
	yyparse();
	printf("resultaat: %s",output_string);
	return 0;
}*/
