/* The Netwide Assembler main program module
 *
 * The Netwide Assembler is copyright (C) 1996 Simon Tatham and
 * Julian Hall. All rights reserved. The software is
 * redistributable under the licence given in the file "Licence"
 * distributed in the NASM archive.
 */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "i386_nasm.h"
#include "i386_nasmlib.h"
#include "i386_insns.h"
#include "i386_parser.h"
#include "i386_eval.h"
#include "i386_nassemble.h"
#include "i386_a2i.h"
#include "../../../utils/util_error.h"


static void report_error(int severity, const char *fmt, ...)
{
  if(severity != ERR_NONFATAL)
    FATAL(("error in nasm-like assembler"));
}

int i386_assembleFromString(char * string, char * result)
{  
  insn ins;
    
  parse_line(2, string, &ins, report_error, evaluate, NULL);

  return assemble(&ins,report_error, result);
}
/*
int main(int argc, char **argv)
{
    int length;
    int counter = 0;
    
    char result[15];

    length = i386_assembleFromString(i386_a2i("imull %eax,%ebx"),result);
      
    while(counter < length){
      printf(" %x",result[counter++]);
    }
    printf("\n");
    
    return 0;
}
*/


/* end of nasm.c */
