/******************************************************************************
 * Copyright 2001,2002,2003: {{{ 
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bjorn De Sutter (brdsutte@elis.rug.ac.be) }}}
 *****************************************************************************/

/* Includes {{{ */
#include <stdlib.h>
#include "../../utils/util_status.h"
#include "../../kernel/diablo_iterators.h"
/* }}} */
#ifndef I386_OBFUSCATION_H
#define I386_OBFUSCATION_H

void GetArchs(t_bbl * bbl,t_section *sec);
void PostArchs(t_bbl * bbl,t_section *sec);
void PreArchs(t_bbl * bbl,t_section *sec);
t_uint32 FindFreeReg(t_regset dead);
t_bool RegisterCanBeUsed(t_uint32 reg);
t_bbl * IndirectJumpBbl(t_cfg * cfg,t_section * added, t_uint32 free_reg,t_cfg_edge * jump_edge);
#endif

/* vim: set shiftwidth=2 foldmethod=marker: */
