/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef I386_OPCODE_TYPEDEFS
#define I386_OPCODE_TYPEDEFS
typedef struct _t_i386_opcode_info t_i386_opcode_info;
typedef enum _t_i386_opcode t_i386_opcode;

enum _t_i386_opcode {
  LAST_OPC	  = -23,
  GRP1a           = -22,
  GRP1b           = -21,
  GRP1c           = -20,
  GRP1d           = -19,
  GRP2a           = -18,
  GRP2b           = -17,
  GRP3a           = -16,
  GRP3b           = -15,
  GRP4a           = -14,
  GRP4b           = -13,
  GRP4c           = -12,
  GRP4d           = -11,
  GRP5a           = -10,
  GRP5b           = -9,
  GRP6a           = -8,
  GRP6b           = -7,
  GRP7a           = -6,
  GRP7b           = -5,
  GRP8a           = -4,
  GRP15a          = -3,
  FPU_ESC         = -2,
  TWOBYTE_ESC     = -1,
  INVALID_OPC     =  0,
  UNSUPPORTED_OPC =  1,
  I386_DATA, 
  I386_AAA,
  I386_AAD,
  I386_AAM,
  I386_AAS,
  I386_ADC,
  I386_ADD,
  I386_AND,
  I386_ARPL,
  I386_BOUND,
  I386_BSF,
  I386_BSR,
  I386_BSWAP,
  I386_BT,
  I386_BTC,
  I386_BTR,
  I386_BTS,
  I386_CALL,
  I386_CALLF,
  I386_CDQ,
  I386_CLC,
  I386_CLD,
  I386_CLI,
  I386_CLTS,
  I386_CMC,
  I386_CMOVcc,
  I386_CMP,
  I386_CMPSB,
  I386_CMPSD,
  I386_CMPXCHG,
  I386_CPUID,
  I386_CWDE,
  I386_DAA,
  I386_DAS,
  I386_DEC,
  I386_DIV,
  I386_ENTER,
  I386_F2XM1,
  I386_FABS,
  I386_FADD,
  I386_FADDP,
  I386_FBLD,
  I386_FBSTP,
  I386_FCHS,
  I386_FCLEX,
  I386_FCMOVcc,
  I386_FCOM,
  I386_FCOMI,
  I386_FCOMIP,
  I386_FCOMP,
  I386_FCOMPP,
  I386_FCOS,
  I386_FDECSTP,
  I386_FDIV,
  I386_FDIVP,
  I386_FDIVR,
  I386_FDIVRP,
  I386_FFREE,
  I386_FIADD,
  I386_FICOM,
  I386_FICOMP,
  I386_FIDIV,
  I386_FIDIVR,
  I386_FILD,
  I386_FIMUL,
  I386_FINCSTP,
  I386_FINIT,
  I386_FIST,
  I386_FISTP,
  I386_FISUB,
  I386_FISUBR,
  I386_FLD,
  I386_FLD1,
  I386_FLDCW,
  I386_FLDENV,
  I386_FLDL2E,
  I386_FLDL2T,
  I386_FLDLG2,
  I386_FLDLN2,
  I386_FLDPI,
  I386_FLDZ,
  I386_FMUL,
  I386_FMULP,
  I386_FNOP,
  I386_FPATAN,
  I386_FPREM,
  I386_FPREM1,
  I386_FPTAN,
  I386_FRNDINT,
  I386_FRSTOR,
  I386_FSAVE,
  I386_FSCALE,
  I386_FSIN,
  I386_FSINCOS,
  I386_FSQRT,
  I386_FST,
  I386_FSTCW,
  I386_FSTENV,
  I386_FSTP,
  I386_FSTSW,
  I386_FSUB,
  I386_FSUBP,
  I386_FSUBR,
  I386_FSUBRP,
  I386_FTST,
  I386_FUCOM,
  I386_FUCOMI,
  I386_FUCOMIP,
  I386_FUCOMP,
  I386_FUCOMPP,
  I386_FXAM,
  I386_FXCH,
  I386_FXRSTOR,
  I386_FXSAVE,
  I386_FXTRACT,
  I386_FYL2X,
  I386_FYL2XP1,
  I386_HLT,
  I386_IDIV,
  I386_IMUL,
  I386_IMULexp1,
  I386_IMULexp2,
  I386_IN,
  I386_INC,
  I386_INSB,
  I386_INSD,
  I386_INT,
  I386_INT3,
  I386_INTO,
  I386_INVD,
  I386_INVLPG,
  I386_IRET,
  I386_JECXZ,
  I386_JMP,
  I386_JMPF,
  I386_Jcc,
  I386_LAHF,
  I386_LAR,
  I386_LDS,
  I386_LEA,
  I386_LEAVE,
  I386_LES,
  I386_LFS,
  I386_LGDT,
  I386_LGS,
  I386_LIDT,
  I386_LLDT,
  I386_LMSW,
  I386_LODSB,
  I386_LODSD,
  I386_LOOP,
  I386_LOOPNZ,
  I386_LOOPZ,
  I386_LSL,
  I386_LSS,
  I386_LTR,
  I386_MOV,
  I386_MOVNTI,
  I386_MOVSB,
  I386_MOVSD,
  I386_MOVSX,
  I386_MOVZX,
  I386_MUL,
  I386_NEG,
  I386_NOP,
  I386_NOT,
  I386_OR,
  I386_OUT,
  I386_OUTSB,
  I386_OUTSD,
  I386_POP,
  I386_POPA,
  I386_POPF,
  I386_PUSH,
  I386_PUSHA,
  I386_PUSHF,
  I386_RCL,
  I386_RCR,
  I386_RDMSR,
  I386_RDPMC,
  I386_RDTSC,
  I386_RET,
  I386_RETF,
  I386_ROL,
  I386_ROR,
  I386_RSM,
  I386_SAHF,
  I386_SAR,
  I386_SBB,
  I386_SCASB,
  I386_SCASD,
  I386_SETcc,
  I386_SGDT,
  I386_SHL,
  I386_SHLD,
  I386_SHR,
  I386_SHRD,
  I386_SIDT,
  I386_SLDT,
  I386_SMSW,
  I386_STC,
  I386_STD,
  I386_STI,
  I386_STOSB,
  I386_STOSD,
  I386_STR,
  I386_SUB,
  I386_SYSENTER,
  I386_SYSEXIT,
  I386_TEST,
  I386_UD2,
  I386_VERR,
  I386_VERW,
  I386_WAIT,
  I386_WBINVD,
  I386_WRMSR,
  I386_XADD,
  I386_XCHG,
  I386_XLAT,
  I386_XOR,

  /* added for instrumentation code */
  I386_PSEUDOCALL,
  I386_PSEUDOSAVE,
  I386_PSEUDOLOAD,

  MAX_I386_OPCODE        /* always keep this entry last */
};
#endif

#ifndef I386_OPCODE_H
#define I386_OPCODE_H

#include "../../simple_types.h"
#include "i386_instructions.h"
#include "../../datastructures/data_string.h"

typedef t_uint32 (*I386DisassembleFunction) (t_i386_ins *, t_uint8* codep, t_uint32 modrm, t_uint32 sib);
struct _t_i386_opcode_info {
  t_string textual;
  int type;
  /* condition flags used by this instruction */
  t_regset cf_used;
  /* condition flags defined by this instruction */
  t_regset cf_defined;
  int fpstack_pops;
  int fpstack_pushes;
  t_uint32 fixedops;
};

extern t_i386_opcode_info i386_opcode_table[];
void I386InitOpcodeTable(void);

#endif
