/* {{{ Copyright
 * Copyright 2001,2002: Bertrand Anckaert
 * 			Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Matias Madou
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
/* }}} */

#include "i386_instructions.h"
#include "i386_registers.h"
#ifndef OPERAND_ITERATORS
#define OPERAND_ITERATORS
typedef struct _t_immediates t_immediates;

struct _t_immediates{
  t_uint8 size;
  t_uint8 count;
  t_uint32 * imms;
};

t_bool I386OpNextNone(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextReg(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextST(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextConst1(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextA(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextC(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextD(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextE(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextF(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextG(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextsI(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextI(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextJ(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextM(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextO(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextR(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextS(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextX(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
t_bool I386OpNextY(t_i386_ins * ins, t_i386_operand * op, t_i386_bytemode bm, t_immediates * imm);
#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
