/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_assemble.h"
#include "ia64_assemble/ia64_assemble_one_a.h"
#include "ia64_assemble/ia64_assemble_one_b.h"
#include "ia64_assemble/ia64_assemble_one_f.h"
#include "ia64_assemble/ia64_assemble_one_i.h"
#include "ia64_assemble/ia64_assemble_one_m.h"
#include "ia64_assemble/ia64_assemble_one_x.h"
#include "ia64_instructions.h"
#include "ia64_opcodes.h"
#include "../../kernel/diablo_addresses.h"
#include "../../utils/util_error.h"
#include "ia64_disassemble/ia64_disassemble_one.h"


#define CALC_OFFSET(section, ins) (G_T_UINT64(GENERIC_SUB(GENERIC_NAND_UINT32(INS_CADDRESS(ins), 0xf), SECTION_GET_CADDRESS(section))))

/* is nog niet gecheckt !!!*/
void WriteBundle(char *data, const t_bundle *bundle, t_uint64 byteoffset)
{
	/* nu de 128bits wegschijven, per 64bit...(little endian)*/
	*((t_uint64*)(data+byteoffset)) = ((t_uint64)bundle->template) | (bundle->slot[0]<<5) | ((bundle->slot[1]&0x3FFFFULL)<<46);
	*((t_uint64*)(data+byteoffset+8)) = ((bundle->slot[1]>>18)&0x7FFFFFULL) | (bundle->slot[2]<<23);
	
}
void WriteData(char * data, t_uint64 data1, t_uint64 data2, t_uint64 byteoffset)
{
	*((t_uint64*)(data+byteoffset)) = data1;
      	*((t_uint64*)(data+byteoffset+8)) = data2;	
}
void Ia64AssembleSection(t_object * obj, t_section * sec)
{
  t_uint32 nins = 0;
  t_ins * i_ins, *startins;
  char * data = SECTION_TMP_BUF(sec), *data2=data;
  t_bundle bundle;
  t_uint8 slot;
  t_bool followedByStop[3];
  t_ia64_instr_type instr_types[3];

  t_uint32 nopCount = 0;

  i_ins = sec->data; //&ARMAINS(obj,sec,0);

  while(i_ins != NULL)
  {
    /* we have to reassemble it */
    
    /* we gaan ervan uit dat de deflowgraph voldoende instructies zal geproduceerd 
     * hebben, dat alle sloten vol zullen zitten !!! 
     * We gaan er ook al van uit dat er een passende template bestaat...
     */

    if(IA64INSTYPE(i_ins)==IA64_TYPE_DATA)
    {
      //printf("ik ben opgeroepen!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
      WriteData(data, IA64INSIMM1(i_ins), IA64INSIMM1(INS_NEXT(i_ins)), CALC_OFFSET(sec, i_ins));
      //WriteData(data2, IA64INSIMM1(i_ins), IA64INSIMM1(INS_NEXT(i_ins)), 0);//CALC_OFFSET(sec, i_ins));
      i_ins = INS_NEXT(i_ins);
      i_ins = INS_NEXT(i_ins);
      i_ins = INS_NEXT(i_ins);
      nins+=3;
      data2+=16;
      continue;
    }

    startins = i_ins;
  
    for(slot = 0; slot<3; slot++,i_ins = INS_NEXT(i_ins))
    {
/*      
      if(INS_CADDRESS(i_ins) == 0x4000000000000330ULL)
      {
	InsPrint(i_ins, 0);
	InsPrint(INS_NEXT(i_ins), 0);
	InsPrint(INS_NEXT(INS_NEXT(i_ins)), 0);
      }
*/      
#ifndef IA64_NEW_BBL_ADDRESS     
      if(IA64INSOPCODE(i_ins) == 0xFFFF)
      {//bevat geen geldige instructie
	switch(slot)
	{
	  case 0:
	    bundle.template = 0xFF;
	    bundle.slot[0] = 0xFFFFFFFFFFFFFFFFULL;
	    bundle.slot[1] = 0xFFFFFFFFFFFFFFFFULL;
	    bundle.slot[2] = 0xFFFFFFFFFFFFFFFFULL;
	    WriteBundle(data2, &bundle, 0);//CALC_OFFSET(sec, i_ins));
	    data2+=16;
	    RELOCATABLE_REFERS_TO(i_ins) = NULL;
	    RELOCATABLE_REFED_BY(i_ins) = NULL;
	    i_ins = INS_NEXT(i_ins); 
	    if(i_ins)
	    {
	      RELOCATABLE_REFERS_TO(i_ins) = NULL;
	      RELOCATABLE_REFED_BY(i_ins) = NULL;	    
	      i_ins = INS_NEXT(i_ins); 
	    }
	    if(i_ins)
	    {
	      RELOCATABLE_REFERS_TO(i_ins) = NULL;
	      RELOCATABLE_REFED_BY(i_ins) = NULL;	    
	      i_ins = INS_NEXT(i_ins); 
	    }
	    nins+=3;
	    break;
	  case 1:
	    instr_types[1] = IA64_TYPE_B;
	    bundle.slot[1] = ia64_opcode_table[IA64_TYPE_B][GetNopOpcode(IA64_UNIT_B)].opcode;
	    instr_types[2] = instr_types[1];
	    bundle.slot[2] = bundle.slot[1];
	    followedByStop[0] = 0;
	    followedByStop[1] = 0;
	    followedByStop[2] = 1;

	    /* bijhorende template invullen */
	    MakeTemplate(&bundle, instr_types, followedByStop);

	    /* nu de bundle wegschrijven */
	    WriteBundle(data2, &bundle, 0); //CALC_OFFSET(sec, i_ins));

	    data2 += 16;
	    RELOCATABLE_REFERS_TO(i_ins) = NULL;
	    RELOCATABLE_REFED_BY(i_ins) = NULL;
	    i_ins = INS_NEXT(i_ins); 
	    if(i_ins)
	    {
	      RELOCATABLE_REFERS_TO(i_ins) = NULL;
	      RELOCATABLE_REFED_BY(i_ins) = NULL;	    
	      i_ins = INS_NEXT(i_ins); 
	    }
	    nins+=2;
	    break;
	  case 2:
	    instr_types[2] = IA64_TYPE_B;
	    bundle.slot[2] = ia64_opcode_table[IA64_TYPE_B][GetNopOpcode(IA64_UNIT_B)].opcode;
	    followedByStop[1] = 0;
	    followedByStop[2] = 1;

	    /* bijhorende template invullen */
	    MakeTemplate(&bundle, instr_types, followedByStop);

	    /* nu de bundle wegschrijven */
	    WriteBundle(data2, &bundle, 0);//CALC_OFFSET(sec, i_ins));

	    data2 += 16;
	    RELOCATABLE_REFERS_TO(i_ins) = NULL;
	    RELOCATABLE_REFED_BY(i_ins) = NULL;
	    i_ins = INS_NEXT(i_ins); 
	    nins++;

	    break;
	}
	
        break;
      }
#endif
//      if (IA64INSTYPE(i_ins))
      instr_types[slot] = IA64INSTYPE(i_ins);
      if(instr_types[slot] == IA64_TYPE_DUMMY)
      {
	instr_types[slot] = IA64_TYPE_X;
	nins++;
        /* we originally forgot this => possible problems for dummy...*/
        followedByStop[slot] = 0;
	continue;
      }

      /*count the total number of nops...*/
      if(IA64OPCODEINFO(i_ins).instr_opcode == IA64_INSTR_NOP)
	nopCount++;
      
      /* IA64-opcode invullen */
      bundle.slot[slot] = 0;
      /* de set_pred moet voor het invullen van de opcode gebeuren, voor instructies B6 en B7... */
      SET_PRED(bundle.slot[slot], IA64INSPRED(i_ins));

      bundle.slot[slot] |= IA64OPCODEINFO(i_ins).opcode;

      /* operandi invullen */
      Ia64AssembleFunction_table[IA64OPCODEINFO(i_ins).instr_format](i_ins, &bundle.slot[slot], &bundle);

      if(slot<2) /* ins_next zou zeker moeten bestaan... */
	followedByStop[slot] = IA64INSINSTRGROUP(i_ins) != IA64INSINSTRGROUP(INS_NEXT(i_ins));
      else
	followedByStop[slot] = INS_NEXT(i_ins) == NULL || IA64INSINSTRGROUP(i_ins) != IA64INSINSTRGROUP(INS_NEXT(i_ins));

      if(instr_types[slot] == IA64_TYPE_A)
      {
	if((IA64INSATTR(i_ins) & IA64_INSTR_FLAG_USE_M_FOR_A))
	  instr_types[slot] = IA64_TYPE_M;
	
	if((IA64INSATTR(i_ins) & IA64_INSTR_FLAG_USE_I_FOR_A))
	  instr_types[slot] = IA64_TYPE_I;
      }
      
      //nog checken voor dummy plaats
#ifndef IA64_NEW_BBL_ADDRESS
      if(bundle.slot[slot] != IA64INSORIGINSTR(i_ins))
      {
          DiabloPrint(stdout, "@I\n", i_ins);
	  printf("WARNING: ASSEMBLE MISMATCH: original ins: %llx; assembled ins:%llx\n", IA64INSORIGINSTR(i_ins), bundle.slot[slot]);
      }
#endif 
      nins++;
    }      
 
    if(slot == 3)
    {   
      /* bijhorende template invullen */
      MakeTemplate(&bundle, instr_types, followedByStop);

      /* nu de bundle wegschrijven */
      WriteBundle(data, &bundle, CALC_OFFSET(sec, startins));
      //WriteBundle(data2, &bundle, 0);//CALC_OFFSET(sec, startins));

      data2 += 16;
    }
  }
                  
  printf("assembled %d instructions, %d NOPs.\n",nins, nopCount);
}

void Ia64AssembleUnsupported(t_ins * ins, t_uint64 * instr, t_bundle * bundle)
{
  FATAL(("Unsupported ia64 instruction; cannot assemble."));
}


/*
 * bevat de lijst van alle assemble functions, 1 voor elk instructie formaat
 * de indexering in deze tabel moet dan ook volgens t_ia64_instr_format gebeuren...
 */
const Ia64AssembleFunction Ia64AssembleFunction_table [] =
{
        Ia64AssembleA1, Ia64AssembleA2, Ia64AssembleA3, Ia64AssembleA4, Ia64AssembleA5,
        Ia64AssembleA6, Ia64AssembleA7, Ia64AssembleA8, Ia64AssembleA9, Ia64AssembleA10,

        Ia64AssembleI1, Ia64AssembleI2, Ia64AssembleI3, Ia64AssembleI4, Ia64AssembleI5,
        Ia64AssembleI6, Ia64AssembleI7, Ia64AssembleI8, Ia64AssembleI9, Ia64AssembleI10,
        Ia64AssembleI11, Ia64AssembleI12, Ia64AssembleI13, Ia64AssembleI14, Ia64AssembleI15,
        Ia64AssembleI16, Ia64AssembleI17, Ia64AssembleUnsupported, Ia64AssembleI19, Ia64AssembleI20,
        Ia64AssembleI21, Ia64AssembleI22, Ia64AssembleI23, Ia64AssembleI24, Ia64AssembleI25,
        Ia64AssembleI26, Ia64AssembleI27, Ia64AssembleI28, Ia64AssembleI29,
 
        Ia64AssembleM1, Ia64AssembleM2, Ia64AssembleM3, Ia64AssembleM4, Ia64AssembleM5,
        Ia64AssembleM6, Ia64AssembleM7, Ia64AssembleM8, Ia64AssembleM9, Ia64AssembleM10,
        Ia64AssembleM11, Ia64AssembleM12, Ia64AssembleM13, Ia64AssembleM14, Ia64AssembleM15,
        Ia64AssembleM16, Ia64AssembleM17, Ia64AssembleM18, Ia64AssembleM19, Ia64AssembleM20,
        Ia64AssembleM21, Ia64AssembleM22, Ia64AssembleM23, Ia64AssembleM24, Ia64AssembleM25,
        Ia64AssembleM26, Ia64AssembleM27, Ia64AssembleM28, Ia64AssembleM29, Ia64AssembleM30,
        Ia64AssembleM31, Ia64AssembleM32, Ia64AssembleM33, Ia64AssembleM34, Ia64AssembleM35,
        Ia64AssembleM36, Ia64AssembleM37, Ia64AssembleM38, Ia64AssembleM39, Ia64AssembleM40,
        Ia64AssembleM41, Ia64AssembleM42, Ia64AssembleM43, Ia64AssembleM44, Ia64AssembleM45,
        Ia64AssembleM46,
 
        Ia64AssembleB1, Ia64AssembleB2, Ia64AssembleB3, Ia64AssembleB4, Ia64AssembleB5,
        Ia64AssembleB6, Ia64AssembleB7, Ia64AssembleB8, Ia64AssembleB9,

        Ia64AssembleF1, Ia64AssembleF2, Ia64AssembleF3, Ia64AssembleF4, Ia64AssembleF5,
        Ia64AssembleF6, Ia64AssembleF7, Ia64AssembleF8, Ia64AssembleF9, Ia64AssembleF10,
        Ia64AssembleF11, Ia64AssembleF12, Ia64AssembleF13, Ia64AssembleF14, Ia64AssembleF15,

        Ia64AssembleX1, Ia64AssembleX2, Ia64AssembleX3, Ia64AssembleX4, 
        
        Ia64AssembleUnsupported, Ia64AssembleUnsupported      

};





/* vim: set shiftwidth=2: */
