/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../config.h"
#ifndef IA64_DUMMY_H
#define IA64_DUMMY_H

#include "../../utils/util_error.h"
#include "../../kernel/diablo_flowgraph.h"
#include "../../kernel/diablo_edge.h"

#include "ia64_utils.h"



/*
* alloc:
* - imm1 = sol
* - imm2 = sof
* - imm3 = sor (sor al * 8 gedaan !)
*
* dummy:
* - imm1 : bevat tijdens constantenpropagatie een pointer naar een tijdelijke procstate
* - imm2 : sol (IA64_ALLOC_MISSING als alloc niet gekend)
* - imm3 : sof (IA64_ALLOC_MISSING als alloc niet gekend)
*
* 
* */


#define IA64_ALLOC_MISSING -1



#define IA64ISLIVEDUMMY(ins) (IA64INSTYPE(ins) == IA64_TYPE_DUMMY && IA64INSOPCODE(ins) == DUMMY_LIVE_OPCODE)

void Ia64InitializeDummies(t_cfg * cfg);
void Ia64FinalizeDummies(t_cfg * cfg);

#endif

/* vim: set shiftwidth=2: */
