/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_emulation.h"
#include "ia64_emulation_one.h"
#include "ia64_registers.h"
#include "ia64_opcodes.h"
#include "ia64_instructions.h"
#include "../../utils/util_error.h"
#include "../../kernel/diablo_print.h"



void Ia64InstructionEmulator(t_ins * ins, t_procstate * procstate)
{
  static t_uint64 __cnt = 0ULL;
  register_content reg;
  t_bool execute /*,flag1,flag2*/;
  t_bool uncertain = FALSE;
  t_procstate * orig_state = NULL;
  //t_ia64_instr_opcode opc = IA64OPCODEINFO(ins).instr_opcode;
  
  
  /*nopkes overslaan*/
/*  
  if(IA64OPCODEINFO(ins).instr_opcode == IA64_INSTR_NOP)
    return;
*/
  
  /* TODO : nog kijken voor tnat, cmp....*/
  
  if(IA64INSPRED(ins) != IA64_P0/* || opc == IA64_INSTR_CMP || opc == IA64_INSTR_CMP4 || opc == IA64_INSTR_TBIT || opc == IA64_INSTR_TNAT*/)
  {
    if (!(uncertain = ProcStateGetReg(procstate,IA64INSPRED(ins), &reg)))
    {
      execute = G_T_UINT64(reg.i);
      if (!execute) 
      {
	if (INS_ATTRIB(ins) & IF_EXECED)
	  INS_ATTRIB(ins) &= ~IF_ALWAYS_EXECED;

	return;

      }
    }
  }
  else if(IA64INSPRED(ins)==IA64_P0)
    INS_ATTRIB(ins) &= ~IF_ALWAYS_EXECED;

  /* an instruction is can be executed */

  INS_ATTRIB(ins) |= IF_EXECED;


  
  /*TODO: misschien beter oplossen*/
  reg.i = 0;
 
  ProcStateSetReg(procstate, IA64_R0, reg);
  ProcStateSetReg(procstate, IA64_R0_NAT, reg);
  


    
  if (uncertain)
  {
    /* but it will not always be executed */
    INS_ATTRIB(ins) &= ~IF_ALWAYS_EXECED;
    FATAL(("Implement"));
    //orig_state = ProcStateAlloc();
    ProcStateDup(orig_state,procstate);
  }

  /* actual emulation */

  if(((++__cnt) & 0x0fffULL) == 0ULL)
  {
    printf("Instruction %lld: ", __cnt);
    //InsPrint(ins, 0);
    fflush(stdout);
  }



  /* emulatie doorlaten. Let wel: bijlange niet alle instructies worden al geemuleerd !!!*/
  /* zie emulation_one: al deze met "status: CHECKED" zijn geactiveerd. */
  /* twee HEEL belangrijke, cmp, en ld, moeten nog gedaan/gecontroleerd worden.*/
  Ia64EmulateInstruction(ins,procstate);

/*  
  //tijdelijk eens eerst alles op bot zette
  if(IA64INSTYPE(ins) == IA64_TYPE_DUMMY && IA64INSOPCODE(ins) == DUMMY_LIVE_OPCODE)
    Ia64EmulateInstruction(ins,procstate);
  else
    ProcStateSetAllBot(procstate,INS_REGS_DEF(ins));
*/
  
  if (uncertain) /* We don't know what happened, join both the new and the prev state*/
  {

    //ProcStateJoin(procstate, orig_state , AllRegs(), NullRegs);
    ProcStateJoin(procstate, orig_state , INS_REGS_DEF(ins), NullRegs);

    ProcStateFree(orig_state);
    orig_state = NULL;
  }

}
/* vim: set shiftwidth=2: */




