/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../config.h"
#ifndef IA64_PRINT_H
#define IA64_PRINT_H
#include "ia64_instructions.h"
#include "../../datastructures/data_string.h"


void Ia64InstructionPrint(t_ins * ins, t_string outputstring) ;


void Ia64PrintUnsupported(t_ins * ins, t_string outputstring);


/* The structure of the different print functions */

typedef void (*Ia64PrintFunction) (t_ins * ins, t_string outputstring);


/* 
 * bevat de lijst van alle print functions, 1 voor elk instructie formaat
 * de indexering in deze tabel moet dan ook volgens t_ia64_instr_format gebeuren...
 */
extern const Ia64PrintFunction Ia64PrintFunction_table [];

#endif
/* vim: set shiftwidth=2: */
