/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_statusbar.h"
#include <stdio.h>

#define IA64_STATUSBAR_DEFAULT_WIDTH 75

static t_uint64 __status_maxCount = 0;
static t_uint64 __status_currCount = 0;
static t_uint64 __status_width = IA64_STATUSBAR_DEFAULT_WIDTH;


/*
void Ia64StatusBarInit(t_uint64 maxCount)
{
  Ia64StatusBarInit(maxCount, IA64_STATUSBAR_DEFAULT_WIDTH);
}
*/

/* no consistency checking is done !*/
void Ia64StatusBarInit(t_uint64 maxCount, t_uint32 width)
{
  __status_maxCount = maxCount;
  __status_currCount = 0;
  __status_width = width;
}


void Ia64StatusBarStart()
{
  t_uint32 i = 0;
  printf("0%%");

  for(i = 6; i < __status_width; i++)
    printf(" ");

  printf("100%%\n");

  for(i = 0; i < __status_width; i++)
    printf("-");

  printf("\n");
 
  
}

void Ia64StatusBarUpdate(t_uint64 current)
{
  t_uint64 last = current*__status_width/__status_maxCount;

  while(__status_currCount != last)
  {
    printf("="); fflush(stdout);
    __status_currCount++;
  }
}

void Ia64StatusBarStop()
{
  Ia64StatusBarUpdate(__status_maxCount);
  printf("\n");
}






/* vim: set shiftwidth=2: */
