/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_utils_f.h"
#include "../../../utils/util_error.h"

#include "../ia64_utils.h"
#include "../ia64_instructions.h"
#include "../ia64_registers.h"

#include "../ia64_opcodes.h"


/* TODO: nog alle verborgen gebruikte en gewijzigde registers toevoegen !!!*/


/* F1: Floating-point multiply add */
void Ia64UsedRegistersF1(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  
  

}

/* F2: Fixed-point multiply add */
void Ia64UsedRegistersF2(t_regset * mask, t_ins * ins)
{
  

}

/* F3: Parallel Floating-point select */
void Ia64UsedRegistersF3(t_regset * mask, t_ins * ins)
{
  

}

/* F4: Floating-point compare */
void Ia64UsedRegistersF4(t_regset * mask, t_ins * ins)
{
  

}


/* F5: Floating-point class */
void Ia64UsedRegistersF5(t_regset * mask, t_ins * ins)
{
  

}


/* F6: Floating-point reciprocal approxiimation */
void Ia64UsedRegistersF6(t_regset * mask, t_ins * ins)
{
  

}

/* F7: Floating-point reciprocal square root approximation */
void Ia64UsedRegistersF7(t_regset * mask, t_ins * ins)
{
  

}

/* F8: minimum/maximum and parallel compare */
void Ia64UsedRegistersF8(t_regset * mask, t_ins * ins)
{
  

}

/* F9: merge and logical */
void Ia64UsedRegistersF9(t_regset * mask, t_ins * ins)
{
  

}

/* F10: convert floating-point to fixed-point */
void Ia64UsedRegistersF10(t_regset * mask, t_ins * ins)
{
  

}


/* F11: convert fixed-point to floating-point */
void Ia64UsedRegistersF11(t_regset * mask, t_ins * ins)
{
  


}

/* F12: floating-point set controls*/
void Ia64UsedRegistersF12(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  
}


/* F13: floating-point clear flags*/
void Ia64UsedRegistersF13(t_regset * mask, t_ins * ins)
{
  
}


/* F14: floating-point check flags*/
void Ia64UsedRegistersF14(t_regset * mask, t_ins * ins)
{

  RegsetAddReg(*mask, IA64_AR_FPSR);  
  RegsetAddReg(*mask, IA64_PSR);  
  RegsetAddReg(*mask, IA64_IP);  
  
}

/* F15: break/nop*/
void Ia64UsedRegistersF15(t_regset * mask, t_ins * ins)
{
  
}





/*----------------------------------------------------------------------------*/





/* F1: Floating-point multiply add */
void Ia64DefinedRegistersF1(t_regset * mask, t_ins * ins)
{

  RegsetAddReg(*mask, IA64_AR_FPSR);
  RegsetAddReg(*mask, IA64_PSR);
  

}

/* F2: Fixed-point multiply add */
void Ia64DefinedRegistersF2(t_regset * mask, t_ins * ins)
{

  RegsetAddReg(*mask, IA64_PSR);
  

}

/* F3: Parallel Floating-point select */
void Ia64DefinedRegistersF3(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_PSR);


}

/* F4: Floating-point compare */
void Ia64DefinedRegistersF4(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  

}


/* F5: Floating-point class */
void Ia64DefinedRegistersF5(t_regset * mask, t_ins * ins)
{
  

}


/* F6: Floating-point reciprocal approxiimation */
void Ia64DefinedRegistersF6(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  RegsetAddReg(*mask, IA64_PSR);
  

}

/* F7: Floating-point reciprocal square root approximation */
void Ia64DefinedRegistersF7(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  RegsetAddReg(*mask, IA64_PSR);
  


}

/* F8: minimum/maximum and parallel compare */
void Ia64DefinedRegistersF8(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  RegsetAddReg(*mask, IA64_PSR);
  


}

/* F9: merge and logical */
void Ia64DefinedRegistersF9(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_PSR);


}

/* F10: convert floating-point to fixed-point */
void Ia64DefinedRegistersF10(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);
  RegsetAddReg(*mask, IA64_PSR);


}


/* F11: convert fixed-point to floating-point */
void Ia64DefinedRegistersF11(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_PSR);


}

/* F12: floating-point set controls*/
void Ia64DefinedRegistersF12(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);  
  
}


/* F13: floating-point clear flags*/
void Ia64DefinedRegistersF13(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_AR_FPSR);  
  
}


/* F14: floating-point check flags*/
void Ia64DefinedRegistersF14(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_IP);    
  
}

/* F15: break/nop*/
void Ia64DefinedRegistersF15(t_regset * mask, t_ins * ins)
{
  
}



/* vim: set shiftwidth=2: */
