/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_utils_i.h"
#include "../../../utils/util_error.h"

#include "../ia64_utils.h"
#include "../ia64_instructions.h"
#include "../ia64_registers.h"

#include "../ia64_opcodes.h"



/* TODO: nog alle verborgen gebruikte en gewijzigde registers toevoegen !!!*/



/* I1: Multimedia multiply and shift */
void Ia64UsedRegistersI1(t_regset * mask, t_ins * ins)
{
  


}

/* I2: Multimedia multiply/mix/pack/unpack */
void Ia64UsedRegistersI2(t_regset * mask, t_ins * ins)
{
  


}


/* I3: Multimedia mux1 */
void Ia64UsedRegistersI3(t_regset * mask, t_ins * ins)
{
  
}


/* I4: Multimedia mux2 */
void Ia64UsedRegistersI4(t_regset * mask, t_ins * ins)
{
  
}

/* I5: Multimedia mux2 */
void Ia64UsedRegistersI5(t_regset * mask, t_ins * ins)
{
  

}


/* I6: Multimedia shift right fixec */
void Ia64UsedRegistersI6(t_regset * mask, t_ins * ins)
{
  

}


/* I7: Multimedia shift left variable */
void Ia64UsedRegistersI7(t_regset * mask, t_ins * ins)
{
  

}


/* I8: Multimedia shift left fixed */
void Ia64UsedRegistersI8(t_regset * mask, t_ins * ins)
{
  


}


/* I9: Population count */
void Ia64UsedRegistersI9(t_regset * mask, t_ins * ins)
{
  

}

/* I10: shift right pair */
void Ia64UsedRegistersI10(t_regset * mask, t_ins * ins)
{
  

}


/* I11: extract */
void Ia64UsedRegistersI11(t_regset * mask, t_ins * ins)
{
  

}

/* I12: zero and deposit */
void Ia64UsedRegistersI12(t_regset * mask, t_ins * ins)
{
  

}


/* I13: zero and deposit immediate*/
void Ia64UsedRegistersI13(t_regset * mask, t_ins * ins)
{
 
}


/* I14: deposit immediate*/
void Ia64UsedRegistersI14(t_regset * mask, t_ins * ins)
{
  

}


/* I15: deposit*/
void Ia64UsedRegistersI15(t_regset * mask, t_ins * ins)
{
  

}


/* I16: test bit*/
void Ia64UsedRegistersI16(t_regset * mask, t_ins * ins)
{
  

}

/* I17: test naT*/
void Ia64UsedRegistersI17(t_regset * mask, t_ins * ins)
{
  

}


/* I19: break\nop*/
void Ia64UsedRegistersI19(t_regset * mask, t_ins * ins)
{
}

/* I20: integer speculation unit*/
void Ia64UsedRegistersI20(t_regset * mask, t_ins * ins)
{
  RegsetAddReg(*mask, IA64_IP);
  RegsetAddReg(*mask, IA64_PSR);  

}


/* I21: move to BR*/
void Ia64UsedRegistersI21(t_regset * mask, t_ins * ins)
{
  RegsetAddReg(*mask, IA64_IP);  

}


/* I22: move from BR*/
void Ia64UsedRegistersI22(t_regset * mask, t_ins * ins)
{
  

}


/* I23: move to predicates -register*/
void Ia64UsedRegistersI23(t_regset * mask, t_ins * ins)
{
  

}

/* I24: move to predicates - immediate44*/
void Ia64UsedRegistersI24(t_regset * mask, t_ins * ins)
{
  
}


/* I25: move from predicates ip*/
void Ia64UsedRegistersI25(t_regset * mask, t_ins * ins)
{
  if(GETBITS64(IA64OPCODEINFO(ins).opcode, 27, 6) == 0x30)
    RegsetAddReg(*mask, IA64_IP);
  else
  {
    t_uint8 i;
    
    for(i = 0; i<64; i++)
      RegsetAddReg(*mask, IA64_PR + i);

  }
}

/* I26: move to AR - register*/
void Ia64UsedRegistersI26(t_regset * mask, t_ins * ins)
{
  if(IA64INSOUT1(ins) == IA64_AR_BSPSTORE || IA64INSOUT1(ins) == IA64_AR_RNAT)
    RegsetAddReg(*mask, IA64_AR_RSC);
  
  RegsetAddReg(*mask, IA64_PSR);

}

/* I27: move to AR - immediate8*/
void Ia64UsedRegistersI27(t_regset * mask, t_ins * ins)
{
  if(IA64INSOUT1(ins) == IA64_AR_BSPSTORE || IA64INSOUT1(ins) == IA64_AR_RNAT)
    RegsetAddReg(*mask, IA64_AR_RSC);

  RegsetAddReg(*mask, IA64_PSR);


}


/* I28: move from AR - immediate8*/
void Ia64UsedRegistersI28(t_regset * mask, t_ins * ins)
{
  if(IA64INSOUT1(ins) == IA64_AR_BSPSTORE || IA64INSOUT1(ins) == IA64_AR_RNAT)
    RegsetAddReg(*mask, IA64_AR_RSC);

  RegsetAddReg(*mask, IA64_PSR);



}

/* I29: sign/zero extend/compute zero index */
void Ia64UsedRegistersI29(t_regset * mask, t_ins * ins)
{
  

}





/*----------------------------------------------------------------------------*/



/* I1: Multimedia multiply and shift */
void Ia64DefinedRegistersI1(t_regset * mask, t_ins * ins)
{
  

}

/* I2: Multimedia multiply/mix/pack/unpack */
void Ia64DefinedRegistersI2(t_regset * mask, t_ins * ins)
{
  

}


/* I3: Multimedia mux1 */
void Ia64DefinedRegistersI3(t_regset * mask, t_ins * ins)
{
  

}


/* I4: Multimedia mux2 */
void Ia64DefinedRegistersI4(t_regset * mask, t_ins * ins)
{
  

}

/* I5: Multimedia mux2 */
void Ia64DefinedRegistersI5(t_regset * mask, t_ins * ins)
{
  

}


/* I6: Multimedia shift right fixec */
void Ia64DefinedRegistersI6(t_regset * mask, t_ins * ins)
{
  

}


/* I7: Multimedia shift left variable */
void Ia64DefinedRegistersI7(t_regset * mask, t_ins * ins)
{
  

}


/* I8: Multimedia shift left fixed */
void Ia64DefinedRegistersI8(t_regset * mask, t_ins * ins)
{
  

}


/* I9: Population count */
void Ia64DefinedRegistersI9(t_regset * mask, t_ins * ins)
{
  

}

/* I10: shift right pair */
void Ia64DefinedRegistersI10(t_regset * mask, t_ins * ins)
{
  


}


/* I11: extract */
void Ia64DefinedRegistersI11(t_regset * mask, t_ins * ins)
{
  

}

/* I12: zero and deposit */
void Ia64DefinedRegistersI12(t_regset * mask, t_ins * ins)
{
  

}


/* I13: zero and deposit immediate*/
void Ia64DefinedRegistersI13(t_regset * mask, t_ins * ins)
{
  

}


/* I14: deposit immediate*/
void Ia64DefinedRegistersI14(t_regset * mask, t_ins * ins)
{
  

}


/* I15: deposit*/
void Ia64DefinedRegistersI15(t_regset * mask, t_ins * ins)
{
  

}


/* I16: test bit*/
void Ia64DefinedRegistersI16(t_regset * mask, t_ins * ins)
{
  

}

/* I17: test naT*/
void Ia64DefinedRegistersI17(t_regset * mask, t_ins * ins)
{
  

}


/* I19: break\nop*/
void Ia64DefinedRegistersI19(t_regset * mask, t_ins * ins)
{
}

/* I20: integer speculation unit*/
void Ia64DefinedRegistersI20(t_regset * mask, t_ins * ins)
{
  RegsetAddReg(*mask, IA64_IP);  
}


/* I21: move to BR*/
void Ia64DefinedRegistersI21(t_regset * mask, t_ins * ins)
{
  

}


/* I22: move from BR*/
void Ia64DefinedRegistersI22(t_regset * mask, t_ins * ins)
{
  

}


/* I23: move to predicates - register*/
void Ia64DefinedRegistersI23(t_regset * mask, t_ins * ins)
{
  t_uint8 i;

  for(i = 0; i<64; i++)
    RegsetAddReg(*mask, IA64_PR + i);

  
}

/* I24: move to predicates - immediate44*/
void Ia64DefinedRegistersI24(t_regset * mask, t_ins * ins)
{
  t_uint8 i;

  for(i = 16; i<64; i++)
    RegsetAddReg(*mask, IA64_PR + i);

}


/* I25: move from predicates ip*/
void Ia64DefinedRegistersI25(t_regset * mask, t_ins * ins)
{
  

}

/* I26: move to AR - register*/
void Ia64DefinedRegistersI26(t_regset * mask, t_ins * ins)
{
  if(IA64INSOUT1(ins) == IA64_AR_BSPSTORE)
  {
    RegsetAddReg(*mask, IA64_AR_RNAT);
    RegsetAddReg(*mask, IA64_AR_BSP);

    /* zie rse_update_internal_stack_pointers */  
    RegsetAddReg(*mask, IA64_AR_BSP);
  }


}

/* I27: move to AR - immediate8*/
void Ia64DefinedRegistersI27(t_regset * mask, t_ins * ins)
{
  if(IA64INSOUT1(ins) == IA64_AR_BSPSTORE)
  {
    RegsetAddReg(*mask, IA64_AR_RNAT);
    RegsetAddReg(*mask, IA64_AR_BSP);
    /* zie rse_update_internal_stack_pointers */  
    RegsetAddReg(*mask, IA64_AR_BSP);
  }


}


/* I28: move from AR - immediate8*/
void Ia64DefinedRegistersI28(t_regset * mask, t_ins * ins)
{
  

}

/* I29: sign/zero extend/compute zero index */
void Ia64DefinedRegistersI29(t_regset * mask, t_ins * ins)
{
  

}




/* vim: set shiftwidth=2: */
