/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_utils_x.h"
#include "../../../utils/util_error.h"

#include "../ia64_utils.h"
#include "../ia64_instructions.h"
#include "../ia64_registers.h"

#include "../ia64_opcodes.h"



/* TODO: nog alle verborgen gebruikte en gewijzigde registers toevoegen !!!*/


/* X1: Break/Nop (X-Unit) */
void Ia64UsedRegistersX1(t_regset * mask, t_ins * ins)
{
  
}

/* X2: Move Long Immediate64 */
void Ia64UsedRegistersX2(t_regset * mask, t_ins * ins)
{
  
}


/* X3: Long Branch */
void Ia64UsedRegistersX3(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_IP);
  RegsetAddReg(*mask, IA64_PSR);

}


/* X4: Long Call */
void Ia64UsedRegistersX4(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_IP);
  RegsetAddReg(*mask, IA64_PSR);
  RegsetAddReg(*mask, IA64_CFM);  
  RegsetAddReg(*mask, IA64_AR_EC);


}




/*----------------------------------------------------------------------------*/





/* X1: Break/Nop (X-Unit) */
void Ia64DefinedRegistersX1(t_regset * mask, t_ins * ins)
{
  
}

/* X2: Move Long Immediate64 */
void Ia64DefinedRegistersX2(t_regset * mask, t_ins * ins)
{
  

}


/* X3: Long Branch */
void Ia64DefinedRegistersX3(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_IP);

  
}


/* X4: Long Call */
void Ia64DefinedRegistersX4(t_regset * mask, t_ins * ins)
{
  
  RegsetAddReg(*mask, IA64_IP);
  RegsetAddReg(*mask, IA64_CFM);
  RegsetAddReg(*mask, IA64_AR_PFS);
  


}

/* vim: set shiftwidth=2: */
