/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef MIPS_ACTIONS_H
#define MIPS_ACTIONS_H
#include "../../kernel/diablo_action.h"
#include "mips_actions.h"
#include "mips_assemble.h"
#include "mips_constant_propagation.h"
#include "mips_deflowgraph.h"
#include "mips_disassemble.h"
#include "mips_emulation.h"
#include "mips_flowgraph.h"
#include "mips_map.h"
#include "mips_print.h"
#include "mips_registers.h"
#include "mips_datamap.h"
#include "mips_write.h"
#include "mips_instructions.h"

const t_action_struct mips_actions={
/* 00 */   NULL,                                 /* Group Info */
/* 01 */   MipsReadMap,                      /* Read Map */
/* 02 */   NULL,                                 /* Disassemble */
/* 03 */   MipsDisassembleSection,           /* Disassemble Section */
/* 04 */   NULL,                                 /* Flowgraph */
/* 05 */   MipsFlowgraphSection,             /* Flowgraph Section */
/* 06 */   MipsMakeAddressProducers,	    /* Make address producers */
/* 07 */   NULL,                                 /* Deflowgraph */
/* 08 */   MipsDeflowgraphSection,           /* Deflowgraph Section */
/* 09 */   NULL,                                 /* Assemble */ 
/* 10 */   MipsAssembleSection,              /* Assemble Section */
/* 11 */   MipsWrite,                                 /* Write Object */
   /* Instruction related mips callbacks*/
/* 12 */   MipsInstructionPrint,             /* Print Instruction */
/* 13 */   MipsInstructionMakeNoop,          /* Make a noop from the instruction */

/* 14 */   MipsRegisterName,                 /* return the register name (from a static array of registers )*/
/* 15 */   MipsInstructionEmulator,          /* Instruction Emulation */
/* 16 */   MipsEdgePropagator,               /* */
/* 17 */   MipsInstructionUnconditionalizer, /* */
/* 18 */   MipsInstructionsConstantOptimizer, /* */
/* 19 */   NULL,                             /* */
/* 20 */   MipsConvertToBlocksSec,             /* */
/* 21 */   NULL,                             /* */
/* 22 */   NULL,
/* 23 */   MipsInsHasSideEffect,
  /* Basic Block factorisation related arm callbacks*/
/* 24 */   NULL,//MipsBblCmpExtReg,		    /* Searches for copy instructions needed before a bbl*/  
/* 25 */   NULL,//MipsBblAbstract,		    /* Abstract a bbl with two given sets of copy-operations (before and after the bbl)*/
/* 26 */   NULL,//MipsFunComputeStackSavedRegisters,/* Compute the stack saved registers for a function */ 
/* 27 */   NULL,//MipsCopyInstructionPropagator,    /* Propagate copy analysis information */
/* 28 */   MipsIsSyscallExit,		    /* Returns true when instruction is program exit */
/* 29 */   MipsIsControlflow,
/* 30 */   MipsInsIsIndirectCall,
/* 31 */   MipsFunIsGlobal,              /* FunIsGlobal */
NULL,
NULL

};
#endif
/* vim: set shiftwidth=2: */
