/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef MIPS_DISASSEMBLE_ONE_H
#define MIPS_DISASSEMBLE_ONE_H
#include "../../kernel/diablo_ins.h"
void MipsDisassemble(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleBreak(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleData(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleUnsupported(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleNOP(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleDataProcessingI(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleDataProcessing(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleShift(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleMultiply(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleUnconditionalJump(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleBranch(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleTrapR(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleTrapI(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleConditionalMove(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleDataTransferL(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleDataTransferS(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP0DataProcessing(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP0(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataTransferS(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataTransferL(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataProcessingFT(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataProcessing(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataProcessingRound(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataProcessingMOV(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1Branch(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
void MipsDisassembleCOP1DataProcessingMoveTF(t_ins * ins, t_uint32 instr, t_uint16 opc ); 
#endif
