
#include "mips_opt.h"
#include "mips_instructions.h"
#include "mips_opcodes.h"
#include "mips_registers.h"
#include "mips_utils.h"
#include "../../kernel/diablo_print.h"
#include "../../kernel/diablo_iterators.h"

void LWC1change(t_ins * ins, t_ins * i_next);
void SWC1change(t_ins * ins, t_ins * i_next);
void LoadStore64bits(t_cfg * cfg);
void JumpEleminatie(t_cfg * cfg);
  
void OptInstructions(t_cfg * cfg)
{
  //LoadStore64bits(cfg);
  //JumpEleminatie(cfg);
}

void JumpEleminatie(t_cfg * cfg)
{
  t_bbl * i_bbl;
  t_cfg_edge * i_edge;

  DiabloPrint(stdout,"JUMPELEMINATIE\n");
  CFG_FOREACH_BBL(cfg,i_bbl)
  {
    if(i_bbl!=NULL && BBL_INS_LAST(i_bbl)!=NULL)// INS_NEXT(BBL_INS_LAST(i_bbl))!=NULL)
    {
      // BblPrint(i_bbl,PRINT_INSTRUCTIONS|PRINT_SUCCESSOR|PRINT_PREDECESSOR);
      BBL_FOREACH_SUCC_EDGE(i_bbl,i_edge)
      {
	if(MIPSINSOPCODE(BBL_INS_LAST(i_bbl))==MIPS_J||
	    (INS_PREV(BBL_INS_LAST(i_bbl))!=NULL&&
	     MIPSINSOPCODE(INS_PREV(BBL_INS_LAST(i_bbl)))==MIPS_J))
	{
	  DiabloPrint(stdout,"@E\n",i_edge);
	  BblPrint(i_bbl,PRINT_INSTRUCTIONS|PRINT_SUCCESSOR|PRINT_PREDECESSOR);
	  if(i_edge!=NULL&&
	      CFG_EDGE_TAIL(i_edge)!=NULL&&
	      BBL_INS_LAST(CFG_EDGE_TAIL(i_edge))!=NULL&&
	      ((G_T_UINT32(INS_OLD_ADDRESS(BBL_INS_LAST(CFG_EDGE_TAIL(i_edge))))
	       ==G_T_UINT32(INS_OLD_ADDRESS(BBL_INS_LAST(CFG_EDGE_HEAD(i_edge))))+4)||
	      (G_T_UINT32(INS_OLD_ADDRESS(BBL_INS_LAST(CFG_EDGE_TAIL(i_edge))))
	       ==G_T_UINT32(INS_OLD_ADDRESS(BBL_INS_LAST(CFG_EDGE_HEAD(i_edge))))+8)))
	  {
	    if(MIPSINSOPCODE(BBL_INS_LAST(i_bbl))==MIPS_J)
	    {
	      //BblPrint(i_bbl,PRINT_INSTRUCTIONS|PRINT_SUCCESSOR|PRINT_PREDECESSOR);
	      CfgEdgeKill(i_edge) ;
	      InsKill(BBL_INS_LAST(i_bbl));
	      CfgEdgeNew(cfg, i_bbl,INS_BBL(INS_NEXT(BBL_INS_LAST(i_bbl))), ET_FALLTHROUGH);
	    }
	    else if (INS_PREV(BBL_INS_LAST(i_bbl))!=NULL&&
		MIPSINSOPCODE(INS_PREV(BBL_INS_LAST(i_bbl)))==MIPS_J)
	    {
	      CfgEdgeKill(i_edge) ;
	      InsKill(INS_NEXT(BBL_INS_LAST(i_bbl)));
	      CfgEdgeNew(cfg, i_bbl,INS_BBL(INS_NEXT(BBL_INS_LAST(i_bbl))), ET_FALLTHROUGH);
	    }
	  }
	}
      }
    }
  }
}

void LoadStore64bits(t_cfg * cfg)
{
  t_bbl * i_bbl;
  t_ins * i_ins;
  //  DiabloPrint(stdout,"INSTR: Instruction optimizer opgeroepen!\n");

  CFG_FOREACH_BBL(cfg,i_bbl)
  {
    if (!BBL_FUN(i_bbl)) continue;

    BBL_FOREACH_INS(i_bbl,i_ins)
    {
      if(INS_NEXT(i_ins)!=NULL)
      {
	t_ins * i_next;
	i_next=INS_NEXT(i_ins);

	if(
	    MIPSINSOPCODE(i_ins)==MIPS_LWC1&&
	    MIPSINSOPCODE(i_next)==MIPS_LWC1&&
	    MIPSINSFT(i_ins)+1==MIPSINSFT(i_next)&&
	    MIPSINSBASE(i_ins)==MIPSINSBASE(i_next)//&&
	    //MIPSINSOFFSET(i_ins)==(MIPSINSOFFSET(i_next)+4)
	  )
	{
	  LWC1change(i_ins, i_next);
	}
	else if(
	    MIPSINSOPCODE(i_ins)==MIPS_SWC1&&
	    MIPSINSOPCODE(i_next)==MIPS_SWC1&&
	    MIPSINSFT(i_ins)+1==MIPSINSFT(i_next)&&
	    MIPSINSBASE(i_ins)==MIPSINSBASE(i_next)//&&
	    //MIPSINSOFFSET(i_ins)==(MIPSINSOFFSET(i_next)+4)
	    )
	{
	  SWC1change(i_ins, i_next);
	}

	continue;
      }
    }
  }
}

void LWC1change(t_ins * i_next, t_ins * ins)
{
  DiabloPrint(stdout,"INSTR: @I @I \n",ins,i_next);
  MIPSINSOPCODE(ins)=MIPS_LDC1;
  INS_ATTRIB(ins)|=IF_CHANGED; 
  MIPSINSFT(ins)-=1;

  INS_REGS_USE(ins) = MipsUsedRegisters(ins);
  INS_REGS_DEF(ins) = MipsDefinedRegisters(ins);

  MipsInstructionMakeNoop(i_next);
  DiabloPrint(stdout,"INSTR: naar:  @I @I \n",ins,i_next);

}

void SWC1change(t_ins * i_next, t_ins * ins)
{
  DiabloPrint(stdout,"INSTR: @I @I \n",ins,i_next);
  MIPSINSOPCODE(ins)=MIPS_SDC1;
  INS_ATTRIB(ins)|=IF_CHANGED; 
  MIPSINSFT(ins)-=1;

  INS_REGS_USE(ins) = MipsUsedRegisters(ins);
  INS_REGS_DEF(ins) = MipsDefinedRegisters(ins);

  MipsInstructionMakeNoop(i_next);
  DiabloPrint(stdout,"INSTR: naar:  @I @I \n",ins,i_next);

}
