/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../config.h"
#ifndef MIPS_REGISTERS_H
#define MIPS_REGISTERS_H
#include "../../datastructures/data_string.h"
#include "../../kernel/diablo_regset.h"
t_string MipsRegisterName(t_reg reg);
/*The MIPS32 registers*/
#define MIPS_REG_R0	0
#define MIPS_REG_R1	1
#define MIPS_REG_R2	2
#define MIPS_REG_R3	3
#define MIPS_REG_R4	4
#define MIPS_REG_R5	5
#define MIPS_REG_R6	6
#define MIPS_REG_R7	7
#define MIPS_REG_R8	8
#define MIPS_REG_R9	9
#define MIPS_REG_R10	10
#define MIPS_REG_R11	11
#define MIPS_REG_R12	12
#define MIPS_REG_R13	13
#define MIPS_REG_R14	14
#define MIPS_REG_R15	15
#define MIPS_REG_R16	16
#define MIPS_REG_R17	17
#define MIPS_REG_R18	18
#define MIPS_REG_R19	19
#define MIPS_REG_R20	20
#define MIPS_REG_R21	21
#define MIPS_REG_R22	22
#define MIPS_REG_R23	23
#define MIPS_REG_R24	24
#define MIPS_REG_R25	25
#define MIPS_REG_R26	26
#define MIPS_REG_R27	27
#define MIPS_REG_R28	28
#define MIPS_REG_R29	29
#define MIPS_REG_R30	30
#define MIPS_REG_R31	31
#define MIPS_REG_ZERO	0
#define MIPS_REG_AT	1
#define MIPS_REG_V0	2
#define MIPS_REG_V1	3
#define MIPS_REG_A0	4
#define MIPS_REG_A1	5
#define MIPS_REG_A2	6
#define MIPS_REG_A3	7
#define MIPS_REG_T0	8
#define MIPS_REG_T1	9
#define MIPS_REG_T2	10
#define MIPS_REG_T3	11
#define MIPS_REG_T4	12
#define MIPS_REG_T5	13
#define MIPS_REG_T6	14
#define MIPS_REG_T7	15
#define MIPS_REG_S0	16
#define MIPS_REG_S1	17
#define MIPS_REG_S2	18
#define MIPS_REG_S3	19
#define MIPS_REG_S4	20
#define MIPS_REG_S5	21
#define MIPS_REG_S6	22
#define MIPS_REG_S7	23
#define MIPS_REG_T8	24
#define MIPS_REG_T9	25
#define MIPS_REG_K0	26
#define MIPS_REG_K1	27
#define MIPS_REG_GP	28
#define MIPS_REG_SP	29
#define MIPS_REG_FP	30
#define MIPS_REG_S8	30
#define MIPS_REG_RA	31
#define MIPS_REG_SR	32
#define MIPS_REG_LO	33
#define MIPS_REG_HI	34
#define MIPS_REG_BAD	35	
#define MIPS_REG_CAUSE	36	
#define MIPS_REG_PC	37	
#define MIPS_REG_F0	38
#define MIPS_REG_F1	39
#define MIPS_REG_F2	40
#define MIPS_REG_F3	41
#define MIPS_REG_F4	42
#define MIPS_REG_F5	43
#define MIPS_REG_F6	44
#define MIPS_REG_F7	45
#define MIPS_REG_F8	46
#define MIPS_REG_F9	47
#define MIPS_REG_F10	48
#define MIPS_REG_F11	49
#define MIPS_REG_F12	50
#define MIPS_REG_F13	51
#define MIPS_REG_F14	52
#define MIPS_REG_F15	53
#define MIPS_REG_F16	54
#define MIPS_REG_F17	55
#define MIPS_REG_F18	56
#define MIPS_REG_F19	57
#define MIPS_REG_F20	58
#define MIPS_REG_F21	59
#define MIPS_REG_F22	60
#define MIPS_REG_F23	61
#define MIPS_REG_F24	62
#define MIPS_REG_F25	63
#define MIPS_REG_F26	64
#define MIPS_REG_F27	65
#define MIPS_REG_F28	66
#define MIPS_REG_F29	67
#define MIPS_REG_F30	68
#define MIPS_REG_F31	69
#define MIPS_REG_FIR	70
#define MIPS_REG_FCCR	71
#define MIPS_REG_FEXR	72
#define MIPS_REG_FENR	73
#define MIPS_REG_FCSR	74
#define MIPS_BRANCH_REG1	75
#define MIPS_BRANCH_REG2	76
#define MIPS_REG_NONE	255

#endif
/* vim: set shiftwidth=2: */
