/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/config.h,v 1.3 2003/12/03 09:59:16 bdebus Exp $ 
 * 
 * This files contains all system wide configuration parameters. 
 * It should be included FIRST in every other c-file 
 * 
 * Documentation: Complete
 * 
 */

#ifndef CONFIG_H
#define CONFIG_H
/* COLORS: Define COLORS to have 16-bit color output when outputting to a terminal. 
 * This could be problematic on terminals that do not support color-escapes
 */
#if 1
#define COLORS
#endif

#define INTERNAL static

/* CONFIG_NINS: The maximum number of instructions in a program. Should be unnecessary in a final version */
#define CONFIG_NINS 10000

/* CONFIG_GT_STACK_ALLOC_SIZE: The non-recursive graph traversal functions allocate stack to keep the 
 * already handled graph-nodes. Stack is reallocated every CONFIG_GT_STACK_ALLOC_SIZE elements */

#define CONFIG_GT_STACK_ALLOC_SIZE 10

/* CONFIG_DEFAULT_OBJPATH: a string containing the default path to objects seperated by : */
#define CONFIG_DEFAULT_OBJPATH "."
/* CONFIG_DEFAULT_LIBPATH: a string containing the default path to the libraries seperated by : */
#define CONFIG_DEFAULT_LIBPATH "."

/* CONFIG_MAX_FILE_LINE_LEN: The maximum length of a line in a file (used by MyGetLine) */
#define CONFIG_MAX_FILE_LINE_LEN 10000


#ifdef VISUALSTUDIO
#define HAVE_MKDIR
#endif

#ifdef ALPHA
#define strtoll strtol
#define POINTERSIZE64
#endif
 
#ifdef UNIX
#define HAVE_DIRS
#define HAVE_GETCWD
#define HAVE_IPC
#define HAVE_MKDIR
#define HAVE_MMAN
#define HAVE_NETWORKING
#define HAVE_STAT
#define HAVE_TIME
#define HAVE_UNISTD
#define HAVE_SYS_PARAM
#define HAVE_SYS_WAIT
#define HAVE_LIBGEN


/* Non c89 ! */
#ifndef __STRICT_ANSI__
#define HAVE_ISATTY
#define HAVE_FILENO
#endif

#endif

#endif

