/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include <stdlib.h>
#include "data_dll.h"
#include "../utils/util_error.h"

void RealAppendDLL(dll * prev, dll * insert, dll ** head, dll ** tail)
{
	if (prev)
	{
		DLLNext(insert)=DLLNext(prev);
		DLLPrev(insert)=prev;
		DLLNext(prev)=insert;
		if (DLLNext(insert)) DLLPrev(DLLNext(insert))=insert;
		else if (tail) *tail=insert;
	}
	else if (head)
	{
		DLLNext(insert)=*head;
		if (*head) DLLPrev(*head)=insert;
		else if (tail) *tail=insert;
		DLLPrev(insert)=NULL;
		*head=insert;
	}
	else
	{
	    FATAL(("Could not append node!"));	
	}
}

void RealAppendDLLSorted(data_dll_elem * insert, data_dll_elem ** head, data_dll_elem ** tail)
{
  data_dll_elem * iter1 = *head;
  if(iter1)
  {
    if(iter1->data > insert->data)
    {
      DLLAppend(NULL,insert,head,tail);
      return;
    }
    while(DLLNext(iter1) && DLLData(DLLNext(iter1)) < insert->data) iter1 = DLLNext(iter1);

    DLLAppend(iter1,insert,head,tail);
    return;
  }
  DLLAppend(NULL,insert,head,tail);
  return;
}

void RealUnlinkDLL(dll * del, dll ** head, dll ** tail)
{
    if (DLLNext(del)) DLLPrev(DLLNext(del))=DLLPrev(del);
    if (DLLPrev(del)) DLLNext(DLLPrev(del))=DLLNext(del);
    if ((head) && (del==(*head))) (*head)=DLLNext(del);
    if ((tail) && (del==(*tail))) (*tail)=DLLPrev(del);
    DLLNext(del) = DLLPrev(del) = NULL;
}
