/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/datastructures/data_dll.h,v 1.2 2004/05/03 11:20:11 lvanput Exp $ */
#ifndef MY_DLL_H
#define MY_DLL_H
#define DLLNext(x) ((void *) (((dll *) x)->next))
#define DLLPrev(x) ((void *) (((dll *) x)->prev))
#define DLLAppend(to,ins,head,tail)	RealAppendDLL((dll *) to,(dll *) ins,(dll **) head,(dll **) tail)
#define DLLAppendSorted(ins,head,tail)	RealAppendDLLSorted((data_dll_elem *) ins,(data_dll_elem **) head, (data_dll_elem**)tail)
#define DLLUnlink(del,head,tail)	RealUnlinkDLL((dll *) del,(dll **) head,(dll **) tail)
#define DLLData(x) (((data_dll_elem*) x)->data)
typedef struct _dll
{
	struct _dll * next;
	struct _dll * prev;
} dll;

typedef struct _data_dll_elem
{
  dll  dll;
  void * data;
} data_dll_elem;


void RealUnlinkDLL(dll * del, dll ** head, dll ** tail);
void RealAppendDLL(dll * prev, dll * insert, dll ** head, dll ** tail);
void RealAppendDLLSorted(data_dll_elem * insert, data_dll_elem ** head, data_dll_elem ** tail);
#endif
