/*
 *{{{ Copyright 2001,2002,2003:
 *			Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/datastructures/data_ll.h,v 1.4 2004/07/02 11:57:55 lvanput Exp $ */
/* }}}*/
#ifndef MY_LL_H
#define MY_LL_H

#include "../utils/util_malloc.h"

#define LLNext(x) ((void *) (((ll *) x)->next))
#define LLAppend(prev,ins,head)	RealAppendLL((ll *) prev,(ll *) ins,(ll **) head)
#define LLAppendSorted(ins,head) RealAppendLLSorted((ll *)ins, (ll **) head)
#define LLAppendSortedCached(ins,head) RealAppendLLSortedCached((ll *)ins, (ll **) head)
#define LLData(ill)	(((data_ll_elem*)ill)->data)
#define LLUnlink(prev,ill,head)	RealUnlinkLL((ll*) prev,(ll*) ill, (ll**)head)

typedef struct _ll
{
	struct _ll * next;
} ll;

typedef struct _data_ll_elem
{
  ll  ll;
  void * data;
} data_ll_elem;

void RealAppendLL(ll * prev, ll * insert, ll ** head);
void RealAppendLLSorted(ll * insert, ll ** head);
void RealAppendLLSortedCached(ll * insert, ll ** head);
void RealUnlinkLL(ll* prev, ll * unlink, ll** head);
data_ll_elem * LLCalloc(void* param);
void LLFree(data_ll_elem* to_free);
void LLFinalise(void);
void LLListCleanup(data_ll_elem ** start);
#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
