/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _MYDLLSTACK_
#define _MYDLLSTACK_

#include "data_dll.h"

typedef struct _data_stack
{
  dll* bottom;
  dll* top;
} data_stack;

#define PUSH(stack,elem)	DLLAppend(NULL,(dll*)elem,&((stack)->top),&((stack)->bottom))
#define POP(stack,elem)		do {elem = (dll*)((stack)->top); DLLUnlink((stack)->top,&((stack)->top),&((stack)->bottom)); } while(0)
#define STACK_NOT_EMPTY(stack)	((stack)->top != NULL)



#endif
