/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */#include <stdio.h>
#include "../../config.h"
#include "../../utils/util_error.h"
#include "../../simple_types.h"
#include "../../kernel/diablo_object.h"
#include "aif_main.h"

/* Currently only decompressed and not self-relocating aif binarioes are recogniozed */
t_bool IsAif(FILE * fp)
{
    AIF_HDR hdr;
    t_uint32 ins;
    long fpos=ftell(fp);
    fread(&hdr,sizeof(AIF_HDR),1,fp);
    fseek(fp,fpos,SEEK_SET);
    
    if ((hdr.pad1[0]!=0) || (hdr.pad1[1]!=0) || (hdr.pad1[2]!=0) || (hdr.pad1[3]!=0) || (hdr.pad1[4]!=0) || (hdr.pad1[5]!=0) || (hdr.pad1[6]!=0) || (hdr.pad1[7]!=0))
       return FALSE;
    ins=*((t_uint32 *) &hdr.Decompress);
    if ((ins!=0xe1a00000)&&((ins&0xea000000)!=0xea000000)) /* Uncompressed aif and compressed aif */
       return FALSE;
    ins=*((t_uint32 *) &hdr.SelfReloc);
    printf("Second pass aif\n");
    if (ins!=0xe1a00000)
       return FALSE;
    return TRUE;
}

void ReadAif(FILE * fp, t_object * obj)
{
   FATAL(("Currently aif is not supported and since it does not include some basic information it probably never will"));
}
