/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifdef ALPHA_SUPPORT
#include "../../config.h"
#include "../../simple_types.h"
#include "../../kernel/diablo_ins.h"
#include "elf_main.h"
#include "elf_armsupport.h"
#include "../../utils/util_machine.h"
#include "../../utils/util_status.h"
#include "../../utils/util_malloc.h"
#include "../../utils/util_error.h"
#include "../../kernel/diablo_object.h"


void ElfReadAlphaSwitchedEndian(FILE * fp, void * hdr, void * data, t_object * obj)
{
   Elf64_Shdr * shdrs=NULL;
   Elf64_Sym * symbol_table=NULL;
   char * strtab=NULL;
   int numsyms=0;
   char * sechdrstrtab=NULL;
/*   Elf64_Ehdr * hdr64=(Elf64_Ehdr *) hdr;
*/
   /* Reading elf headers does not depend on the type of objectfile */
   ElfReadCommon64(fp, hdr, data, obj, &shdrs, &symbol_table, &numsyms, &strtab, &sechdrstrtab,TRUE); 

   FATAL(("Alpha binaries on a machine with different endianness currently not supported."));
}

void ElfReadAlphaSameEndian(FILE * fp, void * hdr, void * data, t_object * obj)
{
   Elf64_Shdr * shdrs=NULL;
   Elf64_Sym * symbol_table=NULL;
   char * strtab=NULL;
   int numsyms=0;
   char * sechdrstrtab=NULL;
/*   Elf64_Ehdr * hdr64=(Elf64_Ehdr *) hdr;
*/
   /* Reading elf headers does not depend on the type of objectfile */
   ElfReadCommon64(fp, hdr, data, obj, &shdrs, &symbol_table, &numsyms, &strtab, &sechdrstrtab,FALSE); 

   FATAL(("Alpha binaries on a machine with same endianness currently not supported."));
}
#endif

