/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef ELF_POWERPC
#define ELF_POWERPC
#include "../../kernel/diablo_object.h"
#include "elf_main.h"
#include <string.h>
#include "elf_types.h"
#include "elf_endian.h"
//#include "elf_i386.h"
//#include "elf_i386.c"



void ElfWritePowerpcSameEndian (t_object * obj, t_string filename);
void   ElfReadPowerpcSameEndian(FILE * fp, t_object * obj);
void   ElfReadPowerpcSwitchedEndian(FILE * fp, t_object * obj);
t_bool IsElfPowerpcSameEndianOnLsb(FILE * fp);
t_bool IsElfPowerpcSameEndianOnMsb(FILE * fp);
t_bool IsElfPowerpcSwitchedEndianOnLsb(FILE * fp);
t_bool IsElfPowerpcSwitchedEndianOnMsb(FILE * fp);
void PowerpcElfWriteSameEndian(FILE * fp, Elf32_Ehdr * hdr, t_object * obj, int pagesize);	

#endif
