/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef ELF_SH3
#define ELF_SH3
#include "../../kernel/diablo_object.h"

#define EF_SH_MACH_MASK	0x1f
#define EF_SH_UNKNOWN	   0 /* For backwards compatibility.  */
#define EF_SH1		   1
#define EF_SH2		   2
#define EF_SH3		   3
#define EF_SH_HAS_DSP(flags) ((flags) & 4)
#define EF_SH_DSP	   4
#define EF_SH3_DSP	   5
#define EF_SH_HAS_FP(flags) ((flags) & 8)
#define EF_SH3E		   8
#define EF_SH4		   9

/* This one can only mix in objects from other EF_SH5 objects.  */
#define EF_SH5		  10
 
void ElfReadSh3SameEndian(FILE * fp, t_object * obj);
void ElfReadSh3SwitchedEndian(FILE * fp, t_object * obj);
void ElfWriteSh3SameEndian(t_object * obj, t_string filename);
t_bool IsElfSh3SameEndianOnLsb(FILE * fp);
t_bool IsElfSh3SameEndianOnMsb(FILE * fp);
t_bool IsElfSh3SwitchedEndianOnLsb(FILE * fp);
t_bool IsElfSh3SwitchedEndianOnMsb(FILE * fp);
#endif
