/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifdef SPARC_SUPPORT
#include "../../config.h"
#include "../../simple_types.h"
#include "../../kernel/diablo_ins.h"
#include "elf_main.h"
#include "elf_armsupport.h"
#include "../../utils/util_machine.h"
#include "../../utils/util_status.h"
#include "../../utils/util_malloc.h"
#include "../../utils/util_error.h"
#include "../../kernel/diablo_object.h"


void ElfReadSparcSameEndian(FILE * fp, void  * hdr, void * data, t_object * obj)
{
   Elf32_Shdr * shdrs=NULL;
   Elf32_Sym * symbol_table=NULL;
   char * strtab=NULL;
   int numsyms=0;
   char * sechdrstrtab=NULL;
   t_symbol ** table;

   /* Reading elf headers does not depend on the type of objectfile */
   ElfReadCommon32(fp, hdr, data, obj, &shdrs, &symbol_table, &numsyms, &strtab, &sechdrstrtab,&table,FALSE); 

   FATAL(("Sparc ELF relocations currently not supported"));
}

void ElfReadSparcSwitchedEndian(FILE * fp, void * hdr, void * data, t_object * obj)
{

   FATAL(("Sparc ELF on an machine with different endianness currently not supported. Support for Sparc ELF on machines with the same endianness is very rudementary"));
}
#endif
