/******************************************************************************
 * Copyright 2001,2002,2003: {{{ 
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be)  }}}
 *****************************************************************************/

#include "../config.h"
#include "diablo_archive_tables.h"
#include "../fileformats/ar/ar_arch.h"
#ifdef JAVA_SUPPORT
#include "../fileformats/jar/jar_arch.h"
#endif


const t_archive_handlers archive_handler_table[]=
{ 
  { AT_ARCH_AR,       IsArchAr, ArchArOpen }, 
  { AT_ARCH_AR_ALPHA, IsArchAlphaAr, ArchAlphaArOpen },
#ifdef JAVA_SUPPORT 
  { AT_ARCH_JAR,   IsArchJar, ArchJarOpen },
#endif
  { AT_UNKNOWN, NULL, NULL}
};
/* vim: set shiftwidth=2 foldmethod=marker: */
