/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


#ifndef DIABLO_CODE_LAYOUT_TYPEDEFS
#define DIABLO_CODE_LAYOUT_TYPEDEFS
typedef struct _t_chain_holder t_chain_holder;
#endif

#ifndef DIABLO_CODE_LAYOUT_H
#define DIABLO_CODE_LAYOUT_H

#include <stdlib.h>
#include <string.h>
#include "diablo_object.h"
#include "diablo_section.h"
#include "diablo_print.h"
#include "diablo_iterators.h"
#include "../utils/util_error.h"

struct _t_chain_holder {
  t_bbl ** chains;
  t_uint32 nchains;
};

extern t_address AssignAddressesInChain(t_bbl * bbl, t_address start);
extern void CreateChains(t_cfg * cfg, t_chain_holder * ch);
extern void DefaultOrderChains(t_chain_holder * ch);
extern void DefaultGiveAddressesToChain(t_address start_address, t_chain_holder * ch);

#endif
