/******************************************************************************
 * Copyright 2001,2002,2003: {{{ 
 *
 * Bruno De Bus, Bjorn De Sutter, Dominique Chanet, Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Written by Bruno De Bus (bdebus@elis.rug.ac.be)
 *
 * Copyright (c) 2002 Bruno De Bus
 *
 * THIS FILE IS PART OF DIABLO (KERNEL)
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

#include <string.h>
#include "diablo_flowgraph.h"
#include "diablo_object.h"
#include "diablo_description.h"

void ArchCall(char * name,t_cfg * cfg)
{
  const t_arch_specific_optimization * opts;
  t_object * obj=CFG_OBJECT(cfg);
  if (!obj->description) return;
  if (!obj->description->opts) return;

  opts=obj->description->opts;
  while(opts->name)
  {
    if (strcmp(name,opts->name)==0)
    {
      printf("Calling %s\n",name);
      opts->callback(cfg);
      return;
    }
    else
    {
      opts++;
    }
  }
}
/* vim: set shiftwidth=2 foldmethod=marker: */
