/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***********************************************************/
#define T_BBL_HE(x) ((t_bbl_he*)(x))
#define T_FINGER(x) ((t_finger*)(x)) 

#ifndef DIABLO_FACTOR_TYPEDEFS
#define DIABLO_FACTOR_TYPEDEFS
typedef struct _t_bbl_he t_bbl_he;
typedef struct _t_finger t_finger;			/* to easily adapt the sort of fingerprint (int, struct,...)*/
#endif


#ifndef DIABLO_FACTOR_H
#define DIABLO_FACTOR_H
struct _t_bbl_he
{
  data_hash_node node;
  t_bbl * bbl;
  t_bbl_he * ident;
};

struct _t_finger
{
  t_uint32 nins;
  t_uint8* opc;						/*pointer to array of opcodes (in 8 bits)*/
};




void Factor (t_cfg *cfg);
data_hash_table * BblPart(t_cfg * cfg);
void * BblFinger(t_bbl *bbl);
t_uint32 BblHash(data_hash_table * table, void * bblhe);
my_cmpresult BblFingComp(void* bblhe, void* bblhe2);
void BblHeFree (void* bblhe,void* data);
void BblHePrint(void* bblhe,void* data);

#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
