/* Functions */

#define FUN_FOREACH_BBL(fun,bbl)\
   for (bbl=FUN_BBL_FIRST(fun); bbl!=NULL; bbl=BBL_NEXT_IN_FUN(bbl))
#define FUN_FOREACH_BBL_R(fun,bbl)\
   for (bbl=FUN_BBL_LAST(fun); bbl!=NULL; bbl=BBL_PREV_IN_FUN(bbl))
#define FUN_FOREACH_BBL_SAFE(fun,bbl,tmp)\
   for(bbl=FUN_BBL_FIRST(fun), tmp=BBL_NEXT_IN_FUN(bbl); bbl!=NULL; bbl=tmp, tmp=(bbl==NULL)?NULL:BBL_NEXT_IN_FUN(bbl))
#define FUN_FOREACH_BBL_SAFE_R(fun,bbl,tmp)\
   for(bbl=FUN_BBL_LAST(fun), tmp=BBL_PREV_IN_FUN(bbl); bbl!=NULL; bbl=tmp, tmp=(bbl==NULL)?NULL:BBL_PREV_IN_FUN(bbl))

#define FUN_FOREACH_CALLEE(fun,edge,callee)\
   for (edge=T_CG_EDGE(NODE_SUCC_FIRST(CgFindNode(fun->cfg->cg,fun))), callee = (edge==NULL)?NULL:CG_NODE_FUN(CG_EDGE_TAIL(edge)); edge; edge=T_CG_EDGE(EDGE_SUCC_NEXT(edge)),callee=(edge==NULL)?NULL:CG_NODE_FUN(CG_EDGE_TAIL(edge)))

/* Bbl -> ??? */

#define BBL_FOREACH_DOMINATES(ibbl, llelem, jbbl)\
   for (llelem = BBL_DOMINATES(ibbl), jbbl = T_BBL(llelem->data); llelem!=NULL; llelem = LLNext(llelem), jbbl = (llelem?llelem->data:NULL))
#define BBL_FOREACH_PDOMINATES(ibbl, llelem, jbbl)\
   for (llelem = BBL_PDOMINATES(ibbl), jbbl = T_BBL(llelem->data); llelem!=NULL; llelem = LLNext(llelem), jbbl = (llelem?llelem->data:NULL))
#define BBL_FOREACH_SUCC_EDGE(bbl,edge)\
   for (edge=T_CFG_EDGE(NODE_SUCC_FIRST(bbl)); edge!=NULL; edge=T_CFG_EDGE(EDGE_SUCC_NEXT(edge)))
#define BBL_FOREACH_SUCC_EDGE_SAFE(bbl,edge,tmp)\
   for (edge=T_CFG_EDGE(NODE_SUCC_FIRST(bbl)), tmp=edge?T_CFG_EDGE(EDGE_SUCC_NEXT(edge)):NULL; edge!=NULL; edge= tmp, tmp=edge?T_CFG_EDGE(EDGE_SUCC_NEXT(edge)):NULL)
#define BBL_FOREACH_PRED_EDGE(bbl,edge)\
   for (edge=T_CFG_EDGE(NODE_PRED_FIRST(bbl)); edge!=NULL; edge=T_CFG_EDGE(EDGE_PRED_NEXT(edge)))
#define BBL_FOREACH_PRED_EDGE_SAFE(bbl,edge,tmp) for (edge=T_CFG_EDGE(NODE_PRED_FIRST(bbl)), tmp=edge?T_CFG_EDGE(EDGE_PRED_NEXT(edge)):NULL; edge!=NULL; edge= tmp, tmp=edge?T_CFG_EDGE(EDGE_PRED_NEXT(edge)):NULL)

#define BBL_FOREACH_INS(bbl,ins) for(ins=bbl->ins_first; ins!=NULL; ins=INS_NEXT(ins))
#define BBL_FOREACH_INS_R(bbl,ins) for(ins=BBL_INS_LAST(bbl); ins!=NULL; ins=INS_PREV(ins))
#define BBL_FOREACH_INS_SAFE(bbl,ins,tmp)   for(ins=BBL_INS_FIRST(bbl), tmp=ins?INS_NEXT(ins):0; ins!=NULL; ins=tmp, tmp=ins?INS_NEXT(ins):0)
#define BBL_FOREACH_INS_R_SAFE(bbl,ins,tmp) for(ins=BBL_INS_LAST(bbl), tmp=ins?INS_PREV(ins):0; ins!=NULL; ins=tmp, tmp=ins?INS_PREV(ins):0)

#define CFG_WHILE_MARKED_BBLS_PER_FUN(cfg,fun,bbl,big_change,small_change)\
  CFG_FOREACH_FUN(cfg,fun) FUN_FLAGS(fun)&=~FF_IS_MARKED;\
  CFG_FOREACH_BBL(cfg,bbl) if (NodeIsMarked(bbl) && BBL_FUN(bbl)) FUN_FLAGS(BBL_FUN(bbl))|=FF_IS_MARKED;\
  big_change = TRUE;\
  while (!(big_change=!big_change)) \
  CFG_FOREACH_FUN(cfg,fun)\
  if ( (!(FUN_FLAGS(fun)&FF_IS_MARKED)) || ((FUN_FLAGS(fun)&=~FF_IS_MARKED) && 0)) continue;\
  else while (!(small_change=!small_change))\
  FUN_FOREACH_BBL(fun,bbl)\
  if( !NodeIsMarked(bbl) || ((NodeUnmark(bbl)) && 0)) continue;\
  else 

/* Sec -> ??? */
   
#define SECTION_FOREACH_INS(code,ins) for(ins=code->data; ins!=NULL; ins=INS_NEXT(ins))
#define SECTION_FOREACH_EDGE(section,edge)\
   for(edge=(t_cfg_edge *) (T_GRAPH(section->data))->edge_first; edge!=NULL; edge=T_CFG_EDGE(EDGE_NEXT(edge)))

#define SECTION_FOREACH_EDGE_SAFE(section,edge,tmp)\
   for(edge=(diablo_edge *) ((diablo_flowgraph *) section->data)->graph->first_edge,tmp =(diablo_edge *) (edge?((t_edge *) edge)->next:NULL); edge!=NULL; edge=tmp, tmp=(diablo_edge *) (edge?((t_edge *) edge)->next:NULL))


#define SECTION_FOREACH_FUNCTION(section,func) for (func=((t_cfg *) ((section)->data))->fun_first; func!=NULL; func=func->next) 

/* Cg -> ??? */

#define CG_FOREACH_NODE(graph,node)\
   for (node=T_CG_NODE(GRAPH_NODE_FIRST(graph)); node!=NULL; node=T_CG_NODE(NODE_NEXT(node)))

#define CG_FOREACH_NODE_FUN(graph,node,fun)\
   for (node=T_CG_NODE(GRAPH_NODE_FIRST(graph)), fun = (node==NULL)?NULL:CG_NODE_FUN(node); node; node=T_CG_NODE(NODE_NEXT(node)), fun = (node==NULL)?NULL:CG_NODE_FUN(node))

/* Cfg -> ??? */

#define CFG_FOREACH_BBL(graph,bbl)\
   for (bbl=T_BBL(GRAPH_NODE_FIRST(graph)); bbl!=NULL; bbl=T_BBL(NODE_NEXT(bbl)))

#define CFG_FOREACH_FUN(cfg,fun) for (fun=CFG_FUN_FIRST(cfg); fun!=NULL; fun=FUN_NEXT(fun))
#define CFG_FOREACH_FUN_SAFE(cfg,fun,tmp) for (fun=CFG_FUN_FIRST(cfg), tmp=fun?FUN_NEXT(fun):NULL; fun!=NULL; fun=tmp, tmp=fun?FUN_NEXT(fun):NULL)
#define CFG_FOREACH_LOOP(cfg,loop) for (loop=CFG_LOOP_FIRST(cfg); loop!=NULL; loop=LOOP_NEXT(loop))

#define CFG_FOREACH_BBL_SAFE(graph,bbl,safe)\
   for (bbl=T_BBL(GRAPH_NODE_FIRST(graph)),safe=bbl?T_BBL(NODE_NEXT(bbl)):NULL; bbl!=NULL; bbl=safe,safe=bbl?T_BBL(NODE_NEXT(bbl)):NULL)

#define CFG_FOREACH_EDGE(graph,edge) for (edge=T_CFG_EDGE(GRAPH_EDGE_FIRST(graph)); edge!=NULL; edge=T_CFG_EDGE(EDGE_NEXT(edge)))

#define CFG_FOREACH_EDGE_SAFE(graph,edge,tmp) for (edge=T_CFG_EDGE(GRAPH_EDGE_FIRST(graph)), tmp=edge?T_CFG_EDGE(EDGE_NEXT(edge)):NULL; edge!=NULL; edge = tmp, tmp = edge?T_CFG_EDGE(EDGE_NEXT(edge)):NULL)

#define RELOCATABLE_FOREACH_E_REFED_BY(x,ref) for (ref=RELOCATABLE_E_REFED_BY(x);ref!=NULL;ref=ref->next)
#define RELOCATABLE_FOREACH_E_REFED_BY_SAFE(x,ref,tmp) for (ref=RELOCATABLE_E_REFED_BY(x),tmp=(ref?ref->next:NULL);ref!=NULL;ref=tmp,tmp=(ref?ref->next:NULL))




/* Loops */

#define LOOP_FOREACH_BBL(loop,iterator,bbl)	for(iterator = LoopNewIterator(loop),bbl = LoopGetNextBbl(iterator); bbl!= NULL;bbl = LoopGetNextBbl(iterator))
#define LOOP_FOREACH_BBL_INTRAFUN(loop,iterator,bbl)	for(iterator = LoopNewIterator(loop),bbl = LoopGetNextBbl(iterator); bbl!= NULL;bbl = LoopGetNextBbl(iterator)) if(BBL_FUN(bbl) == BBL_FUN(LOOP_HEADER(loop)))
#define LOOP_FOREACH_ENTRY_EDGE(loop,edge)      BBL_FOREACH_PRED_EDGE(LOOP_HEADER(loop),edge) if (!LoopContainsBbl(loop,CFG_EDGE_HEAD(edge)))

#define LOOP_FOREACH_EXIT_EDGE(loop,iterator,bbl,edge) for(iterator = LoopNewIterator(loop),bbl = LoopGetNextBbl(iterator), edge=BBL_SUCC_FIRST(bbl);\
                                                   bbl!= NULL && edge!=NULL; \
                                                   edge = T_CFG_EDGE(EDGE_SUCC_NEXT(edge)), bbl=(edge==NULL)?LoopGetNextBbl(iterator):bbl, edge=(edge!=NULL || bbl==NULL)?edge:BBL_SUCC_FIRST(bbl)) \
                                                 if (!LoopContainsBbl(loop,CFG_EDGE_TAIL(edge)))

#if 0
#define LOOP_FOREACH_EXIT_EDGE_SAFE(loop,bbl,edge,safe) for( LoopInitIterator(loop),bbl = LoopGetNextBbl(loop), edge=BBL_SUCC_FIRST(bbl), safe=edge?T_CFG_EDGE(EDGE_NEXT(edge)):NULL;\
                                                   bbl!= NULL && edge!=NULL; \
                                                   edge = T_CFG_EDGE(EDGE_SUCC_NEXT(edge)), bbl=(edge==NULL)?LoopGetNextBbl(loop):bbl, edge=(bbl==NULL && edge==NULL)?edge:BBL_SUCC_FIRST(bbl),safe=edge?T_CFG_EDGE(EDGE_NEXT(edge)):NULL) \
                                                 if (!LoopContainsBbl(loop,CFG_EDGE_TAIL(edge)))
#endif
#define LOOP_FOREACH_EXIT_EDGE_SAFE(loop,iterator,bbl,edge,safe) for(iterator = LoopNewIterator(loop),bbl = LoopGetNextBbl(iterator); bbl!= NULL;bbl = LoopGetNextBbl(iterator)) \
                                                BBL_FOREACH_SUCC_EDGE_SAFE(bbl,edge,safe) if (!LoopContainsBbl(loop,CFG_EDGE_TAIL(edge)))

#define BBL_FOREACH_LOOP(bbl,loopref,loop) for(loopref=BBL_LOOPS(bbl),loop=loopref?loopref->loop:NULL;loop;loopref=LLNext(loopref),loop=loopref?loopref->loop:NULL)

                                                

/* Objects */

#define OBJECT_FOREACH_SUBOBJECT(obj,sub_obj,tmp)  for(tmp=obj->mapped_first; tmp!=NULL; tmp=tmp->next) for (sub_obj=tmp; sub_obj!=NULL; sub_obj=sub_obj->equal)

#define SECTIONARRAYPOINTERBYNUMBER(obj,number) (((number & 0x1f00000)==0x0)?&(obj->code):(((number & 0x1f00000)==0x100000)?&(obj->data):(((number & 0x1f00000)==0x200000)?&(obj->rodata):(((number & 0x1f00000)==0x300000)?&(obj->note):(((number & 0x1f00000)==0x400000)?&(obj->bss):NULL)))))
#define SECTIONARRAYBYNUMBER(obj,number) (((number & 0x1f00000)==0x0)?obj->code:(((number & 0x1f00000)==0x100000)?obj->data:(((number & 0x1f00000)==0x200000)?obj->rodata:(((number & 0x1f00000)==0x300000)?obj->note:(((number & 0x1f00000)==0x400000)?obj->bss:NULL)))))
#define SECTIONCOUNTPOINTERBYNUMBER(obj,number) (((number & 0x1f00000)==0x0)?&(obj->ncodes):(((number & 0x1f00000)==0x100000)?&(obj->ndatas):(((number & 0x1f00000)==0x200000)?&(obj->nrodatas):(((number & 0x1f00000)==0x300000)?&(obj->nnotes):(((number & 0x1f00000)==0x400000)?&(obj->nbsss):NULL)))))
#define SECTIONCOUNTBYNUMBER(obj,number) (((number & 0x1f00000)==0x0)?obj->ncodes:(((number & 0x1f00000)==0x100000)?obj->ndatas:(((number & 0x1f00000)==0x200000)?obj->nrodatas:(((number & 0x1f00000)==0x300000)?obj->nnotes:(((number & 0x1f00000)==0x400000)?obj->nbsss:0)))))
   
#define OBJECT_FOREACH_SECTION(obj, sec, tel) for (tel=0; (tel&0x1f00000)<0x500000; tel+=0x100000, tel&=~0xfffff) for (sec=SECTIONARRAYBYNUMBER(obj,tel)?SECTIONARRAYBYNUMBER(obj,tel)[0]:NULL; ((tel&0xfffff)<SECTIONCOUNTBYNUMBER(obj,tel)); tel++, sec=((tel&0xfffff)<SECTIONCOUNTBYNUMBER(obj,tel))?SECTIONARRAYBYNUMBER(obj,tel)[tel&0xfffff]:NULL)

/* Regset 

#define REGSET_FOREACH_REG(r,i)    for (i=LL(0);i<MAX_REG_ITERATOR;i++) if (RegsetIn(r,i))
#define REGSET_FOREACH_REG_INVERSE(r,i) for (i=(MAX_REG_ITERATOR-1);i>=0;i--) if (RegsetIn(r,i))
#define REGSET_FOREACH_SINGLETON_REGSET(r,i,j) for (i=LL(0),RegsetSetSingleton(j,0);i<MAX_REG_ITERATOR;i++,j=RegsetNextSingleton(j)) if (RegsetIn(r,i))
#define FOREACH_REG(i) for (i=LL(0);i<MAX_REG_ITERATOR;i++)
#define REGSET_FOREACH_REG(r,i)    for (i=LL(0);i<MAX_REG_ITERATOR;i++) if (RegsetIn(r,i))
#define REGSET_FOREACH_REG_INVERSE(r,i) for (i=(MAX_REG_ITERATOR-1);i>=0;i--) if (RegsetIn(r,i))
#define REGSET_FOREACH_SINGLETON_REGSET(r,i,j) for (i=LL(0),j=LL(1);i<MAX_REG_ITERATOR;i++,j<<=1) if (RegsetIn(r,i))
#define FOREACH_REG(i) for (i=LL(0);i<MAX_REG_ITERATOR;i++)
*/
/* Relocs */

#define OBJECT_FOREACH_RELOC(object,relptr) for (relptr=object->reloc_table->first; relptr!=NULL; relptr=REL_NEXT(relptr)) 
#define OBJECT_FOREACH_RELOC_R(object,relptr) for (relptr=object->reloc_table->last; relptr!=NULL; relptr=REL_PREV(relptr)) 
#define OBJECT_FOREACH_RELOC_SAFE(object,relptr,tmpptr) for (relptr=object->reloc_table->first,tmpptr=relptr?REL_NEXT(relptr):NULL; relptr!=NULL; relptr=tmpptr,tmpptr=relptr?REL_NEXT(relptr):NULL) 


/* Symbols */
#define OBJECT_FOREACH_SYMBOL(object,symptr) for (symptr=object->symbol_table->first; symptr!=NULL; symptr=symptr->next) 
#define SYMBOLTABLE_FOREACH_SYMBOL(symboltable,symptr) for (symptr=symboltable->first; symptr!=NULL; symptr=symptr->next) 
#define OBJECT_FOREACH_SYMBOL_SAFE(object,symptr,tmpptr) for (symptr=object->symbol_table->first,tmpptr=symptr?symptr->next:NULL; symptr!=NULL; symptr=tmpptr,tmpptr=symptr?symptr->next:NULL) 
