/* A Bison parser, made from diablo_layout_scripts_parser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse lparseparse
#define yylex lparselex
#define yyerror lparseerror
#define yylval lparselval
#define yychar lparsechar
#define yydebug lparsedebug
#define yynerrs lparsenerrs
# define	SEGMENT_START	257
# define	SEGMENT_END	258
# define	PUT_REMAINING_SECTIONS	259
# define	SECTIONS	260
# define	ALIGN	261
# define	PROVIDE	262
# define	IDENTIFIER	263
# define	NUMBER	264
# define	UMINUS	265

#line 1 "diablo_layout_scripts_parser.y"

/******************************************************************************
 * Copyright 2001,2002,2003:  {{{
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * DESC: This file contains the main object-file routines 
 * 
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}} 
 *****************************************************************************/
#include <string.h>
#include "diablo_layout_script.h"
#include "diablo_object.h"
#include "../utils/util_error.h"
#include "../utils/util_malloc.h"
#include "../kernel/diablo_print.h"
#include "../fileformats/elf/elf_main.h"
#include "../simple_types.h"

extern t_segment * gseg;
int lparselex(void);
static int lparseerror(char * s);

static t_layout_exp * new_exp(int operator, void * arg1, void * arg2);

static t_layout_rule * last_rule = NULL;
static t_layout_rule * complete_script = NULL;

#line 50 "diablo_layout_scripts_parser.y"
#ifndef YYSTYPE
typedef union {
  t_string string;
  long long longlong;
  t_layout_exp * layout_exp;
  t_layout_rule * layout_rule;
  t_layout_assign * layout_assign;
  t_layout_secspec * layout_secspec;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		76
#define	YYFLAG		-32768
#define	YYNTBASE	27

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 265 ? yytranslate[x] : 37)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    23,     2,     2,     2,    12,     2,
      22,    24,    15,    13,     2,    14,     2,    16,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    25,    21,
       2,    26,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    19,    11,    20,    17,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    18
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     5,     8,    10,    12,    15,    18,    25,    32,
      37,    45,    46,    48,    49,    52,    53,    56,    60,    67,
      72,    76,    79,    82,    86,    90,    94,    98,   102,   106,
     108
};
static const short yyrhs[] =
{
       6,    19,    28,    20,     0,    28,    29,     0,    29,     0,
      31,     0,    35,    21,     0,    30,    21,     0,     3,    22,
      23,     9,    23,    24,     0,     4,    22,    23,     9,    23,
      24,     0,     5,    22,     9,    24,     0,     9,    32,    25,
      19,    33,    20,    34,     0,     0,    36,     0,     0,    35,
      21,     0,     0,    26,    36,     0,     9,    26,    36,     0,
       8,    22,     9,    26,    36,    24,     0,     7,    22,    36,
      24,     0,    22,    36,    24,     0,    14,    36,     0,    17,
      36,     0,    36,    13,    36,     0,    36,    14,    36,     0,
      36,    15,    36,     0,    36,    16,    36,     0,    36,    12,
      36,     0,    36,    11,    36,     0,    10,     0,     9,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    84,    87,    93,    96,   103,   110,   115,   122,   129,
     164,   174,   175,   178,   179,   182,   183,   186,   193,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "SEGMENT_START", "SEGMENT_END", 
  "PUT_REMAINING_SECTIONS", "SECTIONS", "ALIGN", "PROVIDE", "IDENTIFIER", 
  "NUMBER", "'|'", "'&'", "'+'", "'-'", "'*'", "'/'", "'~'", "UMINUS", 
  "'{'", "'}'", "';'", "'('", "'\\\"'", "')'", "':'", "'='", 
  "layout_script", "rules", "rule", "command", "section_spec", 
  "opt_address", "opt_endalign", "opt_filler", "assign", "exp", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    27,    28,    28,    29,    29,    29,    30,    30,    30,
      31,    32,    32,    33,    33,    34,    34,    35,    35,    36,
      36,    36,    36,    36,    36,    36,    36,    36,    36,    36,
      36
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     4,     2,     1,     1,     2,     2,     6,     6,     4,
       7,     0,     1,     0,     2,     0,     2,     3,     6,     4,
       3,     2,     2,     3,     3,     3,     3,     3,     3,     1,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,    11,     0,     3,
       0,     4,     0,     0,     0,     0,     0,     0,    30,    29,
       0,     0,     0,     0,     0,    12,     1,     2,     6,     5,
       0,     0,     0,     0,     0,    21,    22,     0,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     9,     0,
       0,    20,    13,    28,    27,    23,    24,    25,    26,     0,
       0,     0,    19,     0,     0,     0,     7,     8,    18,    15,
      14,     0,    10,    16,     0,     0,     0
};

static const short yydefgoto[] =
{
      74,     8,     9,    10,    11,    24,    64,    72,    12,    25
};

static const short yypact[] =
{
      20,    -6,    64,    18,    23,    24,    26,    21,     7,-32768,
      29,-32768,    43,    16,    19,    57,    61,    67,-32768,-32768,
      27,    27,    27,    27,    65,    63,-32768,-32768,-32768,-32768,
      82,    83,    69,    70,    27,-32768,-32768,    -7,    63,    75,
      27,    27,    27,    27,    27,    27,    74,    76,-32768,    27,
      41,-32768,    10,    68,    72,    17,    17,-32768,-32768,    71,
      77,    47,-32768,    78,    80,    81,-32768,-32768,-32768,    79,
  -32768,    27,-32768,    63,    98,   103,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,    99,-32768,-32768,-32768,-32768,-32768,    54,   -20
};


#define	YYLAST		107


static const short yytable[] =
{
      35,    36,    37,    38,    40,    41,    42,    43,    44,    45,
       3,     4,     5,     2,    50,     6,     7,    51,     6,    63,
      53,    54,    55,    56,    57,    58,     1,    26,    17,    61,
      18,    19,    44,    45,    17,    20,    18,    19,    21,    30,
      13,    20,    31,    22,    21,    14,    15,    23,    16,    22,
      28,    73,    40,    41,    42,    43,    44,    45,    40,    41,
      42,    43,    44,    45,    29,    62,    32,     3,     4,     5,
      33,    68,     6,     7,    40,    41,    42,    43,    44,    45,
      41,    42,    43,    44,    45,    42,    43,    44,    45,    34,
      39,    46,    47,    48,    52,    66,    49,    59,    75,    60,
      69,    67,    70,    76,    23,    71,    65,    27
};

static const short yycheck[] =
{
      20,    21,    22,    23,    11,    12,    13,    14,    15,    16,
       3,     4,     5,    19,    34,     8,     9,    24,     8,     9,
      40,    41,    42,    43,    44,    45,     6,    20,     7,    49,
       9,    10,    15,    16,     7,    14,     9,    10,    17,    23,
      22,    14,    23,    22,    17,    22,    22,    26,    22,    22,
      21,    71,    11,    12,    13,    14,    15,    16,    11,    12,
      13,    14,    15,    16,    21,    24,     9,     3,     4,     5,
       9,    24,     8,     9,    11,    12,    13,    14,    15,    16,
      12,    13,    14,    15,    16,    13,    14,    15,    16,    22,
      25,     9,     9,    24,    19,    24,    26,    23,     0,    23,
      20,    24,    21,     0,    26,    26,    52,     8
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 84 "diablo_layout_scripts_parser.y"
{ complete_script = yyvsp[-1].layout_rule; ;
    break;}
case 2:
#line 87 "diablo_layout_scripts_parser.y"
{ 
	yyval.layout_rule = yyvsp[-1].layout_rule; 
	VERIFY_FASSERT(last_rule, ("last_rule NULL but not first rule"));
	last_rule->next = yyvsp[0].layout_rule; 
	last_rule = last_rule->next;
;
    break;}
case 3:
#line 93 "diablo_layout_scripts_parser.y"
{ yyval.layout_rule = last_rule = yyvsp[0].layout_rule;;
    break;}
case 4:
#line 96 "diablo_layout_scripts_parser.y"
{
	t_layout_rule * tmp = Malloc(sizeof(t_layout_rule));
	tmp->kind = SECTION_SPEC;
	tmp->u.secspec = yyvsp[0].layout_secspec;
	tmp->next = NULL;
	yyval.layout_rule = tmp;
;
    break;}
case 5:
#line 103 "diablo_layout_scripts_parser.y"
{
 	t_layout_rule * tmp = Malloc(sizeof(t_layout_rule));
 	tmp->kind = ASSIGN;
 	tmp->u.assign = yyvsp[-1].layout_assign;
 	tmp->next = NULL;
 	yyval.layout_rule = tmp;
;
    break;}
case 6:
#line 110 "diablo_layout_scripts_parser.y"
{
	yyval.layout_rule = yyvsp[-1].layout_rule;
;
    break;}
case 7:
#line 115 "diablo_layout_scripts_parser.y"
{
	t_layout_rule * tmp = Malloc(sizeof(t_layout_rule));
	tmp->kind = SEG_START;
	tmp->u.segment_ident = yyvsp[-2].string;
	tmp->next = NULL;
	yyval.layout_rule = tmp;
;
    break;}
case 8:
#line 122 "diablo_layout_scripts_parser.y"
{
	t_layout_rule * tmp = Malloc(sizeof(t_layout_rule));
	tmp->kind = SEG_END;
	tmp->u.segment_ident = yyvsp[-2].string;
	tmp->next = NULL;
	yyval.layout_rule = tmp;
;
    break;}
case 9:
#line 129 "diablo_layout_scripts_parser.y"
{
	t_layout_rule * tmp = Malloc(sizeof(t_layout_rule));
	tmp->kind = PUT_SECTIONS;

	/* check the validity of the identifier */
	if (!strcmp(yyvsp[-1].string,"CODE_SECTION"))
	{
	  tmp->u.sectype = CODE_SECTION;
	}
	else if (!strcmp(yyvsp[-1].string,"RO_DATA_SECTION"))
	{
	  tmp->u.sectype = RO_DATA_SECTION;
	}
	else if (!strcmp(yyvsp[-1].string,"DATA_SECTION"))
	{
	  tmp->u.sectype = DATA_SECTION;
	}
	else if (!strcmp(yyvsp[-1].string,"BSS_SECTION"))
	{
	  tmp->u.sectype = BSS_SECTION;
	}
	else if (!strcmp(yyvsp[-1].string,"NOTE_SECTION"))
	{
	  tmp->u.sectype = NOTE_SECTION;
	}
	else
	{
	  FATAL(("not a valid section type identifier: %s",yyvsp[-1].string));
	}
	Free(yyvsp[-1].string);
	tmp->next = NULL;
	yyval.layout_rule = tmp;
;
    break;}
case 10:
#line 164 "diablo_layout_scripts_parser.y"
{
	t_layout_secspec * tmp = Malloc(sizeof(t_layout_secspec));
	tmp->name = yyvsp[-6].string;
	tmp->address = yyvsp[-5].layout_exp;
	tmp->internal_rule = yyvsp[-2].layout_assign;
	tmp->filler_exp = yyvsp[0].layout_exp;
	yyval.layout_secspec = tmp;
;
    break;}
case 11:
#line 174 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = NULL; ;
    break;}
case 12:
#line 175 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = yyvsp[0].layout_exp; ;
    break;}
case 13:
#line 178 "diablo_layout_scripts_parser.y"
{ yyval.layout_assign = NULL; ;
    break;}
case 14:
#line 179 "diablo_layout_scripts_parser.y"
{ yyval.layout_assign = yyvsp[-1].layout_assign; ;
    break;}
case 15:
#line 182 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = NULL; ;
    break;}
case 16:
#line 183 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = yyvsp[0].layout_exp; ;
    break;}
case 17:
#line 186 "diablo_layout_scripts_parser.y"
{ 
	t_layout_assign * tmp = Malloc(sizeof(t_layout_assign));
	tmp->lhs = yyvsp[-2].string;
	tmp->rhs = yyvsp[0].layout_exp;
	tmp->provide = FALSE;
	yyval.layout_assign = tmp;
;
    break;}
case 18:
#line 193 "diablo_layout_scripts_parser.y"
{
	t_layout_assign * tmp = Malloc(sizeof(t_layout_assign));
	tmp->lhs = yyvsp[-3].string;
	tmp->rhs = yyvsp[-1].layout_exp;
	tmp->provide = TRUE;
	yyval.layout_assign = tmp;
;
    break;}
case 19:
#line 202 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp(ALIGN,yyvsp[-1].layout_exp,NULL); ;
    break;}
case 20:
#line 203 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = yyvsp[-1].layout_exp; ;
    break;}
case 21:
#line 204 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp(UMINUS,yyvsp[0].layout_exp,NULL); ;
    break;}
case 22:
#line 205 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('~',yyvsp[0].layout_exp,NULL); ;
    break;}
case 23:
#line 206 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('+',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 24:
#line 207 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('-',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 25:
#line 208 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('*',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 26:
#line 209 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('/',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 27:
#line 210 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('&',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 28:
#line 211 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp('|',yyvsp[-2].layout_exp,yyvsp[0].layout_exp); ;
    break;}
case 29:
#line 212 "diablo_layout_scripts_parser.y"
{ long long tmp = yyvsp[0].longlong; yyval.layout_exp = new_exp(NUMBER,&tmp,NULL); ;
    break;}
case 30:
#line 213 "diablo_layout_scripts_parser.y"
{ yyval.layout_exp = new_exp(IDENTIFIER,yyvsp[0].string,NULL); ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 217 "diablo_layout_scripts_parser.y"


static t_layout_exp * new_exp(int operator, void * arg1, void * arg2)
{
  t_layout_exp * ret = Malloc(sizeof(t_layout_exp));
  ret->operator = operator;
  if (operator == NUMBER)
  {
    ret->arg1 = ret->arg2 = NULL;
    ret->identifier = NULL;
    ret->constant = *(long long *)arg1;
  }
  else if (operator == IDENTIFIER)
  {
    ret->arg1 = ret->arg2 = NULL;
    ret->constant = 0LL;
    ret->identifier = (t_string)arg1;
  }
  else
  {
    ret->arg1 = (t_layout_exp *)arg1;
    ret->arg2 = (t_layout_exp *)arg2;
    ret->identifier = NULL;
    ret->constant = 0LL;
  }
  return ret;
}

extern FILE * lparsein;
t_layout_rule * LayoutScriptParse(t_string scriptfile)
{
  t_layout_rule * ret;
  FILE * f = fopen(scriptfile,"r");
  if (!f) FATAL(("Could not open %s for reading",scriptfile));
  DiabloPrint(stdout, "-- parsing layout script in %s\n", scriptfile);

  lparsein = f;
  if (lparseparse())
    FATAL(("Parsing appears to have failed"));
  ret = complete_script;
  complete_script = NULL;
  return ret;
}

/* {{{ rudimentary parse tree printer */
void print_exp(t_layout_exp * exp)
{
  switch (exp->operator)
  {
    case ALIGN: 
      printf("align\n"); break;
    case UMINUS:
      printf("uminus\n"); break;
    case IDENTIFIER:
      printf("identifier %s\n", exp->identifier); break;
    case NUMBER:
      printf("constant %llx\n", exp->constant); break;
    default:
      printf("operator %c\n", exp->operator); break;
  }

  if (exp->arg1)
  {
    printf("subexp 1:\n");
    print_exp(exp->arg1);
  }
  if (exp->arg2)
  {
    printf("subexp 2:\n");
    print_exp(exp->arg2);
  }
}

void print_assign(t_layout_assign * assign)
{
  printf("assign %s\n", assign->lhs);
  print_exp(assign->rhs);
}

void printscript(void)
{
  t_layout_rule * r = complete_script;
  for (; r; r = r->next)
  {
    printf("<<< rule >>>\n");
    if (r->kind == SECTION_SPEC)
    {
      printf("name %s\n", r->u.secspec->name);
      if (r->u.secspec->internal_rule)
        print_assign(r->u.secspec->internal_rule);
      else
        printf("no internal rule\n");
      if (r->u.secspec->filler_exp)
        print_exp(r->u.secspec->filler_exp);
    }
    else
    {
      print_assign(r->u.assign);
    }
    printf("<<< end rule >>>\n");
  }
}
/* }}} */

static int lparseerror(char *s)
{
  FATAL(("parsing failed. parser said: %s",s));
  return 0;
}

long long LayoutScriptCalcExp(t_layout_exp * exp, long long currpos, t_object * obj)
{
  long long res1=0, res2=0;

  if (exp->arg1)
    res1 = LayoutScriptCalcExp(exp->arg1,currpos,obj);
  if (exp->arg2)
    res2 = LayoutScriptCalcExp(exp->arg2,currpos,obj);

  switch (exp->operator)
  {
    case ALIGN:
      return (currpos + res1 - 1) & ~(res1 - 1); 
    case UMINUS:
      return (-res1);
    case NUMBER:
      return exp->constant;
    case IDENTIFIER:
    {
      if (!strcmp(exp->identifier,"."))
        return currpos;
      else
      {
	if (strcmp(exp->identifier,"SIZEOF_HEADERS") && strcmp(exp->identifier,"sizeof_headers"))
	  FATAL(("Currently unsupported identifier (%s) in expression",exp->identifier));
	else if (gseg) gseg->hoist_headers=TRUE;

	return obj->ff_actions->GetSizeofHeaders(obj,obj->layout_script);
      }
    }
    case '~':
      return (~res1);
    case '&':
      return res1 & res2;
    case '|':
      return res1 | res2;
    case '+':
      return res1 + res2;
    case '-':
      return res1 - res2;
    case '*':
      return res1 * res2;
    case '/':
      return res1 / res2;

    default:
      FATAL(("Unknown operator in expression"));
      exit(0);/* Keep the compiler happy */
  }
  return 0; /* Keep the compiler happy */
}

static void free_exp(t_layout_exp * exp)
{
  if (!exp) return;

  if (exp->arg1) free_exp(exp->arg1);
  if (exp->arg2) free_exp(exp->arg2);
  if (exp->identifier) Free(exp->identifier);
  Free(exp);
}

static void free_assign(t_layout_assign * assign)
{
  if (!assign) return;
  Free(assign->lhs);
  free_exp(assign->rhs);
  Free(assign);
}

void LayoutScriptFree(t_layout_rule * script)
{
  t_layout_rule * r, * next;
  for (r=script, next=r?r->next:NULL; r; r=next,next=r?r->next:NULL)
  {
    if (r->kind == ASSIGN)
    {
      free_assign(r->u.assign);
    }
    else if (r->kind == SECTION_SPEC)
    {
      free_assign(r->u.secspec->internal_rule);
      free_exp(r->u.secspec->address);
      free_exp(r->u.secspec->filler_exp);
      Free(r->u.secspec->name);
      Free(r->u.secspec);
    }
    else if (r->kind == SEG_START || r->kind == SEG_END)
    {
      Free(r->u.segment_ident);
    }
    else if (r->kind == PUT_SECTIONS)
    {
    }
    Free(r);
  }
}

/* vim: set shiftwidth=2 foldmethod=marker: */
