/***********************************************************
 * Copyright 2001,2002,2003:  {{{
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This files contains all definitions for  handling "generic" objects 
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be)  }}}
 ***********************************************************/

#ifndef SEGMENT_TYPEDEFS
#define SEGMENT_TYPEDEFS
typedef struct _t_segment t_segment;
#endif

#ifndef _DIABLO_SEGMENT_H_
#define _DIABLO_SEGMENT_H_

#include "diablo_relocatable.h"
#include "diablo_addresses.h"
#include "../datastructures/data_hash.h"

struct _t_segment {
  t_relocatable relocatable;
  t_string name;
  struct _t_segment * next;
  struct _t_segment * prev;
  t_bool hoist_headers;
};

#define T_SEGMENT(seg)			((t_segment *)(seg))
#define SEGMENT_OLD_ADDRESS(seg)	T_RELOCATABLE(seg)->old_address
#define SEGMENT_CADDRESS(seg)		T_RELOCATABLE(seg)->caddress
#define SEGMENT_OLD_SIZE(seg)		T_RELOCATABLE(seg)->old_size
#define SEGMENT_CSIZE(seg)		T_RELOCATABLE(seg)->csize
#define SEGMENT_NAME(seg)		T_SEGMENT(seg)->name

t_segment * SegmentNew(t_string name);

#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
