/******************************************************************************
 * Copyright 2001,2002,2003: {{{ 
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be)  }}}
 *****************************************************************************/

#ifndef DIABLO_ARCHIVE_TABLES_TYPEDEFS
#define DIABLO_ARCHIVE_TABLES_TYPEDEFS
typedef enum { AT_ARCH_AR, AT_ARCH_AR_ALPHA, AT_ARCH_JAR, AT_UNKNOWN } t_archivetype;
/*! Describes how to identify and handle different archive types */
typedef struct _t_archive_handlers t_archive_handlers;
#endif

#ifndef DIABLO_ARCHIVE_TABLES_H
#define DIABLO_ARCHIVE_TABLES_H
#include "diablo_archives.h"
/*! TODO: document */
struct _t_archive_handlers 
{
   t_archivetype type;
   t_bool (*ident)(FILE * fp);
   void (*open)(FILE * fp, t_archive *);
};
extern const t_archive_handlers archive_handler_table[];
#endif
/* vim: set shiftwidth=2 foldmethod=marker: */
