/******************************************************************************
 * Copyright 2001,2002,2003: {{{ 
 *
 * Bruno De Bus, Bjorn De Sutter, Dominique Chanet, Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * All functions to manipulate flowgraphs
 *
 * Written by Bjorn De Sutter (bdebus@elis.ugent.be)
 *
 * Copyright (c) 2002 Bjorn De Sutter
 *
 * THIS FILE IS PART OF DIABLO (KERNEL)
 *
 * MAINTAINER: Bjorn De Sutter (brdsutte@elis.ugent.be) }}} 
 *****************************************************************************/

#ifndef MY_CALLGRAPH_TYPEDEFS
#define MY_CALLGRAPH_TYPEDEFS
typedef struct _t_cg t_cg;
typedef struct _t_cg_edge t_cg_edge;
typedef struct _t_cg_node t_cg_node;


#endif /* MY_CALLGRAPH_TYPEDEFS */

#ifndef _GRAPH_TYPEDEFS
#define _GRAPH_TYPEDEFS
typedef struct _t_edge t_edge;
typedef struct _t_node t_node;
typedef struct _t_graph t_graph;
#endif

#ifndef MY_CALLGRAPH_H
#define MY_CALLGRAPH_H

#include "diablo_flowgraph.h"

struct _t_cg
{
  t_graph graph;
};

struct _t_cg_edge
{
  t_edge edge;
  t_cfg_edge * cfg_edge;
//XZ
  data_ll_elem * call_sites;
};

struct _t_cg_node
{
  t_node node;
  t_function * fun;
};

#define CG_NODE_FUN(node) (T_FUN(node->fun))
#define T_CG_EDGE(edge)   ((t_cg_edge*)(edge))
#define T_CG_NODE(node)   ((t_cg_node*)(node))
#define T_CG(cg)   ((t_cg*)(cg))

#define CG_EDGE_TAIL(edge) (T_CG_NODE(EDGE_TAIL(edge)))
#define CG_EDGE_HEAD(edge) (T_CG_NODE(EDGE_HEAD(edge)))

t_cg * CgNew();
void CgFree(t_cg * cg);
void CgAddCfgEdge(t_cg * cg, t_cfg_edge * edge);
t_cg_node * CgFindNode(t_cg * cg, t_function * fun);
void CgBuild(t_cfg * cfg);
void CgExport(t_cg * cg, const char * name);

void XZ_CgExport(t_cg * cg);
#endif
