/******************************************************************************
 * Copyright 2001,2002,2003: {{{
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bjorn De Sutter (brdsutte@elis.rug.ac.be) }}}
 ******************************************************************************/


/*!\addtogroup DIABLO_ANALYSES Generic analysis */
/*@{ */
/*! \defgroup CONSTPROP Constant Propagation */
/*@{ */
#ifndef DIABLO_CONSTPROP_H
#define DIABLO_CONSTPROP_H
#include "diablo_object.h"
#include "diablo_section.h"
typedef void (*t_ConstantPropagationInsEmul)(t_ins *, t_procstate *);
typedef void (*t_EdgePropagator)(t_cfg_edge *, t_ins *);
typedef t_bool (*t_Unconditionalizer)(t_ins * );
typedef void (*t_InsConstantOptimizer)(t_ins *, t_procstate *, t_procstate * );
void ConstantPropagation(t_cfg * cfg, char * outputfilename, t_bool after_ud_analysis);
void OptUseConstantInformation(t_cfg * cfg, char * outputfilename, t_bool after_ud_analysis);
void DumpConstantPropagationInfo(t_string filename,t_object * obj);


void 	CfgMarkFun(t_cfg * cfg, t_function* fun);
t_bool 	CfgUnmarkFun(t_cfg* cfg, t_function** fun);
void 	CfgUnmarkAllFun(t_cfg * cfg);

void 	FunctionMarkBbl(t_function * fun, t_bbl * bbl);
t_bool 	FunctionUnmarkBbl(t_function * fun, t_bbl** bbl);
void 	FunctionUnmarkAllBbls(t_function * fun);

void 	FunctionMarkEdge(t_function * fun, t_cfg_edge * edge);
t_bool 	FunctionUnmarkEdge(t_function * fun,t_cfg_edge** edge);
void 	FunctionUnmarkAllEdges(t_function * fun);
void 	FunctionMarkAllTrueIncomingEdges(t_function * fun);

void 	FunctionFreeMarkedSpace(t_function * fun);
void    FunctionPropagateConstants(t_object * obj,t_function * fun,t_section *sec,t_cfg_edge* edge_in,t_bool during_fixpoint_calculations, t_bool propagate_over_all_outgoing_edges);

void	FreeConstantInformation(t_cfg * cfg);

#ifdef DIETER
void CfgCollectAddressProducerInformation(t_cfg * cfg);
void FreeAddressProducerInformation(t_cfg * cfg);
void CfgOptimizeLoaders(t_cfg * cfg);
#endif
#endif
/*@} */
/*@} */
/* vim: set shiftwidth=2 foldmethod=marker: */
