/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bjorn De Sutter (brdsutte@elis.rug.ac.be)
 ***********************************************************/


/*!\addtogroup DIABLO_ANALYSES Generic analysis */
/*@{ */
/*! \defgroup DOMINATOR Dominator analysis */
/*@{ */
#ifndef DIABLO_DOMINATOR_H
#define DIABLO_DOMINATOR_H
#include "diablo_object.h"
#include "diablo_section.h"
#include "diablo_bbl.h"

void ComDominators(t_cfg * cfg);
void DominatorRemove(data_ll_elem ** list, t_bbl * bbl);
t_bool BblDominates(t_bbl * dominator, t_bbl * dominated);
t_bool BblPostdominates(t_bbl * postdominator, t_bbl * postdominated);
void Export_FunctionDominator(t_bbl * start, t_uint32 mask, const char * filename);
void Export_FunctionPostDominator(t_bbl * start, t_uint32 mask, const char * filename);
void DominatorCleanup(t_cfg * cfg);
void DominatorFree(data_ll_elem ** list);

#endif
/*@} */
/*@} */
