/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * DESC: Header for liveness analysis
 *
 * MAINTAINER: Bjorn De Sutter (brdsutte@elis.rug.ac.be)
 ***********************************************************/


/*!\addtogroup DIABLO_ANALYSES Generic analysis */
/*@{ */
/*! \defgroup LIVENESS Liveness */
/*@{ */

#ifndef MY_LIVENESS_H
#define MY_LIVENESS_H

typedef enum {TRIVIAL,SENSITIVE,INSENSITIVE} liveness_level;

void AfunInitLiveness(t_function * ifun);
void AfunFiniLiveness(t_function * ifun);
void ComputeSavedChangedRegisters(t_section * sec);
void ComLiveness(t_cfg * cfg, liveness_level level);
void DumpLivenessInfo(t_string filename, t_object * obj);
void DumpCfgWithLiveness(t_cfg * cfg, t_string dotsdir, t_bool livebefore, t_bool liveafter, t_bool compute_fresh);
	
#endif
/*@} */
/*@} */
