/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _UD_GRAPH_H_
#define _UD_GRAPH_H_

#include "diablo_ins.h"
#include "../datastructures/data_graph.h"

/* The ud_graph needn't have any special functionality for now,
 * so it suffices to make t_ud_graph equivalent to t_graph */

#ifndef _UDGRAPH_TYPEDEFS
#define _UDGRAPH_TYPEDEFS
typedef t_graph t_ud_graph;
typedef t_ins 	t_ud_node;
typedef t_edge	t_ud_edge;
#endif

t_ud_graph * UdGraphNew(void);
t_ud_graph * UdGraphNewForCfg(t_cfg * cfg);
void UdGraphInsertNode(t_ud_graph * graph, t_ud_node * node);
t_ud_edge * UdGraphLinkUseToDefForRegister(t_ud_graph * graph, t_ud_node * use, t_ud_node * def, t_reg reg);
void UdGraphFree(t_ud_graph * graph);
void UdGraphWriteOut(t_ins * ins, t_string filename, t_uint32 recursiondepth);

#define InsInUdGraph(ins)	(NODE_NEXT(ins) || NODE_PREV(ins))

#endif
