linker="ARM ADS 1.2"
fileformats="ELF"
architectures="ARM"

RegionTable 
{
   action { ADD_SUBSECTION("Linker","ArmRegionTable",CODE,4) }
   trigger { UNDEFINED_SYMBOL("Region$$Table$$Base") }
   section { CONST32(0),CONST32(0),CONST32(0),CONST32(0),CONST32(0),CONST32(0),CONST32(0),CONST32(0),CONST32(0) }
   address { SYMBOL("Region$$Table$$Base") }
}

RegionTableBase 
{
   action { ADD_SYMBOL("Region$$Table$$Base") 
   }
   trigger { UNDEFINED_SYMBOL("Region$$Table$$Base") 
   && SUBSECTION_EXISTS("Linker","ArmRegionTable") }
   symbol  {  START_OF_SUBSECTION("Linker","ArmRegionTable") } 
}

RegionTableLimit {
   action  { ADD_SYMBOL("Region$$Table$$Limit") }
   trigger { UNDEFINED_SYMBOL("Region$$Table$$Limit") && SUBSECTION_EXISTS("Linker","ArmRegionTable") }
   symbol  { END_OF_SUBSECTION("Linker","ArmRegionTable") } 
}


ZISectionTable {
   action { ADD_SUBSECTION("Linker","ArmZISectionTable",CODE,4) }
   trigger { UNDEFINED_SYMBOL("ZISection$$Table$$Base") }
   section { CONST32(0),CONST32(0),CONST32(0),CONST32(0),START_OF_SECTION("ER_ZI"),SIZE_OF_SECTION("ER_ZI") }
   address { SYMBOL("ZISection$$Table$$Base") }
}

ZISectionTableBase {
 action  { ADD_SYMBOL("ZISection$$Table$$Base") }
 trigger { UNDEFINED_SYMBOL("ZISection$$Table$$Base") && SUBSECTION_EXISTS("Linker","ArmZISectionTable") }
 symbol  { START_OF_SUBSECTION("Linker","ArmZISectionTable") }
}

ZISectionTableLimit {
 action  { ADD_SYMBOL("ZISection$$Table$$Limit") }
 trigger { UNDEFINED_SYMBOL("ZISection$$Table$$Limit") && SUBSECTION_EXISTS("Linker","ArmZISectionTable") }
 symbol  { END_OF_SUBSECTION("Linker","ArmZISectionTable") }
}

ImageRWLimit  {
   action  { ADD_SYMBOL("Image$$RW$$Limit") }
   trigger { UNDEFINED_SYMBOL("Image$$RW$$Limit") && SECTION_EXISTS("ER_ZI") } 
   symbol  { END_OF_SECTION("ER_ZI") }
}

ImageRWLimitnoZI  {
   action  { ADD_SYMBOL("Image$$RW$$Limit") }
   trigger { UNDEFINED_SYMBOL("Image$$RW$$Limit") && SECTION_EXISTS("ER_RW") } 
   symbol  { END_OF_SECTION("ER_RW") }
}

ImageRWLimitnoRW  {
   action  { ADD_SYMBOL("Image$$RW$$Limit") }
   trigger { UNDEFINED_SYMBOL("Image$$RW$$Limit")   }
   symbol  { END_OF_SECTION("ER_RO")  }
}

DefaultSignalHandler {
  action  { ADD_SYMBOL("__SIG_DFL") }
  trigger { UNDEFINED_SYMBOL("__SIG_DFL") }
  symbol  { ABS(0xffffffff) }
}

ErrorSignalHandler {
   action  { ADD_SYMBOL("__SIG_ERR") }
   trigger { UNDEFINED_SYMBOL("__SIG_ERR") }
   symbol  { ABS(0xfffffffe) }
}

IgnoreSignalHandler {
   action  { ADD_SYMBOL("__SIG_IGN") }
   trigger { UNDEFINED_SYMBOL("__SIG_IGN") }
   symbol  { ABS(0xfffffffd) }
}


ConstructorVectors {
   action  { VECTORIZE("C$$pi_ctorvec") }
   trigger { SUBSECTION_EXISTS("*","C$$pi_ctorvec") } 
}

ConstructorVectorsBase {
  action  { ADD_SYMBOL("C$$pi_ctorvec$$Base") }
  trigger { SUBSECTION_EXISTS("Linker","VECTOR___C$$pi_ctorvec") }
  symbol  { START_OF_SUBSECTION("Linker","VECTOR___C$$pi_ctorvec") }
}

ConstructorVectorsBase {
  action  { ADD_SYMBOL("C$$pi_ctorvec$$Limit") }
  trigger { SUBSECTION_EXISTS("Linker","VECTOR___C$$pi_ctorvec") }
  symbol  { END_OF_SUBSECTION("Linker","VECTOR___C$$pi_ctorvec") }
}


DestructorVectors {
   action  { VECTORIZE("C$$pi_dtorvec") }
   trigger { SUBSECTION_EXISTS("*","C$$pi_dtorvec") } 
}

DestructorVectorsBase {
  action  { ADD_SYMBOL("C$$pi_dtorvec$$Base") }
  trigger { SUBSECTION_EXISTS("Linker","VECTOR___C$$pi_dtorvec") }
  symbol  { START_OF_SUBSECTION("Linker","VECTOR___C$$pi_dtorvec") }
}

DestructorVectorsBase {
  action  { ADD_SYMBOL("C$$pi_dtorvec$$Limit") }
  trigger { SUBSECTION_EXISTS("Linker","VECTOR___C$$pi_dtorvec") }
  symbol  { END_OF_SUBSECTION("Linker","VECTOR___C$$pi_dtorvec") }
}


Veneer {
  trigger { LINKED_SYMBOL_EXISTS("$Ven$AT$$*") }
  action { ADD_SUBSECTION("Linker",CONCAT(MATCHED_NAME(),"_section"),CODE,4) }
  section { CONST32(0xe59fc000), 
            CONST32(0xe12fff1c),
	    RELOCATED32(0x0, SUBSTRING(MATCHED_NAME(),9,0) , 0, 0, 0, "SA+SM+\l*w\s0000$")
  }
  address { SYMBOL(MATCHED_NAME()) }

}

Veneer_Symbol {
  trigger { LINKED_SYMBOL_EXISTS("$Ven$AT$$*") }
  action { ADD_LOCAL_SYMBOL("$a") }
  symbol { START_OF_SUBSECTION("Linker",CONCAT(MATCHED_NAME(),"_section")) }
}

Veneer_Data_Symbol {
  trigger { LINKED_SYMBOL_EXISTS("$Ven$AT$$*") }
  action { ADD_LOCAL_SYMBOL("$d") }
  symbol { START_OF_SUBSECTION("Linker",CONCAT(MATCHED_NAME(),"_section")) + OFFSET(0x8)}
}




/* embedded layout script */
SECTIONS
{
  . = 0x8000;
  ER_RO : {}
  PUT_REMAINING_SECTIONS(CODE_SECTION);
  PUT_REMAINING_SECTIONS(RO_DATA_SECTION);
  ER_RW : {}
  PUT_REMAINING_SECTIONS(DATA_SECTION);
  ER_ZI : {. = ALIGN(4);}
  PUT_REMAINING_SECTIONS(BSS_SECTION);
}
