linker="MIPS GNU LD"
fileformats="ELF"
architectures="MIPS"

/* =========== __bss_start ============= */
/*BssStartTosbss {
 action  { ADD_SYMBOL("__bss_start") }
 trigger { UNDEFINED_SYMBOL("__bss_start") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}

BssStartTobss {
 action  { ADD_SYMBOL("__bss_start") }
 trigger { UNDEFINED_SYMBOL("__bss_start") && SUBSECTION_EXISTS("Linker","VECTOR___.bss") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR___.bss") }
}

BssStartTo {
 action  { ADD_SYMBOL("__bss_start") }
 trigger { UNDEFINED_SYMBOL("__bss_start") }
 symbol  { ABS(0) }
}
*/
/* =========== _fbss ============= */
/*FbssTosbss {
 action  { ADD_SYMBOL("_fbss") }
 trigger { UNDEFINED_SYMBOL("_fbss") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}

FbssTobss {
 action  { ADD_SYMBOL("_fbss") }
 trigger { UNDEFINED_SYMBOL("_fbss") && SUBSECTION_EXISTS("Linker","VECTOR___.bss") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR___.bss") }
}

FbssTo {
 action  { ADD_SYMBOL("_fbss") }
 trigger { UNDEFINED_SYMBOL("_fbss") }
 symbol  { ABS(0) }
}
*/
/* =========== sbss ============= */
/*
sbssVector {
   action {  VECTORIZE(".sbss") }
   trigger { SUBSECTION_EXISTS("*",".sbss") }
}

sbssVector2SbssStart {
   action  { ADD_SYMBOL("__sbss_start") }
   trigger { UNDEFINED_SYMBOL("__sbss_start") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
   symbol  { BEGIN_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}
   
sbssVector3SbssStart {
   action  { ADD_SYMBOL("___sbss_start") }
   trigger { UNDEFINED_SYMBOL("___sbss_start") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
   symbol  { BEGIN_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}

sbssVector2SbssEnd {
   action  { ADD_SYMBOL("__sbss_end") }
   trigger { UNDEFINED_SYMBOL("__sbss_end") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}
   
sbssVector3SbssStart {
   action  { ADD_SYMBOL("___sbss_end") }
   trigger { UNDEFINED_SYMBOL("___sbss_end") && SUBSECTION_EXISTS("Linker","VECTOR___.sbss") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.sbss") }
}
*/
/* =========== bss ============= */
/*
bssVector {
   action {  VECTORIZE(".bss") }
   trigger { SUBSECTION_EXISTS("*",".bss") }
}
*/
BssStartWithSbss {
   action  { ADD_SYMBOL("__bss_start__") }
   trigger { UNDEFINED_SYMBOL("__bss_start__")   && SECTION_EXISTS(".sbss") }
   symbol  { SYMBOL_START_OF_SECTION(".sbss") } 
}


BssStartWithBss {
   action  { ADD_SYMBOL("__bss_start__") }
   trigger { UNDEFINED_SYMBOL("__bss_start__")   && SECTION_EXISTS(".bss") }
   symbol  { SYMBOL_START_OF_SECTION(".bss") } 
}

BssEndWithSbss {
   action  { ADD_SYMBOL("__bss_end__") }
   trigger { UNDEFINED_SYMBOL("__bss_end__")   && SECTION_EXISTS(".sbss") }
   symbol  { END_OF_SECTION(".sbss") } 
}

BssEndWithBss {
   action  { ADD_SYMBOL("__bss_end__") }
   trigger { UNDEFINED_SYMBOL("__bss_end__")   && SECTION_EXISTS(".bss") }
   symbol  { END_OF_SECTION(".bss") } 
}

BssStartWithSBss {
   action  { ADD_SYMBOL("_fbss") }
   trigger { UNDEFINED_SYMBOL("_fbss")   && SECTION_EXISTS(".sbss") }
   symbol  { START_OF_SECTION(".sbss") } 
}
BssStartWithBss {
   action  { ADD_SYMBOL("_fbss") }
   trigger { UNDEFINED_SYMBOL("_fbss")   && SECTION_EXISTS(".bss") }
   symbol  { START_OF_SECTION(".bss") } 
}

BssEndWithBss {
   action  { ADD_SYMBOL("_end") }
   trigger { UNDEFINED_SYMBOL("_end")   && SECTION_EXISTS(".bss") }
   symbol  { END_OF_SECTION(".bss") } 
}

/* =========== eh_frame ============= */

eh_frameVector {
   action {  VECTORIZE(".eh_frame") }
   trigger { SUBSECTION_EXISTS("*",".eh_frame") }
}

eh_frameVectorEnd {
   action  { ADD_SYMBOL("__EH_FRAME_BEGIN__") }
   trigger { UNDEFINED_SYMBOL("__EH_FRAME_BEGIN__") && SUBSECTION_EXISTS("Linker","VECTOR___.eh_frame") }
   symbol  { BEGIN_OF_SUBSECTION("Linker","VECTOR___.eh_frame") }
   }

/*   trigger { UNDEFINED_SYMBOL("__EH_FRAME_BEGIN__")   && SECTION_EXISTS(".eh_frame") }
   symbol  { START_OF_SECTION(".eh_frame") } 
}*/

End {
   action  { ADD_SYMBOL("end") }
   trigger { UNDEFINED_SYMBOL("end")    }
   symbol  { ABS(0) } 

}

/* =========== .got ============= */
/*
GotVector {
   action {  VECTORIZE(".got") }
   trigger { SUBSECTION_EXISTS("*",".got") }
}

GotVectorGpDisp {
   action  { ADD_SYMBOL("_gp_disp") }
   trigger { UNDEFINED_SYMBOL("_gp_disp") && SUBSECTION_EXISTS("Linker","VECTOR___.got") }
   symbol  { BEGIN_OF_SUBSECTION("Linker","VECTOR___.got") }
   }

GotVectorGlobal {
   action  { ADD_SYMBOL("__global") }
   trigger { UNDEFINED_SYMBOL("__global") && SUBSECTION_EXISTS("Linker","VECTOR___.got") }
   symbol  { BEGIN_OF_SUBSECTION("Linker","VECTOR___.got") }
   }
*/

GPointer {
   action  { ADD_SYMBOL("_gp") }
   trigger { UNDEFINED_SYMBOL("_gp") && SECTION_EXISTS(".got")  }
   symbol  { START_OF_SECTION(".got") + OFFSET(0x7ff0) }
}
GPDispointer {
   action  { ADD_SYMBOL("_gp_disp") }
   trigger { UNDEFINED_SYMBOL("_gp_disp") && SECTION_EXISTS(".got")  }
   symbol  { START_OF_SECTION(".got") + OFFSET(0x7ff0) }
}
GlobalPointer {
   action  { ADD_SYMBOL("__global") }
   trigger { UNDEFINED_SYMBOL("__global") && SECTION_EXISTS(".got")  }
   symbol  { START_OF_SECTION(".got") + OFFSET(0x7ff0) }
}


StackPointer {
   action  { ADD_SYMBOL("__stack") }
   trigger { UNDEFINED_SYMBOL("__stack") }
   symbol  { ABS(0) }
}

HardwareInitHook {
   action  { ADD_SYMBOL("hardware_init_hook") }
   trigger { UNDEFINED_SYMBOL("hardware_init_hook") }
   symbol  { ABS(0) }
}

HardwareHazardHook {
   action  { ADD_SYMBOL("hardware_hazard_hook") }
   trigger { UNDEFINED_SYMBOL("hardware_hazard_hook") }
   symbol  { ABS(0) }
}

HardwareExitHook {
   action  { ADD_SYMBOL("hardware_exit_hook") }
   trigger { UNDEFINED_SYMBOL("hardware_exit_hook") }
   symbol  { ABS(0) }
}

SoftwareInitHook {
   action  { ADD_SYMBOL("software_init_hook") }
   trigger { UNDEFINED_SYMBOL("software_init_hook") }
   symbol  { ABS(0) }
}

/* =========== Ctors ============= */

CtorsVector {
   action {  VECTORIZE(".ctors") }
   trigger { SUBSECTION_EXISTS("*",".ctors") }
}

CtorsVectorEnd {
   action  { ADD_SYMBOL("_CTOR_END__") }
   trigger { UNDEFINED_SYMBOL("__CTOR_END__") && SUBSECTION_EXISTS("Linker","VECTOR___.ctors") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.ctors") }
}

/* =========== Dtors ============= */

DtorsVector {
   action {  VECTORIZE(".dtors") }
   trigger { SUBSECTION_EXISTS("*",".dtors") }
}

DtorsVectorEnd {
   action  { ADD_SYMBOL("_DTOR_END__") }
   trigger { UNDEFINED_SYMBOL("__DTOR_END__") && SUBSECTION_EXISTS("Linker","VECTOR___.dtors") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.dtors") }
}

/* ========= Start of preinit ========= */

/* Have preinit */

PreInitStart {
 action  { ADD_SYMBOL("__preinit_array_start") }
 trigger { UNDEFINED_SYMBOL("__preinit_array_start") && SUBSECTION_EXISTS("Linker","VECTOR___.preinit_array") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR___.preinit_array") }
}

/* Start of preinit, no preinit, have init */

PreInitStartFALLBACK {
   action  { ADD_SYMBOL("__preinit_array_start") }
   trigger { UNDEFINED_SYMBOL("__preinit_array_start") } 
   symbol  { ABS(0) }
}

/* ========= End of preinit ========= */

/* Have preinit */

PreInitEnd {
 action  { ADD_SYMBOL("__preinit_array_end") }
 trigger { UNDEFINED_SYMBOL("__preinit_array_end") && SUBSECTION_EXISTS("Linker","VECTOR___.preinit_array") }
 symbol  { END_OF_SUBSECTION("Linker","VECTOR___.preinit_array") }
}

/* Have init, no preinit */

PreInitEndFALLBACK {
 action  { ADD_SYMBOL("__preinit_array_end") }
 trigger { UNDEFINED_SYMBOL("__preinit_array_end") }
 symbol  { ABS(0) }
}

/* ========= Start of init ========= */

/* Have init */

InitStart {
   action  { ADD_SYMBOL("__init_array_start") }
   trigger { UNDEFINED_SYMBOL("__init_array_start") && SUBSECTION_EXISTS("Linker","VECTOR___.init_array") }
   symbol  { START_OF_SUBSECTION("Linker","VECTOR___.init_array") }
}

InitStartFALLBACK {
   action  { ADD_SYMBOL("__init_array_start") }
   trigger { UNDEFINED_SYMBOL("__init_array_start") }
   symbol  { ABS(0) }
}

/* ========= End of init ========= */

/* Have init */

InitEnd {
   action  { ADD_SYMBOL("__init_array_end") }
   trigger { UNDEFINED_SYMBOL("__init_array_end") && SUBSECTION_EXISTS("Linker","VECTOR___.init_end") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.init_array") }
}

InitEndFALLBACK {
 action  { ADD_SYMBOL("__init_array_end") }
 trigger { UNDEFINED_SYMBOL("__init_array_end") }
 symbol  { ABS(0) }
}

/* ========= Start of fini ========= */

/* Have fini */

InitStart {
   action  { ADD_SYMBOL("__fini_array_start") }
   trigger { UNDEFINED_SYMBOL("__fini_array_start") && SUBSECTION_EXISTS("Linker","VECTOR___.fini_array") }
   symbol  { START_OF_SUBSECTION("Linker","VECTOR___.fini_array") }
}

InitStartFALLBACK {
   action  { ADD_SYMBOL("__fini_array_start") }
   trigger { UNDEFINED_SYMBOL("__fini_array_start") }
   symbol  { ABS(0) }
}

/* ========= End of fini ========= */

/* Have fini */

InitEnd {
   action  { ADD_SYMBOL("__fini_array_end") }
   trigger { UNDEFINED_SYMBOL("__fini_array_end") && SUBSECTION_EXISTS("Linker","VECTOR___.fini_end") }
   symbol  { END_OF_SUBSECTION("Linker","VECTOR___.fini_array") }
}

InitEndFALLBACK {
 action  { ADD_SYMBOL("__fini_array_end") }
 trigger { UNDEFINED_SYMBOL("__fini_array_end") }
 symbol  { ABS(0) }
}

/* ========= __libc_atexit ========= */

LibcAtExit {
   action {  VECTORIZE("__libc_atexit") }
   trigger { SUBSECTION_EXISTS("*","__libc_atexit") }
}

LibcAtExitStart {
 action  { ADD_SYMBOL("__start___libc_atexit") }
 trigger { SUBSECTION_EXISTS("Linker","VECTOR_____libc_atexit") }
 symbol  { START_OF_SUBSECTION("Linker","VECTOR_____libc_atexit") }
}

LibcAtExitEnd {
 action  { ADD_SYMBOL("__stop___libc_atexit") }
 trigger { SUBSECTION_EXISTS("Linker","VECTOR_____libc_atexit") }
 symbol  { END_OF_SUBSECTION("Linker","VECTOR_____libc_atexit") }
}

SECTIONS
{
  /* Read-only sections, merged into text segment: */
  . = 0x0400000 + SIZEOF_HEADERS;
  .interp         : { *(.interp) }
  .reginfo        : { *(.reginfo) }
  .dynamic        : { *(.dynamic) }
  .hash           : { *(.hash) }
  .dynsym         : { *(.dynsym) }
  .dynstr         : { *(.dynstr) }
  .gnu.version    : { *(.gnu.version) }
  .gnu.version_d  : { *(.gnu.version_d) }
  .gnu.version_r  : { *(.gnu.version_r) }
  .rel.dyn        :
    {
      *(.rel.init)
      *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
      *(.rel.fini)
      *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)
      *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)
      *(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*)
      *(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*)
      *(.rel.ctors)
      *(.rel.dtors)
      *(.rel.got)
      *(.rel.sdata .rel.sdata.* .rel.gnu.linkonce.s.*)
      *(.rel.sbss .rel.sbss.* .rel.gnu.linkonce.sb.*)
      *(.rel.sdata2 .rel.sdata2.* .rel.gnu.linkonce.s2.*)
      *(.rel.sbss2 .rel.sbss2.* .rel.gnu.linkonce.sb2.*)
      *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)
    }
  .rela.dyn       :
    {
      *(.rela.init)
      *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
      *(.rela.fini)
      *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
      *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
      *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
      *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
      *(.rela.ctors)
      *(.rela.dtors)
      *(.rela.got)
      *(.rela.sdata .rela.sdata.* .rela.gnu.linkonce.s.*)
      *(.rela.sbss .rela.sbss.* .rela.gnu.linkonce.sb.*)
      *(.rela.sdata2 .rela.sdata2.* .rela.gnu.linkonce.s2.*)
      *(.rela.sbss2 .rela.sbss2.* .rela.gnu.linkonce.sb2.*)
      *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
    }
  .rel.plt        : { *(.rel.plt) }
  .rela.plt       : { *(.rela.plt) }

  .init           :
  {
    KEEP (*(.init))
  } =0
  .plt            : { *(.plt) }
  .text           :
  {
    _ftext = . ;
    *(.text .stub .text.* .gnu.linkonce.t.*)
    /* .gnu.warning sections are handled specially by elf32.em.  */
    *(.gnu.warning)
    *(.mips16.fn.*) *(.mips16.call.*)
  } =0
  .fini           :
  {
    KEEP (*(.fini))
  } =0
  .merged_code : {}
  PUT_REMAINING_SECTIONS(CODE_SECTION);
  PROVIDE (__etext = .);
  PROVIDE (_etext = .);
  PROVIDE (etext = .);
  .rodata         : { *(.rodata .rodata.* .gnu.linkonce.r.*) }
  .rodata1        : { *(.rodata1) }
  PUT_REMAINING_SECTIONS(RO_DATA_SECTION);
  .sdata2         : { *(.sdata2 .sdata2.* .gnu.linkonce.s2.*) }
  .sbss2          : { *(.sbss2 .sbss2.* .gnu.linkonce.sb2.*) }
  .eh_frame_hdr : { *(.eh_frame_hdr) }
  /* Adjust the address for the data segment.  We want to adjust up to
     the same address within the page on the next page up.  */
  . = 0x10000000;
  /* Ensure the __preinit_array_start label is properly aligned.  We
     could instead move the label definition inside the section, but
     the linker would then create the section even if it turns out to
     be empty, which isn't pretty.  */
  . = ALIGN(32 / 8);
  PROVIDE (__preinit_array_start = .);
  .preinit_array     : { *(.preinit_array) }
  PROVIDE (__preinit_array_end = .);
  PROVIDE (__init_array_start = .);
  .init_array     : { *(.init_array) }
  PROVIDE (__init_array_end = .);
  PROVIDE (__fini_array_start = .);
  .fini_array     : { *(.fini_array) }
  PROVIDE (__fini_array_end = .);
  .data           :
  {
    _fdata = . ;
    *(.data .data.* .gnu.linkonce.d.*)
    SORT(CONSTRUCTORS)
  }
  .data1          : { *(.data1) }
  .tdata	  : { *(.tdata .tdata.* .gnu.linkonce.td.*) }
  .tbss		  : { *(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon) }
  .eh_frame       : { KEEP (*(.eh_frame)) }
  .gcc_except_table   : { *(.gcc_except_table) }
  .ctors          :
  {
    /* gcc uses crtbegin.o to find the start of
       the constructors, so we make sure it is
       first.  Because this is a wildcard, it
       doesn't matter if the user does not
       actually link against crtbegin.o; the
       linker won't look for a file to match a
       wildcard.  The wildcard also means that it
       doesn't matter which directory crtbegin.o
       is in.  */
    KEEP (*crtbegin.o(.ctors))
    /* We don't want to include the .ctor section from
       from the crtend.o file until after the sorted ctors.
       The .ctor section from the crtend file contains the
       end of ctors marker and it must be last */
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  }
  .dtors          :
  {
    KEEP (*crtbegin.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  }
  .jcr            : { KEEP (*(.jcr)) }
  _gp = ALIGN(16) + 0x7ff0;
  .got            : { *(.got.plt) *(.got) }
  /* We want the small data sections together, so single-instruction offsets
     can access them all, and initialized data all before uninitialized, so
     we can shorten the on-disk segment size.  */
  .sdata          :
  {
    *(.sdata .sdata.* .gnu.linkonce.s.*)
  }
  .lit8           : { *(.lit8) }
  .lit4           : { *(.lit4) }
  PUT_REMAINING_SECTIONS(DATA_SECTION);
  _edata = .;
  PROVIDE (edata = .);
  __bss_start = .;
  _fbss = .;
  .sbss           :
  {
    PROVIDE (__sbss_start = .);
    PROVIDE (___sbss_start = .);
    *(.dynsbss)
    *(.sbss .sbss.* .gnu.linkonce.sb.*)
    *(.scommon)
    PROVIDE (__sbss_end = .);
    PROVIDE (___sbss_end = .);
  }
  .bss            :
  {
   *(.dynbss)
   *(.bss .bss.* .gnu.linkonce.b.*)
   *(COMMON)
   /* Align here to ensure that the .bss section occupies space up to
      _end.  Align after .bss to ensure correct alignment even if the
      .bss section disappears because there are no input sections.  */
   . = ALIGN(32 / 8);
  }
  PUT_REMAINING_SECTIONS(BSS_SECTION);
  . = ALIGN(32 / 8);
  _end = .;
  PROVIDE (end = .);
  /* Stabs debugging sections.  */
  .stab          0 : { *(.stab) }
  .stabstr       0 : { *(.stabstr) }
  .stab.excl     0 : { *(.stab.excl) }
  .stab.exclstr  0 : { *(.stab.exclstr) }
  .stab.index    0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment       0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  /* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }
  .gptab.sdata : { *(.gptab.data) *(.gptab.sdata) }
  .gptab.sbss : { *(.gptab.bss) *(.gptab.sbss) }
}

