/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/utils/util_clientserver.h,v 1.1.1.1 2003/10/10 12:12:23 bdebus Exp $ */
#ifndef CLIENTSERVER_H
#define CLIENTSERVER_H
#define CLIENT 'C'
#define SERVER 'S'
#define ACCEPTED_SERVER 'A'
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "../simple_types.h"

/*! Describes a connection */
typedef struct _connection_decriptor
{
    char type;
    struct sockaddr_in sa_in;
    struct hostent *hp;
    int socket_descriptor;
    int max_connections;
    int addrlen;
} connection_descriptor;

connection_descriptor * NewConnectionDescriptor();
connection_descriptor * CreateClient(char * host, int port);
connection_descriptor * CreateServer(int port, int max_con);
void WaitOnceForConnection(connection_descriptor * in, void (*CallBack)(connection_descriptor *));
void WaitForConnections(connection_descriptor * in, void (*CallBack)(connection_descriptor *));
int ConnectionGet(connection_descriptor * in,char * data, t_uint32 max_len,long to);
int ConnectionSend(connection_descriptor * in,char * data,t_uint32 size);
void ConnectionEnd(connection_descriptor * in);
#endif
