/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/utils/util_color.h,v 1.1.1.1 2003/10/10 12:12:23 bdebus Exp $ 
 * 
 * This files contains the functiondeclaraitions for function  to do 
 * colored output on a terminal
 * 
 * Documentation: Complete
 * 
 */

#ifndef MY_COLOR_H
#define MY_COLOR_H
#include "../config.h"

#ifndef COLORS
/* If COLORS is not defined we should never include colors.h! */
#error "Including colors!"
#endif

/* The different effects  */

typedef enum _bold
{
   normal,
   bold
} effect;

/* The possible output colors, leave this alone, order is important! */

typedef enum _colors
{
   black,
   red,
   green,
   yellow,
   blue,
   magenta,
   cyan,
   white
} color;

/* Function: ColorPrint(<effect> e,<color> fg, <color> bg>, <char *> arg, ...);
 *
 * Desc: Prints a string in a certain color and effect
 *
 * arguments: effect  e: either bold or normal
 *            color  fg: the foreground color: see the color enum; 
 *            color  bg: the background color: see the color enum; 
 *            char *arg: a format string 
 *            ...      : the arguments for the format string (see printf) 
 */

void ColorPrint(effect e,color fg, color bg,  char * arg, ...);


/* Function: ColorFPrint(<effect> e,<color> fg, <color> bg>, <FILE *> file, <char *> arg, ...);
 *
 * Desc: Prints a string in a certain color and effect to a certain STREAM
 *
 * arguments: see ColorPrint + <FILE *>  file: the outpt STREAM 
 */

int ColorFPrint(effect e,color fg, color bg, int curspos, int indent,FILE * fp,  char * arg, ...);
#endif
