/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef MY_ENDIAN_H
#define MY_ENDIAN_H
#include "../simple_types.h"
#define UINT16_SWAP_ENDIAN(val)   ((t_uint16) ((((t_uint16) (val)&(t_uint16) 0xffU)<<8) | (((t_uint16) (val)&(t_uint16) 0xff00U)>>8)))
#define UINT32_SWAP_ENDIAN(val)   ((t_uint32) ((((t_uint32) (val)&(t_uint32) 0xffU)<<24)|(((t_uint32) (val)&(t_uint32) 0xff00U)<<8)|(((t_uint32) (val)&(t_uint32) 0xff0000U)>>8)|(((t_uint32) (val)&(t_uint32) 0xff000000U)>>24)))
#define UINT64_SWAP_ENDIAN(val)   ((t_uint64) ((((t_uint64) (val)&(t_uint64) ULL(0xff))<<56)|(((t_uint64) (val)&(t_uint64) ULL(0xff00))<<40)|(((t_uint64) (val)&(t_uint64) ULL(0xff0000))<<24)|(((t_uint64) (val)&(t_uint64) ULL(0xff000000))<<8)|(((t_uint64) (val)&(t_uint64) ULL(0xff00000000))>>8)|(((t_uint64) (val)&(t_uint64) ULL(0xff0000000000))>>24)|(((t_uint64) (val)&(t_uint64) ULL(0xff000000000000))>>40)|(((t_uint64) (val)&(t_uint64) ULL(0xff00000000000000))>>56)))
#endif
