/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef MY_FILE_H
#define MY_FILE_H
#include "../simple_types.h"
#include "../datastructures/data_string.h"
#include <stdio.h>
typedef struct
{
   t_uint32 nelems;
   t_string * dirs;
} t_path;

t_path * ParsePath(t_string path, t_string delim);
t_string FindFile(t_path * path, t_string name);
void PathFree(t_path *);
void PathInit(void);
void PathFini(void);
void DirectoryAssure(const t_string path,t_bool tmp);
t_string RealGetLine(char * file, int lnno, FILE *ifp);
#define GetLine(ifp) RealGetLine(__FILE__,__LINE__,ifp)
t_string ConvertFileName(t_string filename);
void Untar(t_string tar);
void DirToTar(t_string dir, t_string tar);
void RmdirR(t_string dir);
void SmartCopy(t_string from, t_string to);
t_bool FileExists(t_string name);
char * Basename(char * in);
#endif
