/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <stdio.h>
#include "../config.h"
#include "util_machine.h"
#include "util_selfmod_code.h"

/* GLOBAL VARIABLES */

my_machineinfo global_machine_info;

/* STATIC FUNCTIONS */

static my_byteorder MachineEndianness(void)
{
   int x = 1;
   if (x == *((char*)&x)) return LSB;
   return MSB;
}

/* EXPORTED FUCNTIONS */

void MachineInit()
{
   global_machine_info.endian=MachineEndianness();
}

t_bool MachineIsAlphaOrIntel()
{
   unsigned char * c=CreateExecutableSpace(12);
   int (*a)(void)=(int (*)(void))c;
   /* Some black magic ! 
    *-------------------
    * Note to myself:
    *
    * Line 1:
    * 0xeb 0x06 Is intel relative jump + 6
    * 0xeb 0x06 0x1f 0x24 is alpha ldah v0, ...
    * Line 2:
    * an alpha return 
    * Line 3:
    * an intel xor %eax, %eax 
    * an intel ret
    * an intel nop
    * 
    */
   c[0]=0xeb; c[1]=0x06; c[2]=0x1f; c[3]=0x24;
   c[4]=0x01; c[5]=0x80; c[6]=0xfa; c[7]=0x6b;
   c[8]=0x31; c[9]=0xc0; c[10]=0xc3; c[11]=0x90;
   return (a())?TRUE:FALSE;
}
