/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/utils/util_malloc.h,v 1.1.1.1 2003/10/10 12:12:23 bdebus Exp $ */
#ifndef MY_MALLOC_H
#define MY_MALLOC_H
#include "../simple_types.h"
#include <stdlib.h>
#ifdef DEBUG_MALLOC
#define Malloc(x) RealMalloc(__FILE__,__LINE__,x)
#define Calloc(x,y) RealCalloc(__FILE__,__LINE__,x,y)
#define Free(x) RealFree(__FILE__,__LINE__,x)
#define Realloc(x,y) RealRealloc(__FILE__,__LINE__,x,y)
#define CheckAddress(x) RealCheckAddress(__FILE__,__LINE__,x)
#else
#define Malloc(x) RealMalloc(x)
#define Calloc(x,y) RealCalloc(x,y)
#define Free(x) RealFree(x)
#define Realloc(x,y) RealRealloc(x,y)
#define CheckAddress(x) while(0)
#endif
#ifdef DEBUG_MALLOC
void * RealMalloc(char * file, t_uint32 lnno,  t_uint32 size);
void * RealCalloc(char * file, t_uint32 lnno,  t_uint32 numelems, t_uint32 elemsize);
void RealFree(char * file, t_uint32 lnno, void *);
void * RealRealloc(char * file, t_uint32 lnno, void * base,t_uint32 size);
void PrintRemainingBlocks(void);
void RealCheckAddress(char * file,t_uint32 line, void * x);
#else
void * RealMalloc(t_uint32 size);
void * RealCalloc(t_uint32 numelems, t_uint32 elemsize);
void RealFree(void *);
void * RealRealloc(void * base,int size);
#endif
#endif
