/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef OPTIONS_H
#define OPTIONS_H

#include "utils.h"

#ifndef NO_UTILS
#include "util_file.h"
#include "../config.h"
#include "util_error.h"
#include "util_malloc.h"
#endif



typedef enum
{
   OPTION_BOOL,
   OPTION_COUNT,
   OPTION_INT,
   OPTION_STRING,
   OPTION_PATH,
   OPTION_USAGE,
   OPTION_FILE,
   OPTION_NONE
} t_option_type;
 
typedef struct _t_option
{
   t_bool required;
   t_bool hidden;
   char * group;
   char * short_option;
   char * long_option;
   char * enviromental_option;
   t_option_type type;
   t_bool * set;
   void ** variable;

   union
   {
      char * default_string;
      t_bool default_bool;
      t_uint32 default_count;
   } defaults;
   char * description;
} t_option;


void OptionsDefaults(void);
void OptionsInit(void);
void OptionsFini(void);
void Usage(void);

void OptionsParseCommandLine(t_uint32 argc, char ** argv);
void OptionsGetEnvironment();

#endif
