/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "../config.h"
#ifdef HAVE_UNISTD
#include <unistd.h>
#endif
#include <stdlib.h>
#ifdef HAVE_MMAN
#include <sys/mman.h>
#include <sys/types.h>
#endif
#include "util_error.h"
#include "util_selfmod_code.h"
unsigned char * CreateExecutableSpace(long size)
{
#ifdef HAVE_MMAN
   long ps=sysconf(_SC_PAGE_SIZE);
#endif
   unsigned char * exec_room; 
#ifdef HAVE_MMAN
   long paged_size=((size/ps)+2)*ps;
#else
   long paged_size=size;
#endif
   /* Ok, there if there ever was a place where you wanted the real
    * malloc it's probably here */
   exec_room=(unsigned char *) malloc(paged_size);
#ifdef HAVE_MMAN
   exec_room=(unsigned char *) (((((long) exec_room)/ps)+1)*ps);
   if( mprotect( exec_room, paged_size, PROT_READ | PROT_WRITE |  PROT_EXEC) )
      FATAL(("Could not create executable space !"));
#endif
   return exec_room;
}


