#ifndef UTILS_H
#define UTILS_H

#ifdef NO_DEPENDENCIES
#define NO_UTILS
#define NO_DATASTRUCTURES
#define NO_DIABLO_KERNEL
#define NO_CONFIG
#define NO_TYPES
#endif

#ifdef NO_DIABLO_KERNEL
#define DiabloPrint fprintf
#endif

#ifdef NO_UTILS
/* Term stuff */
#define TermPrintClean(file,string,pos,indent,mode) fprintf(file,"%s%s",string,mode?"\n":"")
#define TermTitle fprintf 
#define TermFillLine(x) 
#define FINAL 1
/* Error stuff */
#define FATAL(x) { printf(x); exit(0); }
#define FATAL_USAGE(x) { printf(x); Usage(); exit(0); }
/* Malloc Stuff */
#define Free free 
/* ??? */
#define PrintExecName(x) printf("program ");
#endif

#ifdef NO_DATASTRUCTURES
#define StringDup strdup 
#endif

#ifdef NO_CONFIG
#endif

#ifdef NO_TYPES
#define FALSE 0
#define TRUE 1
#define t_bool int
#define t_uint32 int
#define t_string char *
#endif

#endif
